local rPunchHitEffect =
{
    sEffectPath = 'Effects/Impact.lua',
    offSetRange = { x = { -16, 16 }, y = { 76, 80 } },
    scaleRange = { 0.25, 0.75 },
}
local rRayGunHitEffect =
{
    sEffectPath = 'Effects/ImpactRaygun.lua',
    offSetRange = { x = { -16, 16 }, y = { 60, 70 } },
    scaleRange = { 0.75, 1 },
}
local rFireImpactEffect =
{
    sEffectPath = 'Effects/ImpactFire.lua',
    offSetRange = { x = { -16, 16 }, y = { 60, 70 } },
    scaleRange = { 0.75, 1 },
}
local rRocketPunchImpactEffect =
{
    sEffectPath = 'Effects/Explosion.lua',
    offSetRange = { x = { 40, 60 }, y = { 10, 10 } },
    scaleRange = { 1.5, 2 },
}
local rAlienLaserHitEffect =
{
    sEffectPath = 'Effects/ImpactAlienLaser.lua',
    offSetRange = { x = { -16, 16 }, y = { 60, 70 } },
    scaleRange = { 1, 1 },
}
local rAlienBossLaserHitEffect =
{
    sEffectPath = 'Effects/ImpactAlienBossLaser.lua',
    offSetRange = { x = { -6, 16 }, y = { 70, 80 } },
    scaleRange = { 3, 3 },
}
local rLoveHitEffect =
{
    sEffectPath = 'Effects/ImpactLove.lua',
    offSetRange = { x = { -16, 16 }, y = { 60, 70 } },
    scaleRange = { 1, 1 },
}
return {
    -- henchman
    thugpunch = { 
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "punch",
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25, 
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/ThugWoodHit',
        rHitEffectDef = rPunchHitEffect,
    },
    thugbigswing = { 
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch",
        nDamageAmount = 2, -- multiplied by POW
        sAnimName = "big_swing",
        bIsUnlocked = true,
        bIsDefault = false,
        nCooldownTurns = 4,
        nDamageDelay = 1,                    
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/ThugWoodCrit',
        rHitEffectDef =
        {
            sEffectPath = 'Effects/Impact.lua',
            offSetRange = { x = { -30, 30 }, y = { 40, 40 } },
            scaleRange = { 1.5, 1.5 },
        },
    },
    henchmanpunch = { 
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "punch",
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25,
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/HeroPunch',        
        rHitEffectDef = rPunchHitEffect,
    },
    henchmanbigpunch = { 
        sAbilityType = "AbilityDamage",
        sAbilityName = "big_punch",
        nDamageAmount = 2, -- multiplied by POW
        sAnimName = "big_punch",
        bIsUnlocked = true,
        bIsDefault = false,
        nDamageDelay = 1,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/ThugBatCrit',        
        rHitEffectDef = rPunchHitEffect,
    },
    henchmanraygun = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "fireraygun",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "range_attack",
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/Enemy_Ranged_Attack',
        rHitEffectDef = rRayGunHitEffect,
    },
    henchmanspecialraygun = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "special_attack",
        nDamageAmount = 2, -- multiplied by POW
        sAnimName = "special_attack",
        bIsUnlocked = true,
        bIsDefault = false,
        nDamageDelay = 1,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/Enemy_Ranged_BigAttack',
        rHitEffectDef = rRayGunHitEffect,
    },
    alienpunch = { 
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "punch",
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25,
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/HeroPunch',        
        rHitEffectDef = rPunchHitEffect,
    },
    alienpunch2 = { 
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch2",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "punch",
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25,
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/HeroPunch',        
        rHitEffectDef = rPunchHitEffect,
    },
    alienlaser = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "fireraygun",
        nDamageAmount = 3, -- multiplied by POW
        sAnimName = "fire",
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/Alien_Laser',
        rHitEffectDef = rAlienLaserHitEffect,
    },
    alienBossLaser = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "fireraygun",
        nDamageAmount = 3, -- multiplied by POW
        sAnimName = "fire",
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/AlienBoss_SpecialAttack',
        rHitEffectDef = rAlienBossLaserHitEffect,
    },
    smallloveblast = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "smallloveblast",
        nDamageAmount = 0, -- multiplied by POW       
        bIsUnlocked = true,
        bIsDefault = false,
        nDamageDelay = 0.25,
        nCooldownTurns = 3,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/LoveGun',
        rHitEffectDef = rLoveHitEffect,
        sEffectToTrigger = 'Effects/LoveBlast.lua',
        bAttachEffect = true,
        nEffectXScale = 1,
        nEffectYScale = 1,
        nEffectXOffset = -140,
        nEffectYOffset = 90,
        tBuffs = 
        {
            {
                sBuffType = "PowerBuff",
                nAmount = -5,
                nTurnDuration = 1,
                sSpriteSheetName = 'FX/FX_5',
                sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                sSpriteAnimName = 'lovebuff',
                nSpriteOffsetX = 0.0,
                nSpriteOffsetY = 50.0,
                nScale = 2,
            },
        },
    },
    largeloveblast = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "largeloveblast",
        nDamageAmount = 0, -- multiplied by POW       
        bIsUnlocked = true,
        bIsDefault = false,
        nDamageDelay = 0.25,
        nCooldownTurns = 3,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/LoveGun',
        rHitEffectDef = rLoveHitEffect,
        sEffectToTrigger = 'Effects/BigLoveBlast.lua',
        bAttachEffect = true,
        nEffectXScale = 2,
        nEffectYScale = 2,
        nEffectXOffset = -200,
        nEffectYOffset = 160,
        bAffectAll = true,
        tBuffs = 
        {
            {
                sBuffType = "PowerBuff",
                nAmount = -10,
                nTurnDuration = 1,
                sSpriteSheetName = 'FX/FX_5',
                sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                sSpriteAnimName = 'lovebuff',
                nSpriteOffsetX = 0.0,
                nSpriteOffsetY = 50.0,
                nScale = 2,
            },
        },
    },
    donothing = {
        sAbilityType = "AbilityDamage",
        nDamageAmount = 0, -- multiplied by POW       
        bIsDefault = true, 
        bDontGoToFightPose = true,       
    },
    -- stances
    --[[
    cyclestance = {
        sAbilityType = "AbilityCycleStance",
        sAbilityName = "cyclestance",
        bIsUnlocked = true,
        bIsDefault = false,
        bInstant = true,
        --sCueName = 'MMOJ_Audio/SFX/HeroSFX/HeroPunch',        
    },
    ]]--
    -- heroes
    male01punch = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "punch",
		tAnimNames = { "punch", "punch2", "punch3", }, 
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25, 
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/HeroPunch',        
        rHitEffectDef = rPunchHitEffect,
    },
    male01laser = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL002TEXT",
        sDescription = "ABDS001TEXT",
        sAnimName = "attack_lasers",
        bIsDefault = false,
        bIsUnlocked = true,
        tTrainTime = { 0, 300, 600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/MaleLaser',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_rapidlasers',
        rHitEffectDef = rRayGunHitEffect,

        bAffectAll=false,
    },
    male01slam = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL001TEXT",
        sDescription = "ABDS002TEXT",
        sAnimName = "attack_buttslam",
        bIsDefault = false,
        nDamageDelay = 0.75,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/Buttslam',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_buttstomp',
        bAffectAll = false,

        tBuffs = 
        {
            {
                sBuffType = "StunBuff",
                --nTurnDuration = 2,
                sAnimName = "stun",
                
                sSpriteSheetName = 'FX/FX_5',
                sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                sSpriteAnimName = 'stunstars',
                nSpriteOffsetX = 80.0,
                nSpriteOffsetY = 110.0,
                nScale = 2.5,
            },
        },
    },
    male01throw = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL003TEXT",
        sDescription = "ABDS003TEXT",
        sAnimName = "attack_throw",
        bIsDefault = false,
        nDamageDelay = 2.0,
        bAffectAll = true,
        tTrainTime = { 900, 1800, 3600 },
        sIconSheet = 'UI/icons',
        sIconName = 'ability_throwboulder',
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/MaleThrow',
        sCustomThreadName = 'male01Throw',
    },
    mummybandage = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL004TEXT",
        sDescription = "ABDS004TEXT",
        sAnimName = "throw_bandage",
        bIsDefault = false,
        bIsUnlocked = true,
        bIsRanged = true,
        tTrainTime = { 0, 300, 600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/BandageToss',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_throwbandages',
        rProjectileDef =
        {
            sSpriteSheetName = 'FX/FX_2',
            sAnimDefName = 'Characters/AnimDefs/FX_2.lua',
            sSpriteAnimName = 'mummy_bandages',
            --nSpriteRot = 90,
            nSpeed = 400,
            nSpawnDelay = 0.8,
            nSourceOffsetX = 40,
            nSourceOffsetY = 80,
            nTargetOffsetX = 0,
            nTargetOffsetY = 80,      
            nScaleRange = { 0.75, 1 },
        },
        tBuffs = 
        {
                {
                    sBuffType = "StunBuff",
                    nTurnDuration = 2,
                    sAnimName = "stun",
                    sSpriteSheetName = 'FX/FX_4',
                    sAnimDefName = 'Characters/AnimDefs/FX_2.lua',
                    sSpriteAnimName = 'mummy_cocoon',
                    nSpriteOffsetX = 20.0,
                    nSpriteOffsetY = 0.0,
                    sAlignX = 'center',
                    sAlignY = 'bottom',                  
                    bHideChar = true,
                },
        },
    },
    mummycurse = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL005TEXT",
        sDescription = "ABDS005TEXT",        
        sAnimName = "mummy_curse",
        bIsDefault = false,
        bIsRanged = true,
        nDamageDelay = 0.6,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MummyCurse',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_mummycurse',
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/MummyCurse',
        tBuffs = 
        {
            {
                bScaleByAbilityPower=true,
                sBuffType = "PowerBuff",
                nTurnDuration = 3,                 
                nAmount = -1,
                multBy="nAwareness",
                
                sSpriteSheetName = 'FX/FX_5',
                sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                sSpriteAnimName = 'mummycurse',
                nSpriteOffsetX = 20.0,
                nSpriteOffsetY = 110.0,
                nScale = 2.5, 
            },
        },
    },
    mummyfist = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL006TEXT",
        sDescription = "ABDS007TEXT",
        sAnimName = "mummy_fist",
        bIsDefault = false,
        bIsRanged = true,
        bAffectAll = true,
        nDamageDelay = 3,
        tTrainTime = { 900, 1800, 3600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/MummyGroundFist',
        sCustomThreadName = 'mummyHand',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_mummyfist',
    },
    male01crallycry = {
        sAbilityType = "Ability",
        sAbilityName = "ABIL007TEXT",
        sDescription = "ABDS008TEXT",
        sAnimName = 'rally_cry',
        bIsDefault = false,
        bIsUnlocked = true,
        bAffectAllFriendly = true,
        tTrainTime = { 0, 300, 600 },
        sIconSheet = 'UI/icons',
        sIconName = 'ability_rallycry',
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/RallyCry',
        tBuffs = 
        {
            {
                bScaleByAbilityPower=true,
                sBuffType = "PowerBuff",
                tAmounts={
                    { nAmount="nAwareness", multBy=.4 },
                    { nAmount="nPower", multBy=.4 },
                },
                
                sSpriteSheetName = 'FX/FX_5',
                sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                sSpriteAnimName = 'rallycrybuff',
                nSpriteOffsetX = 0.0,
                nSpriteOffsetY = 100.0,
                nScale = 2.5, 
            },
        },
    },
    male01cslam = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL008TEXT",
        sDescription = "ABDS009TEXT",
        sAnimName = "attack_slam",
        bIsDefault = false,
        bAffectAll = true,
        nDamageDelay = 1.75,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/FistSlam',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_groundstomp',
        nScreenShakeMag = 10,
        nScreenShakeDelay = 1.5,

        tBuffs = 
        {
            {
                bScaleByAbilityPower=true,
                sBuffType = "PowerBuff",
                nTurnDuration = 3,                 
                nAmount = -.5,
                multBy="nAwareness",
            },
        },
    },
    
    male01cflyslam = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL009TEXT",
        sDescription = "ABDS010TEXT",
        bIsDefault = false,
        bAffectAll = true,
        nDamageDelay = 2,       
        tTrainTime = { 900, 1800, 3600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/FlyAttackSlam',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_flyingslam',
        sCustomThreadName = 'veteranFlySlam',
    },
    
    --cosmic crowbar
        male01dpunch = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "punch",
		tAnimNames = { "punch", "punch2", "punch3", }, 
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25, 
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/HeroPunch',        
        rHitEffectDef = rPunchHitEffect,
    },
    
    male01dcrowbar = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL026TEXT",
        sDescription = "ABDS026TEXT",
        sAnimName = "crowbarsmash",
        bAffectAll = false,
        bIsUnlocked = true,
        nDamageDelay = 0.67,       
        tTrainTime = { 0, 300, 600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/CC_CrowbarSwing',
        sIconName = 'ability_crowbar',
        sIconSheet = 'UI/icons',
		rHitEffectDef =
        {
            sEffectPath = 'Effects/CrowbarSmash.lua',
            offSetRange = { x = { -20, 10 }, y = { 60, 70 } },
            scaleRange = { 2, 2 },
        },
    },
    
    male01dripportal = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL027TEXT",
        sDescription = "ABDS027TEXT",
        sAnimName = "rip_portal",
        bAffectAll = true,
        bIsDefault = false,
        nDamageDelay = 2,   
        tTrainTime = { 900, 1800, 3600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/CC_PortalRip',
        sIconName = 'ability_ripportal',
        sCustomThreadName = 'crowbarportal',
        sIconSheet = 'UI/icons',

        tBuffs = 
        {
            {
                bScaleByAbilityPower=false,
                sBuffType = "DamageBuff",
                nTurnDuration = 3,                 
                nAmount = 1,
                multBy="nAwareness",
                
                sSpriteSheetName = 'FX/FX_5',
                sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                sSpriteAnimName = 'portaldamage',
                nSpriteOffsetX = 0.0,
                nSpriteOffsetY = 50.0,
                nScale = 2, 
            },
        },
    },
    
    male01dboomerang = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL028TEXT",
        sDescription = "ABDS028TEXT",
        bIsDefault = false,
        bAffectAll = true,
        nDamageDelay = 2, 
        nPostAnimDelay = 0.5,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/CC_Boomerang',
        sIconName = 'ability_boomerang',
        sCustomThreadName = 'crowbarboomerang',
        sIconSheet = 'UI/icons',
    },
    
    --Gloomerang
    female02bpunch = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "punch",
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25, 
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/HeroPunch',        
        rHitEffectDef = rPunchHitEffect,
    },
    
    female02bgloomerang = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL033TEXT",
        sDescription = "ABIL034TEXT",
        bIsUnlocked = true,
        bIsDefault = false,
        bAffectAll = true,
        nDamageDelay = 1, 
        bDontGoToFightPose = true,
        nPostAnimDelay = 0.5,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/Gloom_Gloomerang',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_gloomerang',
        sCustomThreadName = 'gloomerang',
        sIconSheet = 'UI/icons',
    },
    female02bfocusrefresh = {
        sAbilityType = "Ability",
        sAbilityName = "ABIL035TEXT",
        sDescription = "ABIL036TEXT",
        sAnimName = 'focus_refresh',
        bIsDefault = false,
        bAffectAllFriendly = true,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/Gloom_Focus',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_refreshfocus',
        sCustomThreadName = 'focusrefesh',
        sIconSheet = 'UI/icons',
        tBuffs = 
        {
            {
                sBuffType = "ManaBuff",
                bScaleByAbilityPower = true,
                nAmount=7,
                multBy="nAwareness",
                nTurnDuration = 1,    
    
                sSpriteSheetName = 'FX/FX_4',
                sAnimDefName = 'Characters/AnimDefs/FX_2.lua',
                sSpriteAnimName = 'gloomerangfocusheal',
                nSpriteOffsetX = 10.0,
                nSpriteOffsetY = 80.0,
                nScale = 2.5,
            },
        },
    },
    female02bshadowdebuff = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL037TEXT",
        sDescription = "ABIL038TEXT",
        sAnimName = 'shadow_debuff',
        bIsDefault = false,
        bAffectAll = true,
        nDamageDelay = 1,
        nPostAnimDelay = 0.5,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/Gloom_Shade',
        sIconName = 'ability_castshadow',
        sIconSheet = 'UI/icons',
        tBuffs = 
        {
            {
                bScaleByAbilityPower=true,
                sBuffType = "PowerBuff",
                nTurnDuration = 3,                 
                nAmount = -1,
                multBy="nAwareness",
                
                sSpriteSheetName = 'FX/FX_4',
                sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                sSpriteAnimName = 'gloomerangshadowcast',
                nSpriteOffsetX = 0.0,
                nSpriteOffsetY = 200.0,
                nScale = 1.5, 
            },
        },
    },
    
    male02fireballs = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "FIREBALL",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "range_attack",
        bIsDefault = true,
        bIsUnlocked = true,
        bIsRanged = true,
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/Male02_ThrowFireballs',
        rProjectileDef =
        {
            sSpriteSheetName = 'FX/FX',
            sAnimDefName = 'Characters/AnimDefs/FX.lua',
            sSpriteAnimName = 'fireball',
            --nSpriteRot = 90,
            nSpeed = 400,
            nSpawnDelay = 0.25,
            nSourceOffsetX = 40,
            nSourceOffsetY = 60,
            nTargetOffsetX = 0,
            nTargetOffsetY = 50,      
            nScaleRange = { 0.75, 0.75 },
        },
        rHitEffectDef = rFireImpactEffect,
    },
    male02headbutt = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL012TEXT",
        sDescription = "ABDS012TEXT",
        sAnimName = "headbutt",
        bIsDefault = false,
        bIsUnlocked = false,
        bMoveToTarget = true,
        nMoveDuration = 0.2,
        nDamageDelay = 0.4,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/FireHeadbut',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_headbutt',
        rHitEffectDef = rFireImpactEffect,
        tBuffs =
        {
            {
                sBuffType = "StunBuff",
                nTurnDuration = 1,            
                sAnimName = "stun",
            },
        },
    },
    male02rage = {
        sAbilityType = "Ability",
        sAbilityName = "ABIL011TEXT",
        sDescription = "ABDS011TEXT",
        bIsDefault = false,
        bIsUnlocked = true,
        nPostAnimDelay = 1.5,
        tTrainTime = { 120, 480, 900 },
        sIconSheet = 'UI/icons',
        sIconName = 'ability_flamehead',
        sCustomThreadName = 'rageRallyCry',
        tBuffs = 
        {
            {
                bScaleByAbilityPower=true,
                sBuffType = "PowerBuff",
                tAmounts={
                    { nAmount="nAwareness", multBy=.75 },
                    { nAmount="nPower", multBy=.75 },
                },
                nTurnDuration = 3,    
                
                sSpriteSheetName = 'FX/FX_5',
                sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                sSpriteAnimName = 'hotheadflaminglips',
                nSpriteOffsetX = 30.0,
                nSpriteOffsetY = 80.0,
                nScale = 2.5, 
            },
        },
    },
    male02blast = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL010TEXT",
        sDescription = "ABDS013TEXT",
        sAnimName = "special_attack",
        bIsDefault = false,
        bIsUnlocked = false,
        bAffectAll = true,
        tTrainTime = { 900, 1800, 3600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/ChargeFireball',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_bigfireballthrow',
        rProjectileDef =
        {
            sSpriteSheetName = 'FX/FX',
            sAnimDefName = 'Characters/AnimDefs/FX.lua',
            sSpriteAnimName = 'fireball',
            nSpeed = 400,
            nSpawnDelay = 0.75,
            nSourceOffsetX = 0,
            nSourceOffsetY = 20,
            nTargetOffsetX = 0,
            nTargetOffsetY = 20,
            nScaleRange = { 3, 3 },
        },
        rHitEffectDef = rFireImpactEffect,
    },
    male02bchestbeams = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL013TEXT",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "range_attack",
        bIsDefault = true,
        bIsRanged = true,
        bIsUnlocked = true,
        nDamageDelay = 0.25, 
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/Cyborg_ChestBeam',
        rHitEffectDef = rRayGunHitEffect,
    },
    male02beyebeams = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL015TEXT",
        sDescription = "ABDS015TEXT",
        sAnimName = "eye_blast",
        bIsDefault = false,
        bIsUnlocked = true,
        bIsRanged = true,
        nDamageDelay = 1.5, 
        tTrainTime = { 0, 300, 600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/EyeBeam',
        sIconName = 'ability_chestbeams',
        sIconSheet = 'UI/icons',
        rHitEffectDef = rRayGunHitEffect,
        sCustomThreadName = 'techEyeBlast',
    },
    male02bshield = {
        sAbilityType = "Ability",
        sAbilityName = "ABIL014TEXT",
        sDescription = "ABDS014TEXT",
        sAnimName = 'shield',
        bIsDefault = false,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/ShieldButton',
        sCustomThreadName = 'techShield',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_personalshield',
        tBuffs = 
        {
            {
                sBuffType = "ShieldBuff",
                bScaleByAbilityPower=true,
                tAmounts=
                {
                    { nAmount=5, },
                    { nAmount=1, multBy="nAwareness" },
                },
                nTurnDuration = 3,
            },
        },
    },
    male02borbital = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL016TEXT",
        sDescription = "ABDS016TEXT",
        sAnimName = "orbital",
        bIsDefault = false,
        bIsRanged = true,
        bAffectAll = true,
        nDamageDelay = 3, 
        tTrainTime = { 900, 1800, 3600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/OrbitalStrike',
        sCustomThreadName = 'orbitalStrike',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_orbitalstrike',
    },

    female01chop = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "chop",                                   
		tAnimNames = { "chop", "punch", "punch2", "punch3", }, 
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25, 
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/HeroPunch',        
        rHitEffectDef = rPunchHitEffect,
    },
    female01zap = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL018TEXT",
        sDescription = "ABDS018TEXT",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "zap_freeze",
        bIsDefault = false,
        nDamageDelay = 0.75,
        bIsUnlocked = true,
        tTrainTime = { 0, 300, 600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/ZapFreeze',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_timefreeze',
        sEffectToTrigger = 'Effects/GalaxyGirlZap.lua',
        nEffectXScale = 2.5,
        nEffectYScale = 2.5,
        bAttachEffect = false,
        nEffectXOffset = 80,
        nEffectYOffset = 50,
    },
    female01heal = {
        sAbilityType = "Ability",
        sAbilityName = "ABIL017TEXT",
        sDescription = "ABDS017TEXT",
        sAnimName = 'heal',
        bIsDefault = false,
        bAffectAllFriendly = true,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/AlienHeal',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_heal',
        tBuffs = 
        {
            {
                sBuffType = "HealBuff",
                bScaleByAbilityPower = true,
                nAmount=7,
                multBy="nAwareness",
                nTurnDuration = 1,    
    
                sSpriteSheetName = 'FX/FX_5',
                sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                sSpriteAnimName = 'galaxygirlheal',
                nSpriteOffsetX = 10.0,
                nSpriteOffsetY = 80.0,
                nScale = 2.5,
            },
        },
    },
    female01zapall = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL019TEXT",
        sDescription = "ABDS019TEXT",
        sAnimName = "zap_freeze",
        bIsDefault = false,
        bAffectAll = false,
        nDamageDelay = 0.75,
        tTrainTime = { 900, 1800, 3600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/TimeFreeze',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_zapfreeze',
        tBuffs = 
        {
                {
                    sBuffType = "StunBuff",
                    nTurnDuration = 3,                 
                    sAnimName = "stun",
                    sSpriteSheetName = 'FX/FX_4',
                    sAnimDefName = 'Characters/AnimDefs/FX_2.lua',
                    sSpriteAnimName = 'zapfreeze',
                    sAlignX = 'center',
                    sAlignY = 'bottom',
                    tColor = { r = 1, g = 1, b = 1, a = 0 },
                },
        },
    },
    female02bolt = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "elecbolt",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "range_attack",
        bIsDefault = true,
        bIsUnlocked = true,
        nDamageDelay = 0.5,
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/Female02_ThrowLightning',
        rProjectileDef =
        {
            sSpriteSheetName = 'FX/FX',
            sAnimDefName = 'Characters/AnimDefs/FX.lua',
            sSpriteAnimName = 'electricity',
            --nSpriteRot = 90,
            nSpeed = 400,
            nSpawnDelay = 0.25,
            nSourceOffsetX = 40,
            nSourceOffsetY = 60,
            nTargetOffsetX = 0,
            nTargetOffsetY = 50,      
            nScaleRange = { 0.75, 1 },
        },
        rHitEffectDef =
        {
            sEffectPath = 'Effects/ImpactElectricity.lua',
            offSetRange = { x = { -30, 30 }, y = { 0, 30 } },
            scaleRange = { 0.75, 1 },
        },
    },
    female02eleckick = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL021TEXT",
        sDescription = "ABDS021TEXT",
        sAnimName = "attack_backflipkick",
        bIsDefault = false,
        bIsUnlocked = true,
        bMoveToTarget = true,
        nMoveDuration = 0.7,
        nDamageDelay = 0.4,
        tTrainTime = { 0, 300, 600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/Female02_SpinKick',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_parryflipkick',
        rHitEffectDef = rPunchHitEffect,
    },
    female02elecshield = {
        sAbilityType = "Ability",
        sAbilityName = "ABIL020TEXT",
        sDescription = "ABDS020TEXT",
        bIsDefault = false,
        nDuration = 5.0, 
        tTrainTime = { 120, 480, 900 },
        sCustomThreadName = 'elecShield',
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/SeparateShield',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_lightningshield',
        tBuffs=
        {
            {
                bScaleByAbilityPower=true,
                sBuffType = 'RevengeDamageBuff',
                nAmount = "nAwareness",
                nTurnDuration = 3,                   
            },
        },
    },
    female02lightning = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL022TEXT",
        sDescription = "ABDS022TEXT",
        sAnimName = "lightning_strike",
        bIsDefault = false,
        nDamageDelay = 1.0,
        bAffectAll = true,
        tTrainTime = { 900, 1800, 3600 },
        sCustomThreadName = 'lightningStrike',
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/Female02_LightningStrike',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_callsdownlightning',
        rHitEffectDef =
        {
            sEffectPath = 'Effects/ImpactElectricity.lua',
            offSetRange = { x = { -30, 30 }, y = { 0, 30 } },
            scaleRange = { 1.75, 2 },
        },
    },
    robot01punch = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "punch",                                   
		tAnimNames = { "punch", "punch2", "punch3", }, 
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25, 
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/HeroPunch',        
        rHitEffectDef = rPunchHitEffect,
    },
    robot01eyebeams = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL023TEXT",
        sDescription = "ABDS023TEXT",
        sAnimName = "eyebeam",
        bIsDefault = false,
        bIsRanged = true,
        bIsUnlocked = true,
        nDamageDelay = 1.0,
        tTrainTime = { 0, 300, 600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/RobotEyebeam',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_roboteyebeam',
        rHitEffectDef = rRayGunHitEffect,
        sCustomThreadName = 'robotEyeBeam',
    },
    robot01gasgrenade = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL024TEXT",
        sDescription = "ABDS024TEXT",
        sAnimName = "grenades",
        bIsDefault = false,
        bIsRanged = true,
        nDamageDelay = 1.5,
        bAffectAll = true,
        tTrainTime = { 120, 480, 900 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/RobotGrenade',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_robotgasgrenade',
        sCustomThreadName = 'robotGasGrenade',
        tBuffs = 
        {
            {
                bScaleByAbilityPower=true,
                sBuffType = "PowerBuff",
                nTurnDuration = 3,                 
                nAmount = -.5,
                multBy="nAwareness",
                
                sSpriteSheetName = 'FX/FX_5',
                sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                sSpriteAnimName = 'mummycurse',
                nSpriteOffsetX = 20.0,
                nSpriteOffsetY = 110.0,
                nScale = 2.5, 
            },
        },
    },
    robot01rocketstorm = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "ABIL025TEXT",
        sDescription = "ABDS025TEXT",
        sAnimName = "rocketstorm",
        bIsDefault = false,
        bIsRanged = true,
        nDamageDelay = 4.0,
        bAffectAll = true,
        tTrainTime = { 900, 1800, 3600 },
        sCueName = 'MMOJ_Audio/SFX/HeroSFX/RobotRocketArm',
        sCustomThreadName = 'robotRocketStorm',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_robotmisslebarrage',
    },
    -- villains
    skullfacepunch = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "punch",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "melee_attack",
        bIsUnlocked = true,
        bIsDefault = true,
        nDamageDelay = 0.25, 
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/SkullFaceAttack',
        rHitEffectDef = rPunchHitEffect,
    },
    skullfacestun = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "Laugh",
        sAnimName = "stun_laugh",
        nMinLevel = 1,
        bIsDefault = false,
        bAffectAll = true,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/SkullFaceKackle',
        tBuffs =
        {
            {
                sBuffType = "StunBuff",
                nDuration = 5,
                sAnimName = "stun",
            },
        },
    },
    skullfaceblast = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "Blast",
        nDamageAmount = 2, -- multiplied by POW
        sAnimName = "charge_fire",
        nMinLevel = 1,
        bIsDefault = false,
        bIsUnlocked = true,
        bAffectAll = true,
        nDamageDelay = 1.25,
        nCooldownTurns = 4,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/Skullface_ChargeAttack',
    },
    madscientistraygun = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "fireraygun",
        nDamageAmount = 1, -- multiplied by POW
        sAnimName = "ranged_attack",
        bIsUnlocked = true,
        bIsDefault = true,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/CraniumLaser',
        rHitEffectDef = rRayGunHitEffect,
    },
    madscientistrockettrigger = {
        sAbilityType = "AbilityTriggerAttack",
        sAbilityName = 'Trigger Rocket',
        sAnimName = 'press_button',
        sPostAttackAnim = 'press_button_laugh',
        tTriggerActorNames = { 'RocketPunch1' },        
        sAbilityNameToTrigger = 'rocketfire',
        bIsUnlocked = true,
        bIsDefault = true,
    },
    robotfootstomp = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "stomp",
        nDamageAmount = 1, -- multiplied by POW
        bIsUnlocked = true,
        bIsDefault = true,
        nCooldownTurns = 3,
        nDamageDelay = 1.5,
        nPostAnimDelay = 2.5,
        bAffectAll = true,
        bDontGoToFightPose = true,
        sCustomThreadName = 'footStomp',
        sLiftCueName = 'MMOJ_Audio/SFX/EnemySFX/RobotFootLift',
        sStompCueName = 'MMOJ_Audio/SFX/EnemySFX/RobotFootStomp',
    },
    monsterfootstomp = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "stomp",
        nDamageAmount = 1, -- multiplied by POW
        bIsUnlocked = true,
        bIsDefault = true,
        nCooldownTurns = 3,
        nDamageDelay = 1.5,
        nPostAnimDelay = 2.5,
        bAffectAll = true,
        bDontGoToFightPose = true,
        sCustomThreadName = 'footStomp',
        sLiftCueName = 'MMOJ_Audio/SFX/EnemySFX/MonsterFootLift',
        sStompCueName = 'MMOJ_Audio/SFX/HeroSFX/MonsterFootSlam',
    },
    robotbeamblast = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "fireballs",
        sAnimName = "breathe",
        nDamageAmount = 1, -- multiplied by POW
        nMinLevel = 1,
        bIsDefault = false,
        bIsRanged = true,
        rProjectileDef =
        {
            sSpriteSheetName = 'FX/FX',
            sAnimDefName = 'Characters/AnimDefs/FX.lua',
            sSpriteAnimName = 'fireball',
            nSpriteRot = 245,
            nSpeed = 150,
            nScaleRange = { 5, 5 },
            tAbsSourceLoc = { x = -350, y = 700 },
            tAbsTargetLoc = { x = -450, y = 300 },
        },
    },
    rocketfire = {
        sAbilityType = "AbilityDamage",
        sAbilityName = "rocketfire",
        sAnimName = 'fire',
        nDamageAmount = 1, -- multiplied by POW
        nMinLevel = 1,
        bIsDefault = true,
        bIsUnlocked = true,
        bIsRanged = true,
        nImpactCue = 'MMOJ_Audio/SFX/HeroSFX/HeroPunch',       
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/Enemy_RocketPunch',
        rProjectileDef =
        {
            sSpriteSheetName = 'FX/FX_2',
            sAnimDefName = 'Characters/AnimDefs/FX_2.lua',
            sSpriteAnimName = 'glove_missile',
            nSpeed = 400,
            nSpawnDelay = 0.1,
            nSourceOffsetX = -60,
            nSourceOffsetY = 140,
            nTargetOffsetX = 80,
            nTargetOffsetY = 80,      
            nScaleRange = { 1, 1 },
        },
        rHitEffectDef = rRocketPunchImpactEffect,
        sCustomThreadName = 'rocketFire',
    },
    --[[
    mm_loadbalance = {
        sAbilityType = "Ability",
        sAbilityName = "mm_loadbalance",
        nMinLevel = 1,
        bIsUnlocked = true,
        nRealTimeCooldown = 120,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/Enemy_RocketPunch',
        sCustomThreadName = 'loadBalance',
        sIconName = 'ability_heal',
    },
    ]]--
    mm_peptalk = {
        sAbilityType = "Ability",
        --sAbilityName = "mm_peptalk",
        sAbilityName = "ABIL029TEXT",
        sDescription = "ABDS029TEXT",
        bIsUnlocked=true,
        nRealTimeCooldown = 240,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/Enemy_RocketPunch',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_peptalk',     
        tTrainTime = { 0, 480, 900 },
        tReqLevel = { 1, 3, 5 },
        bAffectAllFriendly = true,
        tBuffsByLevel = 
        {
            {
                {
                    sBuffType = "CritBuff",
                    nAmount = .5,
                    nTurnDuration = 2,
                    
                    sSpriteSheetName = 'FX/FX_5',
                    sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                    sSpriteAnimName = 'powersparkles',
                    nSpriteOffsetX = 20.0,
                    nSpriteOffsetY = 140.0,
                    nScale = 3.5,
                },
            },
            {
                {
                    sBuffType = "CritBuff",
                    nAmount = .6,
                    nTurnDuration = 3,
                    
                    sSpriteSheetName = 'FX/FX_5',
                    sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                    sSpriteAnimName = 'powersparkles',
                    nSpriteOffsetY = 140.0,
                    nScale = 3.5,
                },
            },
            {
                {
                    sBuffType = "CritBuff",
                    nAmount = 1,
                    nTurnDuration = 3,
                    
                    sSpriteSheetName = 'FX/FX_5',
                    sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                    sSpriteAnimName = 'powersparkles',
                    nSpriteOffsetY = 140.0,
                    nScale = 3.5,
                },
            },
        },
    },
    mm_harddeadline = {
        sAbilityType = "Ability",
        --sAbilityName = "mm_harddeadline",
        sAbilityName = "ABIL030TEXT",
        sDescription = "ABDS032TEXT",
        nRealTimeCooldown = 480,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/Enemy_RocketPunch',
        sIconName = 'ability_crunchtime',
        sIconSheet = 'UI/icons',      
        tTrainTime = { 120, 480, 900 },
        tReqLevel = { 7, 8, 8 },
        bAffectAllFriendly = true,
        sCustomThreadName = 'deathCountdown',
        tBuffsByLevel = 
        {
            {
                {
                    sBuffType = "PowerBuff",
                    nAmount = 10,
                    nTurnDuration = 999,
                },
                {
                    sBuffType = "HealBuff",
                    nAmount = 30,
                    nTurnDuration = 999,
                },
            },
            {
                {
                    sBuffType = "PowerBuff",
                    nAmount = 20,
                    nTurnDuration = 999,
                },
                {
                    sBuffType = "HealBuff",
                    nAmount = 50,
                    nTurnDuration = 999,
                },
            },
            {
                {
                    sBuffType = "PowerBuff",
                    nAmount = 30,
                    nTurnDuration = 999,
                },
                {
                    sBuffType = "HealBuff",
                    nAmount = 70,
                    nTurnDuration = 999,
                },
            },
        },
    },
    mm_paradigmshift = {
        sAbilityType = "Ability",
        --sAbilityName = "mm_paradigmshift",
        sAbilityName = "ABIL031TEXT",
        sDescription = "ABDS031TEXT",
        nRealTimeCooldowns = {480,360,240},
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/Enemy_RocketPunch',
        sCustomThreadName = 'paradigmShift',
        sIconName = 'ability_paradigmshift',
        sIconSheet = 'UI/icons',   
        tTrainTime = { 120, 480, 900 },
        tReqLevel = { 2, 4, 6 },
        bAffectAll = true,
    },
    mm_crunchtime = {
        sAbilityType = "Ability",
        --sAbilityName = "mm_crunchtime",
        sAbilityName = "ABIL032TEXT",
        sDescription = "ABDS030TEXT",
        bIsUnlocked = false,
        nRealTimeCooldown = 480,
        sCueName = 'MMOJ_Audio/SFX/EnemySFX/Enemy_RocketPunch',
        sCustomThreadName = 'crunchTime',
        sIconSheet = 'UI/icons',
        sIconName = 'ability_harddeadline',    
        tTrainTime = { 120, 480, 900 },

        bAffectAllFriendly = true,
        tReqLevel = { 5, 7, 8 },
        --tTrainTime = { 0, 300, 600 },
        tBuffs =
        {
            {
                sBuffType = "CrunchTimeBuff",
                nDuration = 1,

                sSpriteSheetName = 'FX/FX_5',
                sAnimDefName = 'Characters/AnimDefs/FX_5.lua',
                sSpriteAnimName = 'speedsparkles',
                --nSpeed = 400,
                --nTurnDuration = 2,
                nSpriteOffsetY = 120.0,
                nScale = 2.5,
            },
        },
    },
    -- per-level ability info, referenced from powers above.
    -- Done for my sanity, to get all the numbers in one place.
    _abilityReferencedData=
    {
        -- robot power impressions: 
        robot01eyebeams=
        {   
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 4, 6, 8 },
            tManaCost = { 2, 4, 6, },
        },
        robot01gasgrenade=
        {
            -- group power debuff (.5*awareness) + damage
            bAffectsAll=true,
            tDamage = { 1, 1, 1 },
            tBuffDuration={ 2,3,4 },
            tManaCost = { 4, 6, 8, },
        },
        robot01rocketstorm = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 1, 2, 3 },
            bAffectAll = true,
            tManaCost = { 4, 6, 8, },
        },
        -- impression: 
        male01laser = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 4, 6, 8 },
            tManaCost = { 2, 4, 6, },
        },
        male01slam = {
            tDamage = { 2, 4, 6 },
            tBuffDuration={2,3,4},
            tManaCost = { 4, 6, 8, },
        },
        male01throw = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 1, 2, 3 },
            bAffectAll = true,
            tManaCost = { 4, 6, 8, },
        },
        mummybandage = {
            tDamage = { 2, 4, 6 },
            tBuffDuration={2,3,4},
            tManaCost = { 2, 4, 6, },
        },
        mummycurse = {
            tBuffDuration={3,5,7},
            -- power debuff, -1 per awareness.
            -- single target.
            tManaCost = { 3, 4, 5, },
        },
        mummyfist = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 1, 2, 3 },
            bAffectAll = true,
            tManaCost = { 4, 6, 8, },
        },
        male01crallycry = {
            -- power buff, .4pow+.4awar.
            bAffectAllFriendly = true,
            tBuffDuration={3,5,7},
            tManaCost = { 2, 5, 8, },
        },
        male01cslam = {
            -- group power debuff (.5*awareness) + damage
            bAffectsAll=true,
            tDamage = { 2, 3, 5 },
            tBuffDuration={ 3,5,7 },
            tManaCost = { 4, 7, 10, },
        },
        male01cflyslam = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 1, 2, 3 },
            bAffectAll = true,
            tManaCost = { 4, 6, 8, },
        },
        
        male01dcrowbar = {
            tDamage = { 2, 3, 5 },
            tManaCost = { 2, 5, 8, },
        },
        male01dboomerang = {
            bAffectsAll = true,
            tDamage = { 2, 3, 5 },
            tManaCost = { 4, 7, 10, },
        },
        male01dripportal = {
            bAffectsAll = true,            
            tDamage = { 1, 1, 1 },
            tManaCost = { 4, 6, 8, },
        },
        
        male02headbutt = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 2, 5, 8 },
            tBuffDuration = {1,1,1},
            tManaCost = { 2, 5, 8, },
        },
        male02rage = {
            -- power buff, .75pow+.75awar
            tBuffDuration = {3,4,5},
            tManaCost = { 2, 5, 8, },
        },
        male02blast = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage  = { 1, 2, 3 },
            bAffectAll = true,
            tManaCost = { 4, 6, 8, },
        },
        male02beyebeams = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 4, 6, 8 },
            tManaCost = { 2, 4, 6, },
        },
        male02bshield = {
            -- shield buff, 5+awareness, scaled by ap, self-only
            tBuffDuration={3,4,5},
            tManaCost = { 4, 6, 8, },
        },
        male02borbital = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 1, 2, 3 },
            bAffectAll = true,
            tManaCost = { 4, 6, 8, },
        },
    
        female01zap = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 4, 6, 8 },
            tManaCost = { 2, 4, 6, },
        },
        female01heal = {
            -- heal all, 7*awareness
            bAffectAllFriendly = true,
            tBaseAmount = {6,8,10},
            tManaCost = { 4, 6, 8, },
        },
        female01zapall = {
            tBuffDuration={3,5,7},
            tManaCost = { 4, 6, 8, },
        },
        female02eleckick = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 4, 6, 8 },
            tManaCost = { 2, 4, 6, },
        },
        female02elecshield = {
            -- revenge buff
            tBuffDuration = {3,4,5},
            tManaCost = { 3, 6, 9, },
        },
        female02lightning = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 1, 2, 3 },
            bAffectAll = true,
            tManaCost = { 4, 6, 8, },
        },    
        female02bgloomerang = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 0.5, 1, 1.5 },
            tManaCost = { 2, 4, 6, },
        },
        female02bfocusrefresh = {
            -- revenge buff
            tBuffDuration = {3,4,5},
            tManaCost = { 3, 6, 9, },
        },
        female02bshadowdebuff = {
            nPowerFactor = 0.5,
            nIntFactor = 0.5,
            tDamage = { 0, 0, 0 },
            bAffectAll = true,
            tManaCost = { 4, 6, 8, },
        },  
    },
}
