local tDefs =
{
    fanboylvl2 = 
    {
        sName = "COST001TEXT",
        sDefKey = 'lvl2',
        sDescription = "COST017TEXT",        
        sEffectDescription = "COST042TEXT",
        iconName = 'male01_lvl2',
        nCost = 500,
        nReqLevel = 5,
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nShield', statAmount = 5, },
                { statName = 'nMaxHP', statAmount = 20, },
            },
        },
        sAchievementID = 'BuyEightLvlTwoCostume',
    },
    fanboylvl3 =
    {
        sName = "COST002TEXT",
        sDefKey = 'lvl3',
        sDescription = "COST018TEXT",
        iconName = 'male01_lvl3',
        nCost = 1000,
        nReqLevel = 10,
        sAchievementID = 'BuyEightLvlThreeCostume',
    },
    hotheadlvl2 = 
    {
        sName = "COST003TEXT",
        sDefKey = 'lvl2',
        sDescription = "COST019TEXT",
        sEffectDescription = "COST043TEXT",
        iconName = 'male02_lvl2',
        nCost = 500,
        nReqLevel = 5,
        sAchievementID = 'BuyEightLvlTwoCostume',
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nPower', statAmount = 3, },
                { statName = 'nAwareness', statAmount = 3, },
                { statName = 'nMaxHP', statAmount = 30, },
            },
        },
    },
    hotheadlvl3 =
    {
        sName = "COST004TEXT",
        sDefKey = 'lvl3',
        sDescription = "COST020TEXT",
        iconName = 'male02_lvl3',
        nCost = 1000,
        nReqLevel = 10,
        sAchievementID = 'BuyEightLvlThreeCostume',
    },
    atmanlvl2 = 
    {
        sName = "COST005TEXT",
        sDefKey = 'lvl2',
        sDescription = "COST021TEXT",
        sEffectDescription = "COST044TEXT",
        iconName = 'male02b_lvl2',
        nCost = 500,
        nReqLevel = 5,
        sAchievementID = 'BuyEightLvlTwoCostume',
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nMaxMana', statAmount = 4, },
                { statName = 'nSpecialAbilityMult', statAmount = .3, },
            },
        },
    },
    atmanlvl3 =
    {
        sName = "COST006TEXT",
        sDefKey = 'lvl3',
        sDescription = "COST022TEXT",
        sEffectDescription = "COST052TEXT",
        iconName = 'male02b_lvl3',
        nCost = 1000,
        nReqLevel = 10,
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nShield', statAmount = 10, },
                { statName = 'nMaxMana', statAmount = 6, },
                { statName = 'nPower', statAmount = 6, },
            },
        },
        sAchievementID = 'BuyEightLvlThreeCostume',
    },
    mummylvl2 = 
    {
        sName = "COST007TEXT",
        sDefKey = 'lvl2',
        sDescription = "COST023TEXT",
        sEffectDescription = "COST045TEXT",
        iconName = 'male01b_lvl2',
        nCost = 500,
        nReqLevel = 5,
        sAchievementID = 'BuyEightLvlTwoCostume',
        tEquipDef=
        {
            sItemType = "FightBuffEquippableItem",
            -- NOTE: I had the shield + mana buff in, but I'm afraid of stackable shields (w/ the item in the store).
            -- You might be able to be nearly immune to damage.
            -- So for now I'm just duping the robot's tanky abilities.
            -- Maybe change it back if we fix stackable shields?
            tStatModifiers =
            {
                --{ statName = 'nMaxMana', statAmount = 30, },
                { statName = 'nBlockEffectiveness', statAmount = .2, },
                { statName = 'nBlockChance', statAmount = .2, },
            },
            --[[
            tBuffs =
            {
                {
                    sBuffType = "ShieldBuff",
                    nAmount = "nPower",
                    multBy = .3,
                    nTurnDuration = -1,
                },
            },
            ]]--
        },
    },
    mummylvl3 =
    {
        sName = "COST008TEXT",
        sDefKey = 'lvl3',
        sDescription = "COST024TEXT",
        iconName = 'male01b_lvl3',
        nCost = 1000,
        nReqLevel = 10,
        sAchievementID = 'BuyEightLvlThreeCostume',
    },
    surgelvl2 = 
    {
        sName = "COST009TEXT",
        sDefKey = 'lvl2',
        sDescription = "COST025TEXT",
        sEffectDescription = "COST048TEXT",
        iconName = 'female02_lvl2',
        nCost = 500,
        nReqLevel = 5,
        sAchievementID = 'BuyEightLvlTwoCostume',
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nBlockEffectiveness', statAmount = .2, },
                { statName = 'nBlockChance', statAmount = .2, },
            },
        },
    },
    surgelvl3 =
    {
        sName = "COST010TEXT",
        sDefKey = 'lvl3',
        sDescription = "COST026TEXT",
        iconName = 'female02_lvl3',
        nCost = 1000,
        nReqLevel = 10,
        sAchievementID = 'BuyEightLvlThreeCostume',
    },
    vetlvl2 = 
    {
        sName = "COST011TEXT",
        sDefKey = 'lvl2',
        sDescription = "COST027TEXT",
        sEffectDescription = "COST046TEXT",
        iconName = 'male01c_lvl2',
        nCost = 500,
        nReqLevel = 5,
        sAchievementID = 'BuyEightLvlTwoCostume',
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nMaxHP', statAmount = 40, },
                { statName = 'nPower', statAmount = 3, },
            },
        },
    },
    vetlvl3 =
    {
        sName = "COST012TEXT",
        sDefKey = 'lvl3',
        sDescription = "COST028TEXT",
        iconName = 'male01c_lvl3',
        nCost = 1000,
        nReqLevel = 10,
        sAchievementID = 'BuyEightLvlThreeCostume',
    },
    cosmiclvl2 = 
    {
        sName = "COST013TEXT",
        sDefKey = 'lvl2',
        sDescription = "COST029TEXT",
        sEffectDescription = "COST046TEXT",
        iconName = 'female01_lvl2',
        nCost = 500,
        nReqLevel = 5,
        sAchievementID = 'BuyEightLvlTwoCostume',
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nMaxHP', statAmount = 40, },
                { statName = 'nPower', statAmount = 3, },
            },
        },
    },
    cosmiclvl3 =
    {
        sName = "COST014TEXT",
        sDefKey = 'lvl3',
        sDescription = "COST030TEXT",
        iconName = 'female01_lvl3',
        nCost = 1000,
        nReqLevel = 10,
        sAchievementID = 'BuyEightLvlThreeCostume',
    },
    gloomlvl2 = 
    {
        sName = "COST049TEXT",
        sDefKey = 'lvl2',
        sDescription = "COST050TEXT",
        sEffectDescription = "COST051TEXT",
        iconName = 'female02b_lvl2',
        nCost = 500,
        nReqLevel = 5,
        sAchievementID = 'BuyEightLvlTwoCostume',
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nAwareness', statAmount = 4, },
                { statName = 'nMaxMana', statAmount = 4, },
            },
        },
    },

    botlvl2 = 
    {
        sName = "COST015TEXT",
        sDefKey = 'lvl2',
        sDescription = "COST031TEXT",
        sEffectDescription = "COST047TEXT",
        iconName = 'robot01_lvl2',
        nCost = 500,
        nReqLevel = 5,
        sAchievementID = 'BuyEightLvlTwoCostume',
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nMaxHP', statAmount = 40, },
                { statName = 'nPower', statAmount = 3, },
            },
        },
    },
    botlvl3 =
    {
        sName = "COST016TEXT",
        sDefKey = 'lvl3',
        sDescription = "COST032TEXT",
        sEffectDescription = "COST053TEXT",
        iconName = 'robot01_lvl3',
        nCost = 1000,
        nReqLevel = 10,
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nShield', statAmount = 5, },
                { statName = 'nMaxMana', statAmount = 10, },
                { statName = 'nAwareness', statAmount = 6, },
            },
        },
        sAchievementID = 'BuyEightLvlThreeCostume',
    },
    
    crowbarlvl2 = 
    {
        sName = "COST033TEXT",
        sDefKey = 'lvl2',
        sDescription = "COST035TEXT",
        sEffectDescription = "COST047TEXT",
        iconName = 'male01d_lvl2',
        nCost = 500,
        nReqLevel = 5,
        sAchievementID = 'BuyEightLvlTwoCostume',
        tEquipDef=
        {
            sItemType = "EquippableItem",
            tStatModifiers =
            {
                { statName = 'nMaxHP', statAmount = 40, },
                { statName = 'nPower', statAmount = 3, },
            },
        },
    },
    
    crowbarlvl3 =
    {
        sName = "COST034TEXT",
        sDefKey = 'lvl3',
        sDescription = "COST036TEXT",
        iconName = 'male01d_lvl3',
        nCost = 1000,
        nReqLevel = 10,
        sAchievementID = 'BuyEightLvlThreeCostume',
    },
}

local tOrderedList =
{
    'atmanlvl2',
    'vetlvl2',
    'crowbarlvl2',
    'botlvl2',
    'cosmiclvl2',
    'gloomlvl2',
    'hotheadlvl2',
    'mummylvl2',
    'surgelvl2',
    'fanboylvl2',    
}

local tConditionalCostumes =
{
    {
        sEnvironmentFlag = 'gpuVendor',
        sReqValue = 'tegra',
        sCostumeKey = 'atmanlvl3',
    },
    {
        sEnvironmentFlag = 'gpuVendor',
        sReqValue = 'tegra',
        sCostumeKey = 'botlvl3',
    },
}

return
{
   tList = tOrderedList,
   tDefs = tDefs,
   tConditionalCostumes = tConditionalCostumes,
}
