local DFUtil = require('DFCommon.Util')

local tDefs =
{
    healthlvl1 = {
        sName = "ITEM001TEXT",
        sDescription = "ITEM013TEXT",
        sStat = "ITEM029TEXT",
        sItemType = 'HealConsumableItem',
        nCost = 50,
        nMMLevel = 1,
        nHealthAmount = 20,
        iconName = 'icon_consumable_healthdrink1',
        sSpriteSheet = 'UI/icons3',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        bResearched = true,
    },
    healthlvl2 = {
        sName = "ITEM002TEXT",
        sDescription = "ITEM014TEXT",
        sStat = "ITEM030TEXT",
        sItemType = 'HealConsumableItem',
        nCost = 75,
        nMMLevel = 1,
        nHealthAmount = 40,
        iconName = 'icon_consumable_healthdrink2',
        sDefKeyRequiredToResearch = 'healthlvl1',
        sSpriteSheet = 'UI/icons3',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        nResearchDuration = 180,
        nReqInt = 3,
    },
    healthlvl3 = {
        sName = "ITEM003TEXT",
        sDescription = "ITEM015TEXT",
        sStat = "ITEM031TEXT",
        sItemType = 'HealConsumableItem',
        nCost = 125,
        nMMLevel = 1,
        nHealthAmount = 80,
        iconName = 'icon_consumable_healthdrink3',
        sDefKeyRequiredToResearch = 'healthlvl2',
        sSpriteSheet = 'UI/icons3',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        nResearchDuration = 360,
        nReqInt = 5,
        nRoomLevel = 2,
    },
    healthlvl4 = {
        sName = "ITEM004TEXT",
        sDescription = "ITEM016TEXT",
        sStat = "ITEM032TEXT",
        sItemType = 'HealConsumableItem',
        nCost = 150,
        nMMLevel = 1,
        nHealthAmount = 100,
        iconName = 'icon_consumable_healthdrink4',
        sDefKeyRequiredToResearch = 'healthlvl3',
        sSpriteSheet = 'UI/icons3',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        nResearchDuration = 720,
        nReqInt = 7,
        nRoomLevel = 3,
    },
    
    strengthpotion1 = {
        sName = "ITEM009TEXT",
        sDescription = "ITEM021TEXT",
        sStat = "ITEM033TEXT",
        sItemType = 'BuffConsumableItem',
        nCost = 75,
        nMMLevel = 1,
        bAffectFriendly = true,
        tBuffs =
        {
            {
                sBuffType = 'PowerBuff',
                nTurnDuration = 3,
                nAmount = 5,
            },
        },
        sOverlayText = "+5 POWER",
        iconName = 'icon_consumable_strengthpotion1',
        sSpriteSheet = 'UI/icons3',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        bResearched = true,
    },
    strengthpotion2 = {
        sName = "ITEM010TEXT",
        sDescription = "ITEM022TEXT",
        sStat = "ITEM034TEXT",
        sItemType = 'BuffConsumableItem',
        nCost = 100,
        nMMLevel = 1,
        bAffectFriendly = true,
        tBuffs =
        {
            {
                sBuffType = 'PowerBuff',
                nTurnDuration = 2,             
                nAmount = 10,
            },
        },
        sOverlayText = "+10 POWER",
        iconName = 'icon_consumable_strengthpotion2',
        sSpriteSheet = 'UI/icons3',
        sDefKeyRequiredToResearch = 'strengthpotion1',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        nResearchDuration = 180,
        nReqInt = 3,
    },
    strengthpotion3 = {
        sName = "ITEM011TEXT",
        sDescription = "ITEM023TEXT",
        sStat = "ITEM035TEXT",
        sItemType = 'BuffConsumableItem',
        nCost = 120,
        nMMLevel = 1,
        bAffectFriendly = true,
        tBuffs =
        {
            {
                sBuffType = 'PowerBuff',
                nTurnDuration = 2,             
                nAmount = 15,
            },
        },
        sOverlayText = "+15 POWER",
        iconName = 'icon_consumable_strengthpotion3',
        sSpriteSheet = 'UI/icons3',
        sDefKeyRequiredToResearch = 'strengthpotion2',
        sUseCue = 'MMOJ_Audio/SFX/StrengthPotion3',
        nResearchDuration = 360,
        nReqInt = 6,
        nRoomLevel = 2,
    },
    strengthpotion4 = {
        sName = "ITEM012TEXT",
        sDescription = "ITEM024TEXT",
        sStat = "ITEM036TEXT",
        sItemType = 'BuffConsumableItem',
        nCost = 150,
        nMMLevel = 1,
        bAffectFriendly = true,
        tBuffs =
        {
            {
                sBuffType = 'PowerBuff',
                nTurnDuration = 2,              
                nAmount = 20,
            },
        },
        sOverlayText = "+20 POWER",
        iconName = 'icon_consumable_strengthpotion4',
        sSpriteSheet = 'UI/icons3',
        sDefKeyRequiredToResearch = 'strengthpotion3',
        sUseCue = 'MMOJ_Audio/SFX/StrengthPotion4',
        nResearchDuration = 720,
        nReqInt = 8,
        nRoomLevel = 3,
    },
    enemyweakenpotion1 = {
        sName = "ITEM027TEXT",
        sDescription = "ITEM028TEXT",
        sStat = "ITEM037TEXT",
        sItemType = 'BuffConsumableItem',
        nCost = 150,
        nMMLevel = 1,
        tBuffs =
        {
            {
                sBuffType = 'PowerBuff',
                nTurnDuration = 3,
                nAmount = -5,
            },
        },
        sOverlayText = "-5 POWER",
        iconName = 'icon_xp_enemydamage',
        sSpriteSheet = 'UI/icons4',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        bResearched = true,
    },
    enemyweakenpotion2 = {
        sName = "ITEM025TEXT",
        sDescription = "ITEM026TEXT",
        sStat = "ITEM038TEXT",
        sItemType = 'BuffConsumableItem',
        nCost = 250,
        nMMLevel = 1,
        tBuffs =
        {
            {
                sBuffType = 'PowerBuff',
                nTurnDuration = 3,
                nAmount = -10,
            },
        },
        sOverlayText = "-10 POWER",
        iconName = 'icon_weaksauce',
        sSpriteSheet = 'UI/icons3',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        nResearchDuration = 360,
        nReqInt = 9,
        nRoomLevel = 2,
    },
    manalvl1 = {
        sName = "ITEM007TEXT",
        sDescription = "ITEM047TEXT",
        sStat = "ITEM017TEXT",
        sItemType = 'ManaConsumableItem',
        nCost = 75,
        nMMLevel = 1,
        nManaAmount = 3,
        iconName = 'icon_consumable_powerpotion1',
        sSpriteSheet = 'UI/icons3',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        bResearched = true,
    },
    manalvl2 = {
        sName = "ITEM006TEXT",
        sDescription = "ITEM048TEXT",
        sStat = "ITEM018TEXT",
        sItemType = 'ManaConsumableItem',
        nCost = 125,
        nMMLevel = 1,
        nManaAmount = 6,
        iconName = 'icon_consumable_powerpotion6',
        sDefKeyRequiredToResearch = 'manalvl1',
        sSpriteSheet = 'UI/icons3',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        nResearchDuration = 180,
        nReqInt = 3,
    },
    manalvl3 = {
        sName = "ITEM005TEXT",
        sDescription = "ITEM049TEXT",
        sStat = "ITEM019TEXT",
        sItemType = 'ManaConsumableItem',
        nCost = 150,
        nMMLevel = 1,
        nManaAmount = 9,
        iconName = 'icon_consumable_powerpotion3',
        sDefKeyRequiredToResearch = 'manalvl2',
        sSpriteSheet = 'UI/icons3',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        nResearchDuration = 360,
        nReqInt = 5,
        nRoomLevel = 2,
    },
    manalvl4 = {
        sName = "ITEM008TEXT",
        sDescription = "ITEM050TEXT",
        sStat = "ITEM020TEXT",
        sItemType = 'ManaConsumableItem',
        nCost = 175,
        nMMLevel = 1,
        nManaAmount = 20,
        iconName = 'icon_consumable_powerpotion2',
        sDefKeyRequiredToResearch = 'manalvl3',
        sSpriteSheet = 'UI/icons3',
        sUseCue = 'MMOJ_Audio/SFX/ConsumableItem',
        nResearchDuration = 720,
        nReqInt = 7,
        nRoomLevel = 3,
    },
    yak = {
        sName = "ITEM042TEXT",
        sDescription = "ITEM046TEXT",
        iconName = 'icon_prop_yak',
        sItemType = 'PermanentPropItem',
        sGrantItemType = 'healthlvl4',
        nCost = 15000,
        nMMLevel = 1,
        sSpriteSheet = 'UI/icons4',
        sPropName = 'yak',
        bResearched = true,
        bPermanent = true,
        sPremiumPurchaseSprite = "MM_Yak",
        sPremiumPurchaseSpriteSheet = "BaseProps3",
        nPremiumPurchaseOverrideWidth = 100,
    },
    juicer = {
        sName = "ITEM040TEXT",
        sDescription = "ITEM043TEXT",
        iconName = 'icon_prop_juicer',
        sItemType = 'PermanentPropItem',
        sGrantItemType = 'healthlvl2',
        nCost = 3000,
        nMMLevel = 1,
        sSpriteSheet = 'UI/icons4',
        sPropName = 'juicer',
        bResearched = true,
        bPermanent = true,
        sPremiumPurchaseSpriteSheet = "BaseProps3",
        sPremiumPurchaseSprite = "MM_Juicer",
        nPremiumPurchaseOverrideHeight = 120,
    },
    blender = {
        sName = "ITEM041TEXT",
        sDescription = "ITEM044TEXT",
        iconName = 'icon_prop_blender',
        sItemType = 'PermanentPropItem',
        sGrantItemType = 'healthlvl3',
        nCost = 7000,
        nMMLevel = 1,
        sSpriteSheet = 'UI/icons4',
        sPropName = 'blender',
        bResearched = true,
        bPermanent = true,
        sPremiumPurchaseSpriteSheet = "BaseProps4",
        sPremiumPurchaseSprite = "MM_Blender",
        nPremiumPurchaseOverrideHeight = 180,
        nPremiumPurchaseOverrideWidth = 120,
    },
    watercooler = {
        sName = "ITEM039TEXT",
        sDescription = "ITEM045TEXT",
        iconName = 'icon_prop_watercooler',
        sItemType = 'PermanentPropItem',
        sGrantItemType = 'healthlvl1',
        nCost = 1000,
        nMMLevel = 1,
        sSpriteSheet = 'UI/icons4',
        sPropName = 'watercooler',
        bResearched = true,
        bPermanent = true,
        sPremiumPurchaseSpriteSheet = "BaseProps2",
        sPremiumPurchaseSprite = "MM_WaterCooler",
    },
    coffeemaker = {
        sName = "EQIP065TEXT",
        sDescription = "EQIP097TEXT",
        iconName = 'icon_prop_coffeemaker',
        sItemType = 'PermanentPropItem',
        sGrantItemType = 'manalvl1',
        nCost = 5000,
        nMMLevel = 1,        
        sSpriteSheet = 'UI/icons4',
        sPropName = 'coffeemaker',
        bResearched = true,
        bUnlocked = false,
        bPermanent = true,
        sPremiumPurchaseSpriteSheet = "BaseProps4",
        sPremiumPurchaseSprite = "MM_CoffeeMaker",
        nPremiumPurchaseOverrideHeight = 180,
        -- this mamma jamma needs to replenish day old coffees and have a prop in the office
    },
}

local tList =
{
    'healthlvl1',
    'healthlvl2',
    'healthlvl3',
    'healthlvl4',

    'manalvl1',
    'manalvl2',
    'manalvl3',
    'manalvl4',

    'strengthpotion1',
    'strengthpotion2',
    'strengthpotion3',
    'strengthpotion4',

    'enemyweakenpotion1',
    'enemyweakenpotion2',
    
    'watercooler',
    'juicer',
    'blender',
    'yak',
    'coffeemaker',
}

return
{
    tList = tList,
    tDefs = tDefs,
}
