local DFUtil = require('DFCommon.Util')

local tDefs = 
{
    powlvl1 = { 
        sName = "EQIP001TEXT",
        sDescription = "EQIP013TEXT",
        sItemType = "EquippableItem",
        nCost = 100,
        nMMLevel = 1,
        iconName = 'icon_equipment_pow1',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nPower', statAmount = 2 },
        },        
        bResearched = true,
    },
    powlvl2 = { 
        sName = "EQIP002TEXT",
        sDescription = "EQIP014TEXT",
        sItemType = "EquippableItem",
        nCost = 200,
        nMMLevel = 1,
        iconName = 'icon_equipment_pow2',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nPower', statAmount = 3 },
        },
        sDefKeyRequiredToResearch = 'powlvl1',
        nResearchDuration = 300,
        nReqInt = 3,
    },
    powlvl3 = { 
        sName = "EQIP003TEXT",
        sDescription = "EQIP015TEXT",
        sItemType = "EquippableItem",
        nCost = 300,
        nMMLevel = 1,
        iconName = 'icon_equipment_pow3',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nPower', statAmount = 5 },
        },
        sDefKeyRequiredToResearch = 'powlvl2',
        nResearchDuration = 600,
        nReqInt = 5,
        nRoomLevel = 2,
    },
    powlvl4 = { 
        sName = "EQIP004TEXT",
        sDescription = "EQIP016TEXT",
        sItemType = "EquippableItem",
        nCost = 400,
        nMMLevel = 1,
        iconName = 'icon_equipment_pow4',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nPower', statAmount = 7 },
        },
        sDefKeyRequiredToResearch = 'powlvl3',
        nResearchDuration = 1800,
        nReqInt = 7,
        nRoomLevel = 3,
    },

    intlvl1 = { 
        sName = "EQIP005TEXT",
        sDescription = "EQIP017TEXT",
        sItemType = "EquippableItem",
        nCost = 100,
        nMMLevel = 1,
        iconName = 'icon_equipment_int1',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nAwareness', statAmount = 2 },
        },        
        bResearched = true,
    },
    intlvl2 = { 
        sName = "EQIP006TEXT",
        sDescription = "EQIP018TEXT",
        sItemType = "EquippableItem",
        nCost = 200,
        nMMLevel = 1,
        iconName = 'icon_equipment_int2',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nAwareness', statAmount = 4 },
        },
        sDefKeyRequiredToResearch = 'intlvl1',
        nResearchDuration = 300,
        nReqInt = 3,
    },
    intlvl3 = { 
        sName = "EQIP007TEXT",
        sDescription = "EQIP019TEXT",
        sItemType = "EquippableItem",
        nCost = 300,
        nMMLevel = 1,
        iconName = 'icon_equipment_int3',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nAwareness', statAmount = 6 },
        },
        sDefKeyRequiredToResearch = 'intlvl2',
        nResearchDuration = 600,
        nReqInt = 6,
        nRoomLevel = 2,
    },
    intlvl4 = { 
        sName = "EQIP008TEXT",
        sDescription = "EQIP020TEXT",
        sItemType = "EquippableItem",
        nCost = 400,
        nMMLevel = 1,
        iconName = 'icon_equipment_int4',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nAwareness', statAmount = 10 },
        },
        sDefKeyRequiredToResearch = 'intlvl3',
        nResearchDuration = 1800,
        nReqInt = 8,
        nRoomLevel = 3,
    },

    shieldlvl1 = { 
        sName = "EQIP009TEXT",
        sDescription = "EQIP021TEXT",
        sItemType = "EquippableItem",
        nCost = 100,
        nMMLevel = 1,
        iconName = 'icon_equipment_shield1',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nShield', statAmount = 2 },
        },        
        bResearched = true,
    },
    shieldlvl2 = { 
        sName = "EQIP010TEXT",
        sDescription = "EQIP022TEXT",
        sItemType = "EquippableItem",
        nCost = 200,
        nMMLevel = 1,
        iconName = 'icon_equipment_shield2',
        sSpriteSheet = 'UI/icons4',
        tStatModifiers = {
            { statName = 'nShield', statAmount = 4 },
        },
        sDefKeyRequiredToResearch = 'shieldlvl1',
        nResearchDuration = 300,
        nReqInt = 3,
    },
    shieldlvl3 = { 
        sName = "EQIP011TEXT",
        sDescription = "EQIP023TEXT",
        sItemType = "EquippableItem",
        nCost = 300,
        nMMLevel = 1,
        iconName = 'icon_equipment_shield3',
        sSpriteSheet = 'UI/icons4',
        tStatModifiers = {
            { statName = 'nShield', statAmount = 6 },
        },
        sDefKeyRequiredToResearch = 'shieldlvl2',
        nResearchDuration = 600,
        nReqInt = 6,
        nRoomLevel = 2,
    },
    shieldlvl4 = { 
        sName = "EQIP012TEXT",
        sDescription = "EQIP024TEXT",
        sItemType = "EquippableItem",
        nCost = 400,
        nMMLevel = 1,
        iconName = 'icon_kevlarspandex',
        sSpriteSheet = 'UI/icons4',
        tStatModifiers = {
            { statName = 'nShield', statAmount = 8 },
        },
        sDefKeyRequiredToResearch = 'shieldlvl3',
        nResearchDuration = 1800,
        nReqInt = 8,
        nRoomLevel = 3,
    },
    passaggbelt = { 
        sName = "EQIP025TEXT",
        sDescription = "EQIP026TEXT",
        sItemType = "EquippableItem",
        nCost = 1500,
        nMMLevel = 1,
        iconName = 'icon_blackbelt',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nShield', statAmount = 15 },
            { statName = 'nPower', statAmount = -15 },
        },
        nResearchDuration = 3600,
        nReqInt = 12,
        nRoomLevel = 3,
    },
    employeeofthemonth = { 
        sName = "EQIP027TEXT",
        sDescription = "EQIP028TEXT",
        sStat = "EQIP044TEXT",
        sItemType = "MoraleEquippableItem",
        nCost = 2000,
        nMMLevel = 1,
        iconName = 'icon_employee_of_the_month',
        sSpriteSheet = 'UI/icons3',
        nResearchDuration = 3600,
        nReqInt = 12,
        nRoomLevel = 3,
    },
    hypnoglasses = { 
        sName = "EQIP029TEXT",
        sDescription = "EQIP030TEXT",
        sStat = "EQIP045TEXT",
        sItemType = "DefaultAttackModEquippableItem",
        nCost = 1000,
        nMMLevel = 1,
        iconName = 'icon_hypnoglasses',
        sSpriteSheet = 'UI/icons4',
        nResearchDuration = 3600,
        nReqInt = 13,
        nRoomLevel = 3,       
        sModKey = 'hypnoglasses',
        nChance = 0.3,
        tBuffs =
        {
            {
                sBuffType = "StunBuff",
                nTurnDuration = 1,
                sAnimName = "stun",            
            },
        },
    },
    montagemusic = { 
        sName = "EQIP031TEXT",
        sDescription = "EQIP032TEXT",
        sStat = "EQIP046TEXT",
        sItemType = "EquippableItem",
        nCost = 2000,
        nMMLevel = 1,
        iconName = 'icon_motivational_music_montage',
        sSpriteSheet = 'UI/icons4',
        nResearchDuration = 3600,
        nReqInt = 13,
        nRoomLevel = 3,      
        tActivitySpeedModifiers = 
        { 
            MMTrainIntActivity = 25,
            Train = 25,
            HPTrain = 25,
            AbilityTrain = 25,
        },
    },
    vitaminhat = { 
        sName = "EQIP033TEXT",
        sDescription = "EQIP034TEXT",
        sStat = "EQIP047TEXT",
        sItemType = "FightBuffEquippableItem",
        nCost = 1000,
        nMMLevel = 1,
        iconName = 'icon_vitamin_hat',
        sSpriteSheet = 'UI/icons4',
        bResearched = false,
        nResearchDuration = 2400,
        nReqInt = 12,
        nRoomLevel = 3,     
        sModKey = 'vitaminhat',
        tBuffs =
        {
            {
                sBuffType = "HealBuff",
                nAmount = 10,
                nTurnDuration = 999,
            },
        },
    },
    coffeeiv = { 
        sName = "EQIP035TEXT",
        sDescription = "EQIP036TEXT",
        sStat = "EQIP050TEXT",
        sItemType = "FightBuffEquippableItem",
        nCost = 1750,
        nMMLevel = 1,
        iconName = 'icon_caffiene_iv',
        sSpriteSheet = 'UI/icons3',
        nResearchDuration = 3600,
        nReqInt = 14,
        nRoomLevel = 3, 
        sModKey = 'coffeeiv',
        tBuffs =
        {
            {
                sBuffType = "HealBuff",
                nAmount = 20,
                nTurnDuration = 999,
            },
        },
        sDefKeyRequiredToResearch = 'vitaminhat',
    },
    xpmultiplier = { 
        sName = "EQIP037TEXT",
        sDescription = "EQIP038TEXT",
        sStat = "EQIP048TEXT",
        sItemType = "XPMultEquippableItem",
        nCost = 3000,
        nMMLevel = 1,
        iconName = 'icon_xp_multiplier',
        sSpriteSheet = 'UI/icons4',
        nResearchDuration = 3600,
        nReqInt = 15,
        nRoomLevel = 3, 
        nMultiplier = .25,
    },
    
    --///////////       RARE DROPS     //////////////////
    --superium oven mitts
    powlvl5 = { 
        sName = "EQIP058TEXT",
        sDescription = "EQIP074TEXT",
        sItemType = "EquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 800,
        nMMLevel = 1,
        iconName = 'icon_equipment_pow6',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nPower', statAmount = 6 },
        },        

    },
    -- superhero handbook vol. 2
    intlvl5 = { 
        sName = "EQIP059TEXT",
        sDescription = "EQIP075TEXT",
        sItemType = "EquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 800,
        nMMLevel = 1,
        iconName = 'icon_equipment_int5',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nAwareness', statAmount = 7 },
        },        
    },
    -- belt of light compromise
    passaggbelt2 = { 
        sName = "EQIP060TEXT",
        sDescription = "EQIP076TEXT",
        sItemType = "EquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 800,
        nMMLevel = 1,
        iconName = 'icon_blackbelt2',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nShield', statAmount = 15 },
            { statName = 'nPower', statAmount = -5 },
        },
    },
    -- otherworldy underpants
    shieldlvl5 = { 
        sName = "EQIP061TEXT",
        sDescription = "EQIP077TEXT",
        sItemType = "EquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 800,
        nMMLevel = 1,
        iconName = 'icon_equipment_shield5',
        sSpriteSheet = 'UI/icons4',
        tStatModifiers = {
            { statName = 'nShield', statAmount = 7 },
        },        
    },
    --brainwash glasses
    hypnoglasses2 = { 
        sName = "EQIP062TEXT",
        sDescription = "EQIP078TEXT",
        sStat = "EQIP094TEXT",
        sItemType = "DefaultAttackModEquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 800,
        nMMLevel = 1,
        iconName = 'icon_hypnoglasses2',
        sSpriteSheet = 'UI/icons4',
        sModKey = 'hypnoglasses',
        nChance = 0.4,
        tBuffs =
        {
            {
                sBuffType = "StunBuff",
                nTurnDuration = 1,
                sAnimName = "stun",            
            },
        },
    },
    --energy hat
    focushat = { 
        sName = "EQIP063TEXT",
        sDescription = "EQIP079TEXT",
        sStat = "EQIP095TEXT",
        sItemType = "FightBuffEquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 800,
        iconName = 'icon_focus_hat',
        sSpriteSheet = 'UI/icons4',
        sModKey = 'focushat',
        tBuffs =
        {
            {
                sBuffType = "ManaBuff",
                nAmount = 1,
                nTurnDuration = 999,
            },
        },
    },
    
    --////////      MOST WANTED DROPS   ///////////
    -- employee of the year
    employeeoftheyear = { 
        sName = "EQIP064TEXT",
        sDescription = "EQIP080TEXT",
        sItemType = "MoraleEquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 2000,
        bImproveTeammates = true,
        iconName = 'icon_employee_of_the_year',
        sSpriteSheet = 'UI/icons3',
    },
    --long smartphone
    longphone = {
        sName = "EQIP066TEXT",
        sDescription = "EQIP082TEXT",
        sStat = "EQIP098TEXT",
        sItemType = "EquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 2000,
        iconName = 'icon_longphone',
        sSpriteSheet = 'UI/icons4',
        tStatModifiers = {
            { statName = 'nAwareness', statAmount = 20 },
        }, 
        tActivitySpeedModifiers = 
        {
            Research = 50,
        },
    },
    --suit of impenetrability
    defensesuit = {
        sName = "EQIP067TEXT",
        sDescription = "EQIP083TEXT",
        sStat = "EQIP099TEXT",
        sItemType = "FightBuffEquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 2000,
        iconName = 'icon_defense_suit',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nShield', statAmount = 20 },
        }, 
        tBuffs =
        {
            {
                sBuffType = "BlockEffectivenessBuff",
                nAmount = .25,
                nTurnDuration = 999,
            },
            {
                sBuffType = "BlockChanceBuff",
                nAmount = .15,
                nTurnDuration = 999,
            },
        },
    },
    
    --beatdown gauntlets
    beatdowngauntlets = {
        sName = "EQIP068TEXT",
        sDescription = "EQIP084TEXT",
        sStat = "EQIP100TEXT",
        sItemType = "DefaultAttackModEquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 2000,
        iconName = 'icon_BeatdownGauntlet',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nPower', statAmount = 15 },
        }, 
        nChance = 1,
        sModKey = 'beatdowngauntlets',
        tBuffs =
        {
            {
                sBuffType = "DamageBuff",
                nAmount = 10,
                nTurnDuration = 1,
            },
        },        
        -- needs DoT: +10 Damage over 5 seconds? Stackable? Hmm...
    },
    --vampire hat
    vampirehat = { 
        sName = "EQIP069TEXT",
        sDescription = "EQIP085TEXT",
        sStat = "EQIP101TEXT",
        sItemType = "FightBuffEquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 2000,
        iconName = 'icon_vampire_hat',
        sSpriteSheet = 'UI/icons4',
        sModKey = 'vampirehat',
        tBuffs =
        {
            {
                sBuffType = "VampireBuff",
                nAmount = .2,
                nTurnDuration = 999999,
            },
        },
        --needs to steal back tunable % of whatever damage you deal
    },
    --certificate of validity
    certificateofvalidity = {
        sName = "EQIP106TEXT",
        sDescription = "EQIP082TEXT",
        sStat = "EQIP116TEXT",
        sItemType = "MoraleEquippableItem",
        bResearched = true,
        nCost = 2000,
        iconName = 'icon_crimefighting_certificate',
        sSpriteSheet = 'UI/icons4',
        tStatModifiers = {
            { statName = 'nAwareness', statAmount = 20 },
        }, 
        nMultiplier = .25,
    },
    --bulletproof hairspray
    bulletproofhairspray = {
        sName = "EQIP109TEXT",
        sDescription = "EQIP113TEXT",
        sStat = "EQIP115TEXT",
        sItemType = "FightBuffEquippableItem",
        bResearched = true,
        nCost = 2000,
        iconName = 'icon_equipment_shield4',
        sSpriteSheet = 'UI/icons4',
        tStatModifiers = {
            { statName = 'nShield', statAmount = 25 },
        }, 
        {
            sBuffType = "BlockEffectivenessBuff",
            nAmount = .25,
            nTurnDuration = 999,
        },
    },
    
    --key to the city
    keytothecity = {
        sName = "EQIP108TEXT",
        sDescription = "EQIP112TEXT",
        sItemType = "DefaultAttackModEquippableItem",
        bResearched = true,
        nCost = 2000,
        iconName = 'icon_key_to_city',
        sSpriteSheet = 'UI/icons4',
        tStatModifiers = {
            { statName = 'nPower', statAmount = 10 },
            { statName = 'nShield', statAmount = 10 },
            { statName = 'nAwareness', statAmount = 10 },
        }, 
        nChance = 1,
    },
    
    --nerd specs
    nerdspecs = {
        sName = "EQIP107TEXT",
        sDescription = "EQIP111TEXT",
        sStat = "EQIP100TEXT",
        sItemType = "DefaultAttackModEquippableItem",
        bResearched = true,
        nCost = 2000,
        iconName = 'icon_nerdglasses',
        sSpriteSheet = 'UI/icons4',
        tStatModifiers = {
            { statName = 'nAwareness', statAmount = 18 },
            { statName = 'nShield', statAmount = 12 },
        }, 
        nChance = 1,
    },
    
    --////////      GODZILLA DROPS   ///////////
    -- beastfly eye
    beastflyeye = {
        sName = "EQIP070TEXT",
        sDescription = "EQIP086TEXT",
        sStat = "EQIP102TEXT",
        sItemType = "HealthRegenInBaseItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 5000,
        iconName = 'icon_eyeofthebeastfly',
        sSpriteSheet = 'UI/icons4',
        nHPPerSec = 1,
        tStatModifiers = {
            { statName = 'nPower', statAmount = 15 },
        }, 
    },
    -- beastfly hat
    beastflyhat = {
        sName = "EQIP071TEXT",
        sDescription = "EQIP087TEXT",
        sItemType = "EquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 5000,
        iconName = 'icon_tuftofthebeastfly',
        sSpriteSheet = 'UI/icons4',
        tStatModifiers = {
            { statName = 'nAwareness', statAmount = 20 },
            { statName = 'nShield', statAmount = 10 },
        },        
    },
    -- beastfly carapace
    beastflysuit = {
        sName = "EQIP072TEXT",
        sDescription = "EQIP088TEXT",
        sStat = "EQIP104TEXT",
        sItemType = "FightBuffEquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 5000,
        iconName = 'icon_carapaceofthebeastfly',
        sSpriteSheet = 'UI/icons3',
        tStatModifiers = {
            { statName = 'nShield', statAmount = 20 },
        },  
        --stole this bit from vitaminhat, just needs to do the identical thing
        sModKey = 'vitaminhat',
        tBuffs =
        {
            { 
                sBuffType = "HealBuff",
                nAmount = 10,
                nTurnDuration = 999,
            },
            {
                sBuffType = "BlockChanceBuff",
                nAmount = .25,
                nTurnDuration = 999,
            },
        },
    },
    -- beastfly docs
    beastflysoftware = {
        sName = "EQIP073TEXT",
        sDescription = "EQIP089TEXT",
        sStat = "EQIP105TEXT",
        sItemType = "EquippableItem",
        bResearched = true,
        bHideInShop = true,
        nCost = 5000,
        iconName = 'icon_beastflysoftware',
        sSpriteSheet = 'UI/icons3',
        tActivitySpeedModifiers = 
        {
            MMMoraleActivity = 25,
            MMTrainIntActivity = 25,
            Recreation = 25,
            Research = 25,
            Rest = 25,
            Train = 25,
            HPTrain = 25,
            AbilityTrain = 25,  
        },
    },
}

local tList =
{
    'powlvl1',
    'powlvl2',
    'powlvl3',
    'powlvl4',

    'intlvl1',
    'intlvl2',
    'intlvl3',
    'intlvl4',

    'shieldlvl1',
    'shieldlvl2',
    'shieldlvl3',
    'shieldlvl4',

    'passaggbelt',
    'employeeofthemonth',
    'hypnoglasses',
    'montagemusic',
    'vitaminhat',
    'coffeeiv',
    'xpmultiplier',

-- rare drops-- most wanted drops
    'powlvl5',
    'intlvl5',
    'shieldlvl5',
    'hypnoglasses2',
    'passaggbelt2',
    'focushat',

    'employeeoftheyear',
    'longphone',    
    'beatdowngauntlets',
    'defensesuit',    
    'vampirehat',
-- godzilla drops
    'beastflyhat',
    'beastflyeye',
    'beastflysuit',
    'beastflysoftware',
}

return
{
    tList = tList,
    tDefs = tDefs,
}
