local tMeteoriteSpawnInfo =
{
    -- default
    {
        nPossibility = 40,
        nMinMMLevel = 2, -- this is the area unlock levels
        tMeteoriteInfos =
        {
            {
                sMeteoriteKey = 'firedamage',
                tPossibleLevels = { 1 },
            },
            {
                sMeteoriteKey = 'powerdebuff',
                tPossibleLevels = { 1 },
            },
            {
                sMeteoriteKey = 'coinbuff',
                tPossibleLevels = { 1 },
            },
            {
                sMeteoriteKey = 'thorns',
                tPossibleLevels = { 1 },
            },
            {
                sMeteoriteKey = 'xpbuff',
                tPossibleLevels = { 1 },
            },
        },
    },
    {
        nPossibility = 30,
        nMinMMLevel = 4, -- this is the area unlock levels
        tMeteoriteInfos =
        {
            {
                sMeteoriteKey = 'firedamage',
                tPossibleLevels = { 1 },
            },
            {
                sMeteoriteKey = 'powerdebuff',
                tPossibleLevels = { 1 },
            },
            {
                sMeteoriteKey = 'thorns',
                tPossibleLevels = { 1 },
            },
            {
                sMeteoriteKey = 'coinbuff',
                tPossibleLevels = { 1 },
            },
            {
                sMeteoriteKey = 'xpbuff',
                tPossibleLevels = { 1 },
            },
        },
    },
    {
        nPossibility = 20,
        nMinMMLevel = 6, -- this is the area unlock levels
        tMeteoriteInfos =
        {
            {
                sMeteoriteKey = 'firedamage',
                tPossibleLevels = { 2 },
            },
            {
                sMeteoriteKey = 'powerdebuff',
                tPossibleLevels = { 2 },
            },
            {
                sMeteoriteKey = 'thorns',
                tPossibleLevels = { 1 },
            },
            {
                sMeteoriteKey = 'coinbuff',
                tPossibleLevels = { 2 },
            },
            {
                sMeteoriteKey = 'xpbuff',
                tPossibleLevels = { 1 },
            },
        },
    },
    {
        nPossibility = 10,
        nMinMMLevel = 8, -- this is the area unlock levels
        tMeteoriteInfos =
        {
            {
                sMeteoriteKey = 'firedamage',
                tPossibleLevels = { 2 },
            },
            {
                sMeteoriteKey = 'powerdebuff',
                tPossibleLevels = { 2 },
            },
            {
                sMeteoriteKey = 'thorns',
                tPossibleLevels = { 2 },
            },
            {
                sMeteoriteKey = 'coinbuff',
                tPossibleLevels = { 2 },
            },
            {
                sMeteoriteKey = 'xpbuff',
                tPossibleLevels = { 2 },
            },
        },
    },
    {
        nPossibility = 8,
        nMinMMLevel = 10, -- this is the area unlock levels
        tMeteoriteInfos =
        {
            {
                sMeteoriteKey = 'firedamage',
                tPossibleLevels = { 3 },
            },
            {
                sMeteoriteKey = 'powerdebuff',
                tPossibleLevels = { 3 },
            },
            {
                sMeteoriteKey = 'thorns',
                tPossibleLevels = { 2 },
            },
            {
                sMeteoriteKey = 'coinbuff',
                tPossibleLevels = { 3 },
            },
            {
                sMeteoriteKey = 'xpbuff',
                tPossibleLevels = { 2 },
            },
        },
    },
    {
        nPossibility = 5,
        nMinMMLevel = 10, -- this is the area unlock levels
        tMeteoriteInfos =
        {
            {
                sMeteoriteKey = 'firedamage',
                tPossibleLevels = { 4 },
            },
            {
                sMeteoriteKey = 'powerdebuff',
                tPossibleLevels = { 4 },
            },
            {
                sMeteoriteKey = 'thorns',
                tPossibleLevels = { 4 },
            },
            {
                sMeteoriteKey = 'coinbuff',
                tPossibleLevels = { 4 },
            },
            {
                sMeteoriteKey = 'xpbuff',
                tPossibleLevels = { 4 },
            },
        },
    },
}

local tDefs =
{
    firedamage = {
        sName = "MNAM009TEXT",
        sDescription = "MNAM024TEXT",
        sPlusMinus = "MNAM032TEXT",
        sEffectText = "MNAM015TEXT",
        sItemType = "BuffMeteorite",
        nMMLevel = 1,
        bResearched = true,
        tColor = { 1, .50, 0 },
        tPurchasePrice = { 1, 3, 5, 7, 10 },
        tSellPrice = { 50, 100, 250, 600, 1200, 2400 }, -- split out to make tweaks easier
        tInfo = {
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "DamageBuff",
                            nAmount = 2,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'firebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 2.5,
                        },
                    },
                },
            },
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "DamageBuff",
                            nAmount = 3,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'firebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 2.5,
                        },
                    },
                },
            },
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "DamageBuff",
                            nAmount = 5,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'firebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 2.5,
                        },
                    },
                },
            },
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "DamageBuff",
                            nAmount = 7,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'firebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 2.5,
                        },
                    },
                },
            },
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "DamageBuff",
                            nAmount = 9,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'firebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 2.5,
                        },
                    },
                },
            },
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "DamageBuff",
                            nAmount = 11,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'firebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 2.5,
                        },
                    },
                },
            },
        },
    },
    powerdebuff = {
        sName = "MNAM010TEXT",
        sDescription = "MNAM025TEXT",
        sPlusMinus = "MNAM031TEXT",
        sEffectText = "MNAM022TEXT",
        sItemType = "BuffMeteorite",
        nMMLevel = 1,
        bResearched = true,
        tColor = { 0, .43, .97 },
        tPurchasePrice = { 1, 3, 5, 7, 10 },
        tSellPrice = { 50, 100, 250, 600, 1200, 2400 }, -- split out to make tweaks easier
        tInfo = {
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "PowerBuff",
                            nAmount = -1,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'powerdebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 3,
                        },
                    },
                },
            },
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "PowerBuff",
                            nAmount = -3,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'powerdebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 3,
                        },
                    },
                },
            },
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "PowerBuff",
                            nAmount = -5,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'powerdebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 3,
                        },
                    },
                },
            },
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "PowerBuff",
                            nAmount = -7,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'powerdebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 3,
                        },
                    },
                },
            },
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "PowerBuff",
                            nAmount = -9,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'powerdebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 3,
                        },
                    },
                },
            },
            {
                tAttackMods =
                {
                    tBuffs =
                    {
                        {
                            sBuffType = "PowerBuff",
                            nAmount = -11,
                            nTurnDuration = 1,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'powerdebuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                            nScale = 3,
                        },
                    },
                },
            },
        },
    },
    thorns = {
        sName = "MNAM011TEXT",
        sDescription = "MNAM023TEXT",
        sPlusMinus = "MNAM032TEXT",
        sEffectText = "MNAM016TEXT",
        sItemType = "BuffMeteorite",
        nMMLevel = 1,
        bResearched = true,
        tColor = { 0, 1, 0 },
        tPurchasePrice = { 1, 3, 5, 7, 10 },
        tSellPrice = { 50, 100, 250, 600, 1200, 2400 }, -- split out to make tweaks easier
        tInfo = {
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "RevengeDamageBuff",
                            nAmount = 3,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'thornybuff',
                            nSpriteOffsetX = 40,
                            nSpriteOffsetY = 100,
                            nScale = 1.5;
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "RevengeDamageBuff",
                            nAmount = 5,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'thornybuff',
                            nSpriteOffsetX = 40,
                            nSpriteOffsetY = 100,
                            nScale = 1.5;
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "RevengeDamageBuff",
                            nAmount = 7,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'thornybuff',
                            nSpriteOffsetX = 40,
                            nSpriteOffsetY = 100,
                            nScale = 1.5;
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "RevengeDamageBuff",
                            nAmount = 9,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'thornybuff',
                            nSpriteOffsetX = 40,
                            nSpriteOffsetY = 100,
                            nScale = 1.5;
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "RevengeDamageBuff",
                            nAmount = 11,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'thornybuff',
                            nSpriteOffsetX = 40,
                            nSpriteOffsetY = 100,
                            nScale = 1.5;
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "RevengeDamageBuff",
                            nAmount = 13,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'thornybuff',
                            nSpriteOffsetX = 40,
                            nSpriteOffsetY = 100,
                            nScale = 1.5;
                        },
                    },
                },
            }, 
        },
    },
    coinbuff = {
        sName = "MNAM007TEXT",
        sDescription = "MNAM026TEXT",
        sPlusMinus = "MNAM032TEXT",        
        sEffectText = "MNAM017TEXT",
        sItemType = "BuffMeteorite",
        nMMLevel = 1,
        bResearched = true,
        tColor = { 1, .85, 0 },
        tPurchasePrice = { 1, 3, 5, 7, 10 },
        tSellPrice = { 50, 100, 250, 600, 1200, 2400 }, -- split out to make tweaks easier
        tInfo = {
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "CoinBuff",
                            nAmount = 0.5,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'coinbuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "CoinBuff",
                            nAmount = 1,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'coinbuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "CoinBuff",
                            nAmount = 1.5,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'coinbuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "CoinBuff",
                            nAmount = 2,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'coinbuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "CoinBuff",
                            nAmount = 2.5,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'coinbuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "CoinBuff",
                            nAmount = 3,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'coinbuff',
                            nSpriteOffsetX = 0,
                            nSpriteOffsetY = 120,
                        },
                    },
                },
            }, 
        },
    },
    xpbuff = {
        sName = "MNAM008TEXT",
        sDescription = "MNAM027TEXT", 
        sPlusMinus = "MNAM032TEXT",       
        sEffectText = "MNAM018TEXT",
        sItemType = "BuffMeteorite",
        nMMLevel = 1,
        bResearched = true,
        tColor = { 0, .86, 1 },
        tPurchasePrice = { 1, 3, 5, 7, 10 },
        tSellPrice = { 50, 100, 250, 600, 1200, 2400 }, -- split out to make tweaks easier
        tInfo = {
            {
                nXPMultiplier = .1 
            },
            {
                nXPMultiplier = .2 
            },
            {
                nXPMultiplier = .4             
            },
            {
                nXPMultiplier = .6 
            },
            {
                nXPMultiplier = .8
            },
            {
                nXPMultiplier = 1
            },
        },
    },
    dodge = {
        sName = "MNAM013TEXT",
        sDescription = "MNAM029TEXT",
        sPlusMinus = "MNAM032TEXT",
        sEffectText = "MNAM019TEXT",
        sItemType = "BuffMeteorite",
        tRecipe = { "powerdebuff", "powerdebuff", "xpbuff",},
        nMMLevel = 1,
        bResearched = false,
        nResearchDuration = 3600,
        nReqInt = 5,
        nRoomLevel = 1,  
        tColor = { 1, 0, 0 },
        tSellPrice = { 50, 100, 250, 600, 1200, 2400 }, -- split out to make tweaks easier
        tInfo = {
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "DodgeBuff",
                            nAmount = 0.2,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'dodgebuff',
                            nSpriteOffsetX = 60,
                            nSpriteOffsetY = 80,
                            nScale = 2.7,
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "DodgeBuff",
                            nAmount = 0.25,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'dodgebuff',
                            nSpriteOffsetX = 60,
                            nSpriteOffsetY = 80,
                            nScale = 2.7,
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "DodgeBuff",
                            nAmount = 0.3,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'dodgebuff',
                            nSpriteOffsetX = 60,
                            nSpriteOffsetY = 80,
                            nScale = 2.7,
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "DodgeBuff",
                            nAmount = 0.35,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'dodgebuff',
                            nSpriteOffsetX = 60,
                            nSpriteOffsetY = 80,
                            nScale = 2.7,
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "DodgeBuff",
                            nAmount = 0.4,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'dodgebuff',
                            nSpriteOffsetX = 60,
                            nSpriteOffsetY = 80,
                            nScale = 2.7,
                        },
                    },
                },
            }, 
            {
                tFightBuffs =
                {
                    tBuffs =
                    {
                        { 
                            sBuffType = "DodgeBuff",
                            nAmount = 0.45,
                            bIsInfinite = true,
                            sSpriteSheetName = 'FX/FX_4',
                            sAnimDefName = 'Characters/AnimDefs/FX_4.lua',
                            sSpriteAnimName = 'dodgebuff',
                            nSpriteOffsetX = 60,
                            nSpriteOffsetY = 80,
                            nScale = 2.7,
                        },
                    },
                },
            }, 
        },
    },
    focusbuff = {
        sName = "MNAM012TEXT",
        sDescription = "MNAM020TEXT",
        sPlusMinus = "MNAM031TEXT",
        sEffectText = "MNAM020TEXT",
        sItemType = "BuffMeteorite",
        tRecipe = { "coinbuff", "xpbuff", "splashdamage", },
        nMMLevel = 5,
        bResearched = false,
        nResearchDuration = 5000,
        nReqInt = 10,
        nRoomLevel = 2, 
        tColor = { 1, 0, .91 },
        tSellPrice = { 50, 100, 250, 600, 1200, 2400 }, -- split out to make tweaks easier
        tInfo = {
            {
                nManaCostMultiplier = 0.2,
            },
            {
                nManaCostMultiplier = 0.25,
            },
            {
                nManaCostMultiplier = 0.3,
            },
            {
                nManaCostMultiplier = 0.35,
            },
            {
                nManaCostMultiplier = 0.4,
            },
            {
                nManaCostMultiplier = 0.5,
            },
        },
    },
    splashdamage = {
        sName = "MNAM014TEXT",
        sDescription = "MNAM028TEXT",
        sPlusMinus = "MNAM032TEXT",
        sEffectText = "MNAM021TEXT",
        sItemType = "BuffMeteorite",
        tRecipe = { "thorns", "thorns", "firedamage", },
        nMMLevel = 10,
        bResearched = false,
        nResearchDuration = 7200,
        nReqInt = 15,
        nRoomLevel = 3, 
        tColor = { .45, 0, .89 },
        tSellPrice = { 50, 100, 250, 600, 1200, 2400 }, -- split out to make tweaks easier
        tInfo = {
            {
                nSplashDamageMultiplier = 0.2,
            },
            {
                nSplashDamageMultiplier = 0.25,
            },
            {
                nSplashDamageMultiplier = 0.3,
            },
            {
                nSplashDamageMultiplier = 0.35,
            },
            {
                nSplashDamageMultiplier = 0.4,
            },
            {
                nSplashDamageMultiplier = 0.45,
            },
        },
    },
}

local tList =
{
    'firedamage',
    'powerdebuff',
    'coinbuff',
    'thorns',    
    'xpbuff',
    'dodge',
    'focusbuff',
    'splashdamage',
}

return
{
    tList = tList,
    tDefs = tDefs,
    tSpawnInfo = tMeteoriteSpawnInfo,
}