local DialogManager = {}
local DFFile = require('DFCommon.File')
local DFUtil = require('DFCommon.Util')

function DialogManager:new(sStringTableFile, sDialogSetFile)
    local Ob = {}

    Ob.tStringTable = dofile(DFFile.getDataPath('Scripts/String/'..sStringTableFile))
    Ob.tDialogSets = dofile(DFFile.getDataPath('Scripts/String/'..sDialogSetFile))

    function Ob:getDialogSetInstance(sDialogSetName) -- returns a new instance
        if sDialogSetName and self.tDialogSets and self.tDialogSets[sDialogSetName] then
            return DFUtil.deepCopy(self.tDialogSets[sDialogSetName])
        end
        return nil
    end

    function Ob:getString(sLineCode)
        if sLineCode and self.tStringTable then
            if self.tStringTable[sLineCode] then
                return self.tStringTable[sLineCode]
            else
                return "INVALID LINECODE: "..sLineCode
            end
        end
        return ""
    end

    function Ob:updateStringTableEntry(sKey, sValue)
        if sKey and sValue then
            if self.tStringTable[sKey] then
                self.tStringTable[sKey] = sValue
            end
        end
    end

    return Ob
end

return DialogManager