local util = require("DFUtil")

return {
	layers = {
		{
			image = util.getAssetName("Rooms/Base/base01.png"),
			width = 1024,
			height = 601,
			x = 0,
			y = 0,
			priority = 0,
		},
		{
			image = util.getAssetName("Rooms/Base/base02.png"),
			x = 197,
			y = 98,
			width = 392,
			height = 186,
			priority = 100,
		},
		{
			image = util.getAssetName("Rooms/Base/base03.png"),
			x = 19,
			y = 116,
			width = 306,
			height = 224,
			priority = 200,
		},
		{
			image = util.getAssetName("Rooms/Base/base04.png"),
			x = 19,
			y = 197,
			width = 372,
			height = 182,
			priority = 300,
		},
		{
			image = util.getAssetName("Rooms/Base/base05.png"),
			x = 627,
			y = 290,
			width = 55,
			height = 109,
			priority = 400,
		},
		{
			image = util.getAssetName("Rooms/Base/base06.png"),
			x = 428,
			y = 313,
			width = 399,
			height = 185,
			priority = 500,
		},
		{
			image = util.getAssetName("Rooms/Base/base07.png"),
			x = 561,
			y = 395,
			width = 246,
			height = 193,
			priority = 600,
		},
	},
	layerMods = {
		{
			image = util.getAssetName("Rooms/Base/base01_up.png"),
			x = 273,
			y = 35,
			width = 82,
			height = 98,
			layer = 1,
			modType = "add",
		},
		{
			image = util.getAssetName("Rooms/Base/base03_up.png"),
			x = 19,
			y = 116,
			width = 319,
			height = 224,
			layer = 3,
			modType = "replace",
		},
		{
			image = util.getAssetName("Rooms/Base/base04_up.png"),
			x = 19,
			y = 197,
			width = 372,
			height = 182,
			layer = 4,
			modType = "replace",
		},
		{
			image = util.getAssetName("Rooms/Base/base07_up.png"),
			x = 481,
			y = 355,
			width = 326,
			height = 233,
			layer = 7,
			modType = "replace",
		},
	},
	layout = 
	{
		offsetX = 385,
		offsetY = 55,
		scaleX = 1.05,
		scaleY = 1.05,
		tileWidth = 100,
		tileHeight = 50,
		numTilesX = 13,
		numTilesY = 8,
		tileOpacity = 0,
		tileTypes = {
			{
				name = "hub",
				image = util.getAssetName("Tile.png"),
				renderLayer = "Gameplay",
				hidden = true,
			},
			{
				name = "canteen",
				image = util.getAssetName("Tile.png"),
				tintR = 1,
				tintG = 0.5,
				tintB = 0.5,
				renderLayer = "Gameplay",
				exitX = 4,
				exitY = 3,
				entranceX = 5,
				entranceY = 3,
				layerMods = { 1 },
				upgradeCost = 300,
				visualName = "Lounge",
				visualDescription = "Heroes can hang out here and develop friendships.  Friends will be more effective in combat.  Friendships will develop faster at Level 2",
				centerTileX = 3,
				centerTileY = 3,
			},
			{
				name = "gym",
				image = util.getAssetName("Tile.png"),
				tintR = 0.5,
				tintG = 1,
				tintB = 0.5,
				renderLayer = "Gameplay",
				exitX = 4,
				exitY = 8,
				entranceX = 5,
				entranceY = 8,
				layerMods = { 2, 3 },
				upgradeCost = 300,
				visualName = "Gym",
				visualDescription = "The Hero can gain XP by training in the Gym.  At level 2, the Hero will gain more XP for a training session",
				centerTileX = 3,
				centerTileY = 6,
			},
			{
				name = "lab",
				image = util.getAssetName("Tile.png"),
				tintR = 1,
				tintG = 0.5,
				tintB = 1,
				renderLayer = "Gameplay",
				exitX = 10,
				exitY = 2,
				entranceX = 9,
				entranceY = 2,
				upgradeCost = 300,
				visualName = "Lab",
				visualDescription = "Research Items to purchase.  The higher the awareness the better Items you will create.  Items are half price at Level 2",
				centerTileX = 11,
				centerTileY = 3,
			},
			{
				name = "bedroom",
				image = util.getAssetName("Tile.png"),
				tintR = 0.5,
				tintG = 1,
				tintB = 1,
				renderLayer = "Gameplay",
				exitX = 10,
				exitY = 7,
				entranceX = 9,
				entranceY = 7,
				offsetX = 0,
				offsetY = 20,
				layerMods = { 4 },
				upgradeCost = 300,
				visualName = "Bedroom",
				visualDescription = "Heroes will rest here to regain all of their Health.  At Level 2 you can add more heroes to the base",
				centerTileX = 11,
				centerTileY = 6,
			},
			{
				name = "computers",
				image = util.getAssetName("Tile.png"),
				tintR = 0.2,
				tintG = 0.2,
				tintB = 0.2,
				renderLayer = "Gameplay",
				hidden = true,
			},
		},
		map = {
			2, 2, 2, 2, 1, 6, 6, 6, 1, 4, 4, 4, 4, 
			2, 2, 2, 2, 1, 1, 1, 1, 1, 4, 4, 4, 4, 
			2, 2, 2, 2, 1, 1, 1, 1, 1, 4, 4, 4, 4, 
			2, 2, 2, 2, 1, 1, 1, 1, 1, 4, 4, 4, 4, 
			3, 3, 3, 3, 1, 1, 1, 1, 1, 5, 5, 5, 5, 
			3, 3, 3, 3, 1, 1, 1, 1, 1, 5, 5, 5, 5, 
			3, 3, 3, 3, 1, 1, 1, 1, 1, 5, 5, 5, 5, 
			3, 3, 3, 3, 1, 1, 1, 1, 1, 5, 5, 5, 5, 
		},
		layermap = {
			1, 1, 1, 1, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
			1, 1, 1, 1, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
			1, 1, 1, 1, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
			1, 1, 1, 1, 3, 3, 3, 3, 3, 5, 3, 3, 3, 
			3, 3, 3, 3, 4, 4, 4, 4, 4, 7, 7, 7, 7, 
			3, 3, 3, 3, 4, 4, 4, 4, 4, 7, 7, 7, 7,  
			3, 3, 3, 3, 4, 4, 4, 4, 4, 7, 7, 7, 7, 
			3, 3, 3, 3, 4, 4, 4, 4, 4, 7, 7, 7, 7, 
		},
		transparency = {
			0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0,
			2, 2, 2, 2, 0, 0, 0, 0, 5, 6, 6, 6, 6,
			0, 0, 0, 4, 0, 0, 0, 0, 6, 0, 0, 0, 0,
			0, 0, 0, 4, 0, 0, 0, 0, 6, 0, 0, 0, 0,
			0, 0, 0, 4, 0, 0, 0, 0, 6, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0,
		}
	},
	props = {
		beds = {
			{
				x = 13,
				y = 8,
				offsetX = -20,
				offsetY = 10,
			},
			{
				x = 12,
				y = 5,
				offsetX = 10,
				offsetY = -10,
			},
			{
				x = 13,
				y = 5,
				offsetX = -30,
				offsetY = 70,
			},
		},
		level2Beds = {
			{
				x = 13,
				y = 8,
				offsetX = -20,
				offsetY = 10,
			},
			{
				x = 12,
				y = 5,
				offsetX = 10,
				offsetY = -10,
			},
			{
				x = 13,
				y = 5,
				offsetX = -30,
				offsetY = 70,
			},
			{
				x = 11,
				y = 8,
				offsetX = 0,
				offsetY = 0,
			},
			{
				x = 10,
				y = 5,
				offsetX = 35,
				offsetY = -20,
			},
			{
				x = 10,
				y = 6,
				offsetX = 90,
				offsetY = 60,
			},
		},
		desks = {
			{
				x = 11,
				y = 1,
			},
			{
				x = 13,
				y = 1,
			},
			{
				x = 11,
				y = 2,
			},
			{
				x = 13,
				y = 2,
			},
		},
		trainingEquipments = {
			{
				x = 1,
				y = 5,
				offsetX = -20,
				offsetY = 0,
				isTreadmill = false
			},
			{
				x = 2,
				y = 5,
				offsetX = -20,
				offsetY = 0,
				isTreadmill = false
			},
			{
				x = 3,
				y = 5,
				offsetX = -20,
				offsetY = 0,
				isTreadmill = false
			},
			{
				x = 1,
				y = 8,
				offsetX = 20,
				offsetY = 20,
				isTreadmill = true
			},
			{
				x = 2,
				y = 8,
				offsetX = 30,
				offsetY = 20,
				isTreadmill = true
			},
			{
				x = 3,
				y = 8,
				offsetX = 5,
				offsetY = 20,
				isTreadmill = true
			},
		},
		meetingPoints = {
			{
				x = 1,
				y = 1,
				other = 2,
				flipX = false,
			},
			{
				x = 1,
				y = 2,
				other = 1,
				flipX = true,
			},
			{
				x = 3,
				y = 1,
				other = 4,
				flipX = false,
			},
			{
				x = 3,
				y = 2,
				other = 3,
				flipX = true,
			},
		},
	},
}