return {
	layers = {
		{
			image = util.getAssetName("Rooms/Test/layer1.png"),
			width = 768,
			height = 512,
			x = 0,
			y = 0,
			priority = 0,
		},
		{
			image = util.getAssetName("Rooms/Test/layer2.png"),
			width = 768,
			height = 512,
			x = 0,
			y = 0,
			priority = 100,
		},
		{
			image = util.getAssetName("Rooms/Test/layer3.png"),
			width = 768,
			height = 512,
			x = 0,
			y = 0,
			priority = 200,
		},
		{
			image = util.getAssetName("Rooms/Test/layer4.png"),
			width = 768,
			height = 512,
			x = 0,
			y = 0,
			priority = 300,
		},
		{
			image = util.getAssetName("Rooms/Test/layer5.png"),
			width = 768,
			height = 512,
			x = 0,
			y = 0,
			priority = 400,
		},
		{
			image = util.getAssetName("Rooms/Test/layer6.png"),
			width = 768,
			height = 512,
			x = 0,
			y = 0,
			priority = 500,
		},
	},
	layout = 
	{
		offsetX = 285,
		offsetY = 60,
		tileWidth = 100,
		tileHeight = 50,
		numTilesX = 10,
		numTilesY = 6,
		tileOpacity = 0.25,
		tileTypes = {
			{
				name = "hub",
				image = util.getAssetName("Tile.png"),
				renderLayer = "Gameplay",
			},
			{
				name = "canteen",
				image = util.getAssetName("Tile.png"),
				tintR = 1,
				tintG = 0.5,
				tintB = 0.5,
				renderLayer = "Gameplay",
				exitX = 3,
				exitY = 3,
				entranceX = 4,
				entranceY = 3,
			},
			{
				name = "gym",
				image = util.getAssetName("Tile.png"),
				tintR = 0.5,
				tintG = 1,
				tintB = 0.5,
				renderLayer = "Gameplay",
				exitX = 3,
				exitY = 6,
				entranceX = 4,
				entranceY = 6,
			},
			{
				name = "lab",
				image = util.getAssetName("Tile.png"),
				tintR = 1,
				tintG = 0.5,
				tintB = 1,
				renderLayer = "Gameplay",
				exitX = 8,
				exitY = 2,
				entranceX = 7,
				entranceY = 2,
			},
			{
				name = "bedroom",
				image = util.getAssetName("Tile.png"),
				tintR = 0.5,
				tintG = 1,
				tintB = 1,
				renderLayer = "Gameplay",
				exitX = 8,
				exitY = 4,
				entranceX = 7,
				entranceY = 4,
			},
		},
		map = {
			2, 2, 2, 1, 1, 1, 1, 4, 4, 4, 
			2, 2, 2, 1, 1, 1, 1, 4, 4, 4, 
			2, 2, 2, 1, 1, 1, 1, 4, 4, 4, 
			3, 3, 3, 1, 1, 1, 1, 5, 5, 5, 
			3, 3, 3, 1, 1, 1, 1, 5, 5, 5, 
			3, 3, 3, 1, 1, 1, 1, 5, 5, 5, 
		},
		layermap = {
			1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 
			1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 
			1, 1, 1, 2, 2, 2, 2, 4, 2, 2, 
			2, 2, 2, 3, 3, 3, 3, 6, 6, 6, 
			2, 2, 2, 3, 3, 3, 3, 6, 6, 6, 
			2, 2, 2, 3, 3, 3, 3, 6, 6, 6,
		},
	},
	props = {
		beds = {
			{
				x = 9,
				y = 4,
			},
			{
				x = 10,
				y = 4,
			},
			{
				x = 9,
				y = 6,
			},
			{
				x = 10,
				y = 6,
			},
		},
		desks = {
			{
				x = 9,
				y = 1,
			},
			{
				x = 10,
				y = 1,
			},
			{
				x = 9,
				y = 3,
			},
			{
				x = 10,
				y = 3,
			},
		},
		punchingBags = {
			{
				x = 1,
				y = 4,
			},
			{
				x = 3,
				y = 4,
			},
			{
				x = 1,
				y = 6,
			},
			{
				x = 2,
				y = 6,
			},
		},
		meetingPoints = {
			{
				x = 1,
				y = 1,
				other = 2,
			},
			{
				x = 1,
				y = 2,
				other = 1,
			},
			{
				x = 2,
				y = 1,
				other = 4,
			},
			{
				x = 2,
				y = 2,
				other = 3,
			},
		},
	},
}