local Character = require('Character')
local util = require('DFUtil')
local MMNothingActivity = require('activity/MMNothingActivity')
local MMPTJobActivity = require('activity/MMPTJobActivity')
local MMTrainIntActivity = require('activity/MMTrainIntActivity')
local MMMoraleActivity = require('activity/MMMoraleActivity')
local MMPromoteActivity = require('activity/MMPromoteActivity')
local MMTrainAbilityActivity = require('activity/MMTrainAbilityActivity')
local MiddleManagerAvatar = {}

local tActivityClasses =
{
    Nothing = MMNothingActivity,
    MMPTJobActivity = MMPTJobActivity,
    MMTrainIntActivity = MMTrainIntActivity,
    MMMoraleActivity = MMMoraleActivity,
    MMPromoteActivity = MMPromoteActivity,
    MMTrainAbilityActivity = MMTrainAbilityActivity,
}

function MiddleManagerAvatar:new()
    local tSaveTable = g_Game:getSaveTable()
    if not tSaveTable.tMiddleManagerAvatar then
        tSaveTable.tMiddleManagerAvatar = {}
        tSaveTable = tSaveTable.tMiddleManagerAvatar
    end
	local Ob = Character:new('MiddleManager', tSaveTable, 1, true)

    function Ob:getActivityClass(activityType)
        return tActivityClasses[activityType]
    end

    function Ob:sayLine(lineCode, sUpperOrLower, bBlocking, bWaitForInput)
        if lineCode then
            local sLine = g_DialogManager:getString(lineCode)
            if sUpperOrLower == 'upper' then
                g_GUI:DisplayUpperDialogText(self, sLine, bBlocking, bWaitForInput)
            else
                g_GUI:DisplayLowerDialogText(self, sLine, bBlocking, bWaitForInput)
            end            
        end
    end

    function Ob:addMMTrainIntActivityAtIndex(nIndex, sDefKey)
        self:setCurActivity('MMTrainIntActivity', sDefKey)
    end	

    function Ob:addMMMoraleActivityAtIndex(nIndex, sDefKey)
        self:setCurActivity('MMMoraleActivity', sDefKey)
    end	

    function Ob:addMMPromoteActivityAtIndex(nIndex, sDefKey)
        self:setCurActivity('MMPromoteActivity', sDefKey)
    end	

    function Ob:addMMTrainAbilityActivityAtIndex(nIndex, sDefKey)
        self:setCurActivity('MMTrainAbilityActivity', sDefKey)
    end	

    function Ob:addAbilityTrainingActivityAtIndex(nIndex, sDefKey)
        self:setCurActivity('MMTrainAbilityActivity', sDefKey)
    end

    Ob:setActive(true, true)

    return Ob
end

return MiddleManagerAvatar
