module(..., package.seeall)

local util = require("DFUtil")
local Task = require("Task")
local EffectInstance = require("EffectInstance")
local TextEffectInstance = require("TextEffectInstance")

function StartEffectTask:new(rActivity, effectDef, renderLayer, x, y, priority, sTextEffectValue, blocking)
	local Ob = Task:new(rActivity, "StartEffectTask")
	Ob.effectDef = effectDef
	Ob.renderLayer = renderLayer
	Ob.x = x
	Ob.y = y
	Ob.priority = priority
	Ob.blocking = blocking
	
	function Ob:Execute()
		local effectInstance = EffectInstance:new(Ob.effectDef, Ob.renderLayer, Ob.x, Ob.y, Ob.priority, 1, sTextEffectValue)
		
		effectInstance:start()
		
		if Ob.blocking then
			while not effectInstance:isDone() do
				util.sleep(0.1)
			end
			--print("Effect finished: " .. Ob.effectDef)
		end
	end
	
	function Ob:IsDone()
		return true
	end

	return Ob
end