local util = require('DFUtil')
local Renderer = require('Renderer')
local DFAnalytics = require('DFCommon.Analytics')
local Character = require('Character')
local TutorialManager = {}


local function waitGetActiveHero()
    local rHero = g_Game:getActiveHeroes()[1]
    while not rHero do
        rHero = g_Game:getActiveHeroes()[1]
        coroutine.yield()
    end
    return rHero
end

local function patrolTutorial(self)
    self.bEnableWindowTutorials = false
    g_Game:setSaveEnabled(false)
    g_Game:setActionEnabled('RoomSelection', false)
    g_Game:setActionEnabled('Shop', false)
    g_Game:setActionEnabled('RMTPurchase', false)
    g_Game:setActionEnabled('ShowRoster', false)
    g_Game:setActionEnabled('ShowOptions', false)
    g_Game:setActionEnabled('CameraControl', false)
    g_Game:setActionEnabled('SelectHero', false)
    g_Game:setActionEnabled('CloseWindow', false)
    g_Game:setActionEnabled('ScrollMap', false)
    g_Game:setActionEnabled('ShowHeroDetails', false)
    g_Game:setActionEnabled('MMTrainInt', false)
    g_Game:setActionEnabled('MMRaiseMorale', false)
    g_Game:setActionEnabled('MMTrainAbility', false)
    g_Game:setActionEnabled('OpenMap', false)
    g_Game:setActionEnabled('ActivitySelectEnabled', false)
    g_Game:setActionEnabled('CycleHeroScheduler', false)
    g_Game:setActionEnabled('OpenTodoList', false)
    g_Game:setActionEnabled('TouchProp', false)
    g_Game:setActionEnabled('CollectMapCoins', false)
    g_Game:setActionEnabled('OpenMapEvent', false)
    g_Game:setActionEnabled('OpenAbilityPane', false)
    g_Game:setActionEnabled('CombineGems', false)
    g_Game:setActionEnabled('MMTrainAbility', false)
    g_Game:setActionEnabled('MMPromote', false)

    g_City:enableEventGeneration(false)

    local rIntroCS = g_GUI:ShowIntroCS()
    while rIntroCS:isRunning() do
        coroutine.yield()
    end
    g_GUI:HideIntroCS()
    g_GUI:GetGameOverlayUI():setVisible(false)

    Character.setPackListOverride({'packtut'})

    local rMM = g_MiddleManager:getAvatar()

    if not rMM then
        print('ERROR: Patrol Tutorial could not find MM')
        return
    end
    
    DFAnalytics.logEvent('prg_tut_rcrt_start')

    Renderer.setCameraLoc(-360, -1620)

    local tSpriteSheets =
    {
        default = { 
            "Characters/MM/MMWalkIdle",
            "Characters/MM/MMMap",
        },
    }

    rMM:setSelectable(false)
    rMM:addExtraSprites(tSpriteSheets, 'WalkIdle')
    rMM:setPosition(-315, -1725, true)
    rMM:playAnimation('breathe_reverse', false, true)
    util.sleep(1)
    g_CurrentMap:centerOnRoom('hub', 3)
    rMM:WalkToTile(28, 26) -- this blocks
    rMM:playAnimation('breathe', false, true)
    rMM:sayLine("STRT014MIDM", 'lower', true, true)
    rMM:sayLine("STRT017MIDM", 'lower', true, true)
    rMM:sayLine("STRT016MIDM", 'lower', true, true)
    rMM:playAnimation('scratch_ear', false, true)
    rMM:sayLine("STRT008MIDM", 'lower', true, true)
    g_GUI:GetGameOverlayUI():setVisible(true)
    g_GUI:GetGameOverlayUI():setTodoListVisible(false)
    g_GUI:GetGameOverlayUI():setScoreTabVisible(false)
    g_GUI:GetGameOverlayUI():update()
    rMM:playAnimation('lookat_board', false, true)
    rMM:sayLine("STRT009MIDM", 'lower', true, true)  
    rMM:sayLine("STRT020MIDM", 'lower', true, true)      
    rMM:playAnimation('breathe_reverse', false, true)    
    g_GUI:HideDialogText()    
    util.sleep(0.5)
    local tutorialPPP = 12
    g_Game:addPP(tutorialPPP)

    DFAnalytics.logEvent("ppp_ernd", { type = "tutr", amount = tutorialPPP })
    DFAnalytics.incrStat('ppp_ernd_tutr', tutorialPPP)
    g_Audio:playCue('MMOJ_Audio/UI/BuyButton')

    if g_Game:wasUserSaveReset() then
        local ppForResetUser = 50
        local coinsForResetUser = 1500
        g_Game:addPP(ppForResetUser)
        g_Game:addCash(coinsForResetUser)
        
        DFAnalytics.logEvent("ppp_ernd", { type = "beta", amount = ppForResetUser })
        DFAnalytics.incrStat('ppp_ernd_beta', ppForResetUser)
        DFAnalytics.incrStat('csh_ernd_beta', coinsForResetUser)
    end
    
    g_GUI:ShowTutorialArrow(Renderer.getUIWidth() - 283, -Renderer.getUIHeight() + 80, 90, Renderer.getUIWidth() - 280, -Renderer.getUIHeight() + 140, { 1, .88, .1, 1 })
    g_Game:setActionEnabled('Shop', true)    

    while self.sOpenedWindowName ~= 'ShopUI' do
        coroutine.yield()
    end
    
    DFAnalytics.logEvent('prg_tut_rcrt_openshop')    
    
    g_GUI:GetActivePane().rShopCategoryPane.rItemsButton:setVisible(false)
    g_GUI:GetActivePane().rShopCategoryPane.rItemsButtonText:setReveal(0)
    g_GUI:GetActivePane().rShopCategoryPane.rItemButtonTape:setVisible(false)
    g_GUI:GetActivePane().rShopCategoryPane.rEquipmentButton:setVisible(false)
    g_GUI:GetActivePane().rShopCategoryPane.rEquipmentButtonText:setReveal(0)
    g_GUI:GetActivePane().rShopCategoryPane.rEquipmentButtonTape:setVisible(false)
    g_GUI:GetActivePane().rShopCategoryPane.rCostumesButton:setVisible(false)
    g_GUI:GetActivePane().rShopCategoryPane.rCostumesButtonText:setReveal(0)
    g_GUI:GetActivePane().rShopCategoryPane.rCostumeButtonTape:setVisible(false)
    g_GUI:GetActivePane().rShopCategoryPane.rMeteoriteButton:setVisible(false)
    g_GUI:GetActivePane().rShopCategoryPane.rMeteoriteButtonText:setReveal(0)   
    g_GUI:GetActivePane().rShopCategoryPane.rMeteoriteButtonTape:setVisible(false)
    g_GUI:GetActivePane().rShopCategoryPane.rRMTButton:setVisible(false)
    g_GUI:GetActivePane().rShopCategoryPane.rRMTButtonText:setReveal(0)   
    g_GUI:GetActivePane().rShopCategoryPane.rRMTButtonTape:setVisible(false)
   
    g_GUI:GetActivePane().rBackButton:setVisible(false)
    g_GUI:GetActivePane().rInventoryText:setReveal(0)
    g_GUI:GetActivePane().rInventoryTabButton:setVisible(false)

    g_GUI:GetActivePane().rMeteoriteText:setReveal(0)
    g_GUI:GetActivePane().rMeteoriteTabButton:setVisible(false)
    -- The hide above should work, but it doesn't so...
    Renderer.getRenderLayer('UIOverlay'):removeProp(g_GUI:GetActivePane().rInventoryTabButton)
    Renderer.getRenderLayer('UIOverlay'):removeProp(g_GUI:GetActivePane().rShopTabButton)
    Renderer.getRenderLayer('UIOverlay'):removeProp(g_GUI:GetActivePane().rMeteoriteTabButton)
    g_GUI:GetActivePane().rShopCategoryPane:selectCategory("")
    g_GUI:ShowTutorialArrow(230, -150, -90, 230, -250, { 1, .88, .1, 1 })

    while self.sOpenedWindowName ~= 'HeroPackShopCategory' do
        coroutine.yield()        
    end

    DFAnalytics.logEvent('prg_tut_rcrt_selhero')

    rMM:setPosition(0, -1617, true)

    local nArrowX = Renderer.getUIWidth() - 50 - ((Renderer.getUIWidth() - 960) / 2)
    g_GUI:ShowTutorialArrow(nArrowX, -450, -90, nArrowX, -350, { 1, .88, .1, 1 })

    while self.sOpenedWindowName ~= 'HeroCardSelector' do
        coroutine.yield()        
    end
    
    DFAnalytics.logEvent('prg_tut_rcrt_buy')

    g_GUI:HideTutorialArrow()

    while self.sClosedWindowName ~= 'HeroCardSelector' do
        coroutine.yield()        
    end   
    
    g_Game:setActionEnabled('Shop', false)
    g_GUI:GetGameOverlayUI():setVisible(false)
    
    local rHero = waitGetActiveHero()
    rHero:setPosition(-90, -1617, true)
    
    DFAnalytics.logEvent('prg_tut_rcrt_pickhero', { hero = rHero:getCharDefKey() })
           
    rHero:setVisible(false)
    coroutine.yield()

    rMM:playAnimation('breathe', false, false)
    util.sleep(1)
    rMM:playAnimation('idle_fixpants', true, false)
    rMM:playAnimation('breathe', false, false)
    util.sleep(0.25)

    rHero:setVisible(true)
    g_Audio:playCue('MMOJ_Audio/SFX/HeroSFX/LandIn')
    rHero:setPlayEnterAnimForNothingActivity(false)
    rHero:playAnimation('enter', true, true)
    rHero:playAnimation('breathe', false, true)

    rHero:sayLine("STRT001FBOY", 'lower', true, true)
    g_GUI:HideDialogText()
    rHero:playAnimation('idle1', false, true)
    rMM:sayLine("STRT002MIDM", 'lower', true, true)
    rMM:sayLine("STRT003MIDM", 'lower', true, true)
    g_GUI:HideDialogText()
    rHero:sayLine("STRT004FBOY", 'lower', true, true)
    g_GUI:HideDialogText()
    rMM:sayLine("STRT005MIDM", 'lower', true, true)
    g_GUI:HideDialogText()
    rHero:sayLine("STRT006FBOY", 'lower', true, true)
    g_GUI:HideDialogText()
    rMM:sayLine("STRT007MIDM", 'lower', true, true)
    g_GUI:HideDialogText()

    rHero:playAnimation('idle1', false, true)
    util.sleep(0.25)

    rHero:runActivities(true)
    rHero:setActivityProgressPaused(true)

    g_GUI:ShowTutorialArrow(-50, 150, 90, -50, 200, { 1, .88, .1, 1 }, rHero, Renderer.getRenderLayer('GameplayOverlay'))
    
    DFAnalytics.logEvent('prg_tut_rcrt_end')
    DFAnalytics.logEvent('prg_tut_tran_start')

    g_Game:setActionEnabled('SelectHero', true)
    while self.sOpenedWindowName ~= 'HeroScheduler' do
        coroutine.yield()
    end
    g_GUI:GetActivePane().rStatHelpButton:setVisible(false)

    g_Game:setActionEnabled('SelectHero', false)
    g_Game:setActionEnabled('ActivitySelectEnabled', true)
    
    DFAnalytics.logEvent('prg_tut_tran_opensched')

    self.sOpenedWindowName = nil

    g_GUI:ShowPostIt(g_DialogManager:getString("ARWT001TEXT"), 400, -310)
    g_GUI:ShowTutorialArrow(292, -400, 0, 392, -400, { 1, .88, .1, 1})

    while not g_GUI:GetActivePane() or (g_GUI:GetActivePane() and (not g_GUI:GetActivePane().isActivitySelectorVisible or not g_GUI:GetActivePane():isActivitySelectorVisible())) do
        coroutine.yield()
    end
    
    DFAnalytics.logEvent('prg_tut_tran_picktran')

    g_GUI:ClearPostIts()
    g_GUI:ShowTutorialArrow(605, -210, 180, 505, -210, { 1, .88, .1, 1 })
    g_GUI:ShowPostIt(g_DialogManager:getString("ARWT002TEXT"), 180, -210)

    while self.sClosedWindowName ~= 'HeroScheduler' do
        coroutine.yield()
    end

    DFAnalytics.logEvent('prg_tut_tran_trintype')

    g_GUI:ClearPostIts()
    g_GUI:HideTutorialArrow()

    g_GUI:GetGameOverlayUI():setVisible(false)

    g_CurrentMap:centerOnRoom('gym', 3)

    while true do
        local rActivity = rHero:getCurActivity()
        if rActivity then
            if rActivity and rActivity.tSaved then
                if rActivity.tSaved.bInRoom then
                    break
                end
            end
        end
    end

    util.sleep(10)

    g_CurrentMap:centerOnRoom('hub', 1)
    util.sleep(1)
    rMM:sayLine("STRT010MIDM", 'lower', false, false)
    
    DFAnalytics.logEvent('prg_tut_tran_end')
    DFAnalytics.logEvent('prg_tut_mmgr_start')

    g_CurrentMap:centerOnRoom('mm', 5)

    rMM:WalkToTile(25, 25) -- this blocks
    g_CurrentMap:getRoom('mm'):openDoor()
    rMM:WalkToTile(24, 25) -- this blocks      
    rMM:WalkToTile(18, 24) -- this blocks  
    rMM:runActivities(true)
    g_GUI:HideDialogText()

    rMM:setSelectable(true)

    -- prep the heroes   
    g_GUI:ShowTutorialArrow(0, 150, 90, 0, 200, { 1, .88, .1, 1 }, rMM, Renderer.getRenderLayer('GameplayOverlay'))
    g_Game:setActionEnabled('SelectHero', true)
    self.sOpenedWindowName = nil
    while self.sOpenedWindowName ~= 'HeroScheduler' do
        coroutine.yield()
    end
    g_Game:setActionEnabled('SelectHero', false)
    
    DFAnalytics.logEvent('prg_tut_mmgr_selmgr')

    g_GUI:ShowPostIt(g_DialogManager:getString("ARWT009TEXT"), 350, -360)
    g_GUI:ShowTutorialArrow(152, -375, 0, 252, -375, { 1, .88, .1, 1})

    while not g_GUI:GetActivePane() or (g_GUI:GetActivePane() and (not g_GUI:GetActivePane().isActivitySelectorVisible or not g_GUI:GetActivePane():isActivitySelectorVisible())) do
        coroutine.yield()   
    end
    
    DFAnalytics.logEvent('prg_tut_mmgr_opensched')

    g_GUI:ClearPostIts()
    g_GUI:HideTutorialArrow()

    g_GUI:ShowTutorialArrow(520, -165, 180, 620, -165, { 1, .88, .1, 1 })
    g_GUI:ShowPostIt(g_DialogManager:getString("ARWT010TEXT"), 180, -170)

    self.sClosedWindowName = nil
    while self.sClosedWindowName ~= 'HeroScheduler' do
        coroutine.yield()
    end

    DFAnalytics.logEvent('prg_tut_mmgr_mmscheduled')

    g_GUI:ClearPostIts()
    g_GUI:HideTutorialArrow()
    rMM:setSelectable(false)
    
    DFAnalytics.logEvent('prg_tut_mmgr_end')
    DFAnalytics.logEvent('prg_tut_rush_start')

    util.sleep(4)

    g_CurrentMap:centerOnRoom('gym', 1)

    rMM:sayLine("STRT012MIDM", 'lower', true, true)
    rHero:sayLine("STRT018FBOY", 'lower', true, true)
    rMM:sayLine("STRT019MIDM", 'lower', true, true)
    g_GUI:HideDialogText()

    rHero:setActivityProgressPaused(false)

    g_GUI:ShowHeroScheduler(rHero)
    g_GUI:GetActivePane().rStatHelpButton:setVisible(false)
    g_Game:setActionEnabled('ActivitySelectEnabled', false)

    g_GUI:ShowTutorialArrow(235, -450, 90, 235, -550, { 1, .88, .1, 1 })
    g_GUI:ShowPostIt(g_DialogManager:getString("UIHT012TEXT"), 450, -350)

    local rActivity = rHero:getCurActivity()
    while rActivity and (rActivity:getActivityType() == 'Train' or rActivity:getActivityType() == 'HPTrain') do
        rActivity = rHero:getCurActivity()
        coroutine.yield()
    end
    
    DFAnalytics.logEvent('prg_tut_rush_rushed')
    
    g_GUI:HideHeroScheduler()
    g_CurrentMap:centerOnRoom('hub', 1)

    g_GUI:ClearPostIts()
    g_GUI:HideTutorialArrow()
    
    DFAnalytics.logEvent('prg_tut_rush_end')
    DFAnalytics.logEvent('prg_tut_cmbt_start')

    local rTerritory = g_City:getTerritory('PummelPark')
    if rTerritory then
        rTerritory:setEventToGenerateOverride('introevent_1')
        rTerritory:generateEvents()
    end
    g_Game:setActionEnabled('OpenMap', true)
    rHero:sayLine("STRT011FBOY", 'lower', true, true)
    rMM:sayLine("STRT015MIDM", 'lower', true, true)
    g_GUI:HideDialogText()

    g_GUI:ShowTutorialArrow(740, -130, 0, 790, -130, { 1, .88, .1, 1 })
    g_GUI:ShowPostIt(g_DialogManager:getString("ARWT002TEXT"), 580, -180)

    while not g_City:areEventsQueued() do
        coroutine.yield()
    end
        
    g_GUI:ClearPostIts()

    g_GUI:ShowPostIt(g_DialogManager:getString("ARWT004TEXT"), 0, -260)
    g_GUI:ShowTutorialArrow(120, -90, -90, 120, -140, { 1, .88, .1, 1 })    

    while self.sOpenedWindowName ~= 'TerritoryMap' do
        coroutine.yield()
    end
    self.sOpenedWindowName = nil
    
    DFAnalytics.logEvent('prg_tut_cmbt_openmap')

    g_GUI:ClearPostIts()
    g_GUI:HideTutorialArrow()

    local nInitMapXLoc = Renderer.getUIHalfWidth() - 260

    g_GUI:GetActivePane():setMapScl(0.52)
    g_GUI:GetActivePane():setMapLoc(nInitMapXLoc, -100)    

    util.sleep(1)
    g_GUI:GetActivePane():moveMapScl(0.88, 1)
    g_GUI:GetActivePane():moveMapLoc(-474 - nInitMapXLoc, 894, 1)

    util.sleep(1)

    g_GUI:ShowPostIt(g_DialogManager:getString("ARWT003TEXT"), 210, -300, nil, true, true)
    g_GUI:ShowTutorialArrow(625, -530, 90, 625, -480, { 1, .88, .1, 1 })
    while g_GUI:HasPostIts() do
        coroutine.yield()
    end
    g_GUI:HideTutorialArrow()
    g_GUI:ShowPostIt(g_DialogManager:getString("ARWT014TEXT"), 550, -150)
    g_GUI:ShowTutorialArrow(625, -530, 90, 625, -480, { 1, .88, .1, 1 })
    g_Game:setActionEnabled('OpenMapEvent', true)
    
    while self.sOpenedWindowName ~= 'EventDetail' do
        coroutine.yield()
    end
    g_GUI:ClearPostIts()
    g_GUI:HideTutorialArrow()
    
    DFAnalytics.logEvent('prg_tut_cmbt_pickevent')
    
    g_GUI:GetActivePane().rHeroPane:preventCancel()

    --g_GUI:ShowTutorialArrow(440, -570, 180, 380, -570, { 1, .88, .1, 1 })

    while self.sOpenedWindowName ~= 'EventUI' do
        coroutine.yield()        
    end
    self.sOpenedWindowName = nil
    
    DFAnalytics.logEvent('prg_tut_cmbt_aprvevent')

    g_GUI:HideTutorialArrow()

    while self.sClosedWindowName ~= 'EventEndScreen' do
        coroutine.yield()        
    end    
       
    rMM:clearExtraSprites(tSpriteSheets, 'WalkIdle')
    rMM:setSelectable(true)

    g_Game:setActionEnabled('RoomSelection', true)
    g_Game:setActionEnabled('Shop', true)
    g_Game:setActionEnabled('RMTPurchase', true)
    g_Game:setActionEnabled('ShowRoster', true)
    g_Game:setActionEnabled('ShowOptions', true)
    g_Game:setActionEnabled('CameraControl', true)
    g_Game:setActionEnabled('SelectHero', true)
    g_Game:setActionEnabled('CloseWindow', true)    
    g_Game:setActionEnabled('ScrollMap', true)
    g_Game:setActionEnabled('ShowHeroDetails', true) 
    g_Game:setActionEnabled('MMTrainInt', true)
    g_Game:setActionEnabled('MMRaiseMorale', true)
    g_Game:setActionEnabled('MMTrainAbility', true)
    g_Game:setActionEnabled('OpenMap', true)
    g_Game:setActionEnabled('ActivitySelectEnabled', true)
    g_Game:setActionEnabled('CycleHeroScheduler', true)
    g_Game:setActionEnabled('TouchProp', true)
    g_Game:setActionEnabled('CollectMapCoins', true)
    g_Game:setActionEnabled('OpenAbilityPane', true)
    g_Game:setActionEnabled('CombineGems', true)
    g_Game:setActionEnabled('MMTrainAbility', true)
    g_Game:setActionEnabled('MMPromote', true)

    g_City:enableEventGeneration(true)
    Character.setPackListOverride(nil)

    g_Game:setSaveEnabled(true)
    self.tSaved.bPatrolTutorialCompleted = true
    
    DFAnalytics.logEvent('prg_tut_cmbt_end')

    g_Audio:playCue('MMOJ_Audio/SFX/HeroSFX/LandIn')

    self.bEnableWindowTutorials = true
    self.bFromPatrolTutorial = true
    self:onTutorialCompleted()
end

local function roomTutorial(self)
    g_Game:setSaveEnabled(false)    
    g_GUI:GetGameOverlayUI():setVisible(false)
    g_Game:setActionEnabled('RoomSelection', false)
    g_Game:setActionEnabled('HubSelection', false)
    g_Game:setActionEnabled('Shop', false)
    g_Game:setActionEnabled('RMTPurchase', false)
    g_Game:setActionEnabled('ShowRoster', false)
    g_Game:setActionEnabled('ShowOptions', false)
    g_Game:setActionEnabled('SelectHero', false)
    g_Game:setActionEnabled('CloseWindow', false)
    g_Game:setActionEnabled('CameraControl', false)
    g_Game:setActionEnabled('ShowHeroDetails', false)
    g_Game:setActionEnabled('HeroTrain', false)
    g_Game:setActionEnabled('MMRaiseMorale', false)
    g_Game:setActionEnabled('MMTrainAbility', false)
    g_Game:setActionEnabled('OpenMap', false)
    g_Game:setActionEnabled('CycleHeroScheduler', false)
    g_Game:setActionEnabled('TouchProp', false)
    g_Game:setActionEnabled('OpenAbilityPane', false)

    g_City:enableEventGeneration(false)  

    g_Audio:playMusic('MMOJ_Audio/Music/MMOJ_IngameLoop', true)
    
    local rMM = g_MiddleManager:getAvatar()
    local rHero = waitGetActiveHero()
    rHero:runActivities(false)
    rHero:setSuspendWander(true)
    rMM:runActivities(false)
    rMM:setSelectable(false)
    if not rMM or not rHero then
        print('ERROR: Room Tutorial could not find MM or Hero')
        return
    end
    
    DFAnalytics.logEvent('prg_tut_room_start')

    g_CurrentMap:centerOnRoom('hub')

    local tSpriteSheets =
    {
        default = { 
            "Characters/MM/MMWalkIdle",
        },
    }

    rMM:addExtraSprites(tSpriteSheets, 'WalkIdle')

    rMM:setPosition(0, -1617, true)
    rHero:setPosition(-90, -1617, true)
    rHero:setVisible(false)

    rMM:playAnimation('breathe', false, false)
    g_GUI:SetActivePane(nil)
    g_GUI:GetGameOverlayUI():setVisible(false)

    rHero:setVisible(true)
    rHero:playAnimation('enter', true, true)
    rHero:playAnimation('breathe', false, true)

    rMM:sayLine("AFFI001MIDM", 'lower', true, true)
    g_GUI:HideDialogText()
    rHero:sayLine("AFFI002FBOY", 'lower', true, true)
    g_GUI:HideDialogText()
    rMM:sayLine("AFFI003MIDM", 'lower', true, true)
    rMM:sayLine("AFFI004MIDM", 'lower', true, true)           
    rHero:playAnimation('idle1', false, true)

    g_CurrentMap:centerOnRoom('emptyroom', 0.5)
    Renderer.setCameraScl(0.75, 0.75, 0.5)
    g_GUI:HideDialogText()
    util.sleep(0.5)

    g_GUI:ShowPostIt(g_DialogManager:getString("ARWT006TEXT"), 0, -120)
    g_GUI:ShowTutorialArrow(280, -340, 180, 380, -340, { 1, .88, .1, 1 })
    

    util.sleep(0.5)
    g_Game:setActionEnabled('RoomSelection', true)

    g_Game:setNewRoomKeyListOverride({'bedroomlvl1'})
    while self.sOpenedWindowName ~= 'RoomDetails' do
        coroutine.yield()
    end
    self.sOpenedWindowName = nil
    
    DFAnalytics.logEvent('prg_tut_room_pickrm')

    g_GUI:ClearPostIts()
    g_GUI:ShowTutorialArrow(434, -200, 0, 484, -200, { 1, .88, .1, 1 })

    while self.sClosedWindowName ~= 'RoomDetails' do
        coroutine.yield()
    end
    g_Game:setActionEnabled('RoomSelection', false)

    g_GUI:GetGameOverlayUI():setVisible(false)
    self.sClosedWindowName = nil
    
    DFAnalytics.logEvent('prg_tut_room_buyrm')

    g_GUI:HideTutorialArrow()
    Renderer.setCameraScl(1, 1)

    util.sleep(1.5)
    g_CurrentMap:centerOnRoom('hub', 1)
    util.sleep(1)
    g_GUI:GetGameOverlayUI():setVisible(false)

    rMM:sayLine("AFFI005MIDM", 'lower', true, true)
    g_GUI:HideDialogText()
    rHero:sayLine("AFFI006FBOY", 'lower', true, true)
    g_GUI:HideDialogText()
    rMM:sayLine("AFFI007MIDM", 'lower', true, true)
    g_GUI:HideDialogText()

    g_Game:setActionEnabled('CameraControl', true)
    g_GUI:ShowTutorialArrow(-50, 150, 90, -50, 280, { 1, .88, .1, 1 }, rHero, Renderer.getRenderLayer('GameplayOverlay'))

    g_Game:setActionEnabled('SelectHero', true)
    while self.sOpenedWindowName ~= 'HeroScheduler' do
        coroutine.yield()
    end
    g_GUI:GetActivePane().rStatHelpButton:setVisible(false)

    self.sOpenedWindowName = nil
    
    DFAnalytics.logEvent('prg_tut_room_opensched')

    g_GUI:ShowTutorialArrow(292, -400, 0, 392, -400, { 1, .88, .1, 1})

    rHero:runActivities(true)
    while not g_GUI:GetActivePane() or (g_GUI:GetActivePane() and (not g_GUI:GetActivePane().isActivitySelectorVisible or not g_GUI:GetActivePane():isActivitySelectorVisible())) do
        coroutine.yield()
    end
    
    DFAnalytics.logEvent('prg_tut_room_schedact')

    g_GUI:ShowTutorialArrow(580, -126, 180, 530, -126, { 1, .88, .1, 1 })

    while self.sClosedWindowName ~= 'HeroScheduler' do
        coroutine.yield()
    end
    self.sClosedWindowName = nil
        
    g_GUI:HideTutorialArrow()
    rMM:runActivities(true)
    g_CurrentMap:centerOnRoom('bedroom', 1)

    rMM:setSelectable(true)    
    g_Game:setActionEnabled('RoomSelection', true)
    g_Game:setActionEnabled('Shop', true)
    g_Game:setActionEnabled('RMTPurchase', true)
    g_Game:setActionEnabled('ShowRoster', true)
    g_Game:setActionEnabled('ShowOptions', true)
    g_Game:setActionEnabled('CameraControl', true)
    g_Game:setActionEnabled('SelectHero', true)
    g_Game:setActionEnabled('CloseWindow', true)    
    g_Game:setActionEnabled('ScrollMap', true)
    g_Game:setActionEnabled('ShowHeroDetails', true)
    g_Game:setActionEnabled('HeroTrain', true)
    g_Game:setActionEnabled('MMRaiseMorale', true)
    g_Game:setActionEnabled('MMTrainAbility', true)
    g_Game:setActionEnabled('OpenMap', true)
    g_Game:setActionEnabled('CycleHeroScheduler', true)
    g_Game:setActionEnabled('TouchProp', true)
    g_Game:setActionEnabled('HubSelection', true)
    g_Game:setActionEnabled('OpenAbilityPane', true)

    g_Game:setNewRoomKeyListOverride(nil)
    g_GUI:GetGameOverlayUI():setVisible(true)

    while rHero:getCurHP() < rHero:getMaxHP() do
        coroutine.yield()
    end

    g_City:enableEventGeneration(true)
    g_City:forceGenerateEvents()

    rMM:sayLine("STRT013TEXT", 'lower', true, true)
    g_GUI:HideDialogText()

    g_Game:setSaveEnabled(true)
    self.tSaved.bRoomTutorialCompleted = true
    
    DFAnalytics.logEvent('prg_tut_room_end')

    rHero:setSuspendWander(false)
    self:onTutorialCompleted()
end

local function getHeroTutorial(self)
    g_Game:setSaveEnabled(false)  

    while self.sClosedWindowName ~= 'EventEndScreen' do
        coroutine.yield()
    end
    g_GUI:GetGameOverlayUI():setVisible(false)

    g_Game:setActionEnabled('RoomSelection', false)
    g_Game:setActionEnabled('CameraControl', false)
    g_Game:setActionEnabled('SelectHero', false)
    g_Game:setActionEnabled('CloseWindow', false)
    g_Game:setActionEnabled('Shop', false)
    g_Game:setActionEnabled('RMTPurchase', false)
    g_Game:setActionEnabled('OpenMap', false)
    g_Game:setActionEnabled('TouchProp', false)
    g_Game:setActionEnabled('OpenAbilityPane', false)

    local tLastUsedHeroes = g_eventManager:getLastUsedHeroes()

    if tLastUsedHeroes and table.getn(tLastUsedHeroes) > 0 then
        local rMM = g_MiddleManager:getAvatar()
        local rHero = tLastUsedHeroes[1]
        
        if rMM and rHero then
            g_CurrentMap:centerOnRoom('mm')        
            rMM:sayLine("AFSF001MIDM", 'lower', true, true)
            g_GUI:HideDialogText()
            rHero:sayLine("AFSF002FBOY", 'lower', true, true)
            g_GUI:HideDialogText()
            rMM:sayLine("AFSF003MIDM", 'lower', true, true)
            g_GUI:HideDialogText()
            rHero:sayLine("AFSF004FBOY", 'lower', true, true)
            g_GUI:HideDialogText()
        end
    end

    g_Game:setActionEnabled('RoomSelection', true)
    g_Game:setActionEnabled('CameraControl', true)
    g_Game:setActionEnabled('SelectHero', true)
    g_Game:setActionEnabled('CloseWindow', true)
    g_Game:setActionEnabled('Shop', true)
    g_Game:setActionEnabled('RMTPurchase', true)
    g_Game:setActionEnabled('OpenMap', true)
    g_Game:setActionEnabled('TouchProp', true)
    g_Game:setActionEnabled('OpenAbilityPane', true)

    g_GUI:GetGameOverlayUI():setVisible(true)

    self.tSaved.bGetHeroTutorialCompleted = true

    g_Game:setSaveEnabled(true)   
end

local function itemTutorial(self)
    DFAnalytics.logEvent('prg_tut_item_start')
    g_Game:setSaveEnabled(false)
    g_GUI:GetGameOverlayUI():setVisible(false)
    g_Game:setActionEnabled('RoomSelection', false)
    g_Game:setActionEnabled('Shop', false)
    g_Game:setActionEnabled('RMTPurchase', false)
    g_Game:setActionEnabled('ShowRoster', false)
    g_Game:setActionEnabled('ShowOptions', false)
    g_Game:setActionEnabled('SelectHero', false)
    g_Game:setActionEnabled('CloseWindow', false)
    g_Game:setActionEnabled('CameraControl', false)
    g_Game:setActionEnabled('OpenMap', false)
    g_Game:setActionEnabled('CycleHeroScheduler', false)
    g_Game:setActionEnabled('OpenTodoList', false)
    g_Game:setActionEnabled('TouchProp', false)
    g_Game:setActionEnabled('OpenAbilityPane', false)

    g_City:enableEventGeneration(false)  

    g_Audio:playMusic('MMOJ_Audio/Music/MMOJ_IngameLoop', true)
    
    local rMM = g_MiddleManager:getAvatar()
    g_CurrentMap:centerOnRoom('hub')

    util.sleep(0.5)

    g_CurrentMap:centerOnRoom('mm', 1)
    rMM:sayLine("ITUT001MIDM", 'lower', true, true)
    rMM:sayLine("ITUT002MIDM", 'lower', true, true)
    rMM:sayLine("ITUT003MIDM", 'lower', true, true)
    g_GUI:HideDialogText()    

    g_GUI:GetGameOverlayUI():setVisible(true)
    local tutorialCash = 100
    g_Game:addCash(tutorialCash)
    DFAnalytics.incrStat('csh_ernd_tutr', tutorialCash)
    g_Audio:playCue('MMOJ_Audio/UI/BuyButton')

    g_GUI:ShowTutorialArrow(Renderer.getUIWidth() - 280, -Renderer.getUIHeight() + 80, 90, Renderer.getUIWidth() - 280, -Renderer.getUIHeight() + 140, { 1, .88, .1, 1 })
    g_Game:setActionEnabled('Shop', true)    

    self.sOpenedWindowName = nil
    while self.sOpenedWindowName ~= 'ShopUI' do
        coroutine.yield()
    end
    g_GUI:HideTutorialArrow()
    
    DFAnalytics.logEvent('prg_tut_item_openshop')

    g_Game:setActionEnabled('CloseWindow', true)

    self.sClosedWindowName = nil
    while self.sClosedWindowName ~= 'ShopUI' and self.sClosedWindowName ~= 'HeroCardSelector' and self.sClosedWindowName ~= 'HeroRoster' do
        coroutine.yield()
    end
    
    DFAnalytics.logEvent('prg_tut_item_leftshop')

    g_City:enableEventGeneration(true)
    g_City:forceGenerateEvents()

    rMM:sayLine("ITUT004MIDM", 'lower', true, true)
    g_GUI:HideDialogText()    

    g_Game:setSaveEnabled(true)   
    g_Game:setActionEnabled('RoomSelection', true)
    g_Game:setActionEnabled('ShowRoster', true)
    g_Game:setActionEnabled('ShowOptions', true)
    g_Game:setActionEnabled('SelectHero', true)
    g_Game:setActionEnabled('CameraControl', true)
    g_Game:setActionEnabled('OpenMap', true)
    g_Game:setActionEnabled('CycleHeroScheduler', true)
    g_Game:setActionEnabled('OpenTodoList', true)
    g_Game:setActionEnabled('TouchProp', true)
    g_Game:setActionEnabled('RMTPurchase', true)
    g_Game:setActionEnabled('OpenAbilityPane', true)

    self.tSaved.bItemTutorialCompleted = true
    DFAnalytics.logEvent('prg_tut_item_end')
end


local function newHeroTutorial(self)
    -- commenting out the analytics until we finalize this tutorial
    --DFAnalytics.logEvent('prg_tut_item_start')
    g_Game:setSaveEnabled(false)
    g_GUI:GetGameOverlayUI():setVisible(false)
    g_Game:setActionEnabled('RoomSelection', false)
    g_Game:setActionEnabled('Shop', false)
    g_Game:setActionEnabled('RMTPurchase', false)
    g_Game:setActionEnabled('ShowRoster', false)
    g_Game:setActionEnabled('ShowOptions', false)
    g_Game:setActionEnabled('SelectHero', false)
    g_Game:setActionEnabled('CloseWindow', false)
    g_Game:setActionEnabled('CameraControl', false)
    g_Game:setActionEnabled('OpenMap', false)
    g_Game:setActionEnabled('CycleHeroScheduler', false)
    g_Game:setActionEnabled('OpenTodoList', false)
    g_Game:setActionEnabled('TouchProp', false)
    g_Game:setActionEnabled('OpenAbilityPane', false)

    g_City:enableEventGeneration(false)  

    g_Audio:playMusic('MMOJ_Audio/Music/MMOJ_IngameLoop', true)
    
    local rMM = g_MiddleManager:getAvatar()
    g_CurrentMap:centerOnRoom('hub')

    util.sleep(0.5)

    g_CurrentMap:centerOnRoom('mm', 1)
    rMM:sayLine("NHRO001TEXT", 'lower', true, true)
    rMM:sayLine("NHRO002TEXT", 'lower', true, true)
    g_GUI:HideDialogText()    

    g_GUI:GetGameOverlayUI():setVisible(true)
    local tutorialPP = 10
    g_Game:addPP(tutorialPP)
    --DFAnalytics.incrStat('csh_ernd_tutr', tutorialCash)

   g_GUI:ShowTutorialArrow(Renderer.getUIWidth() - 280, -Renderer.getUIHeight() + 80, 90, Renderer.getUIWidth() - 280, -Renderer.getUIHeight() + 140, { 1, .88, .1, 1 })
    g_Game:setActionEnabled('Shop', true)    

    self.sOpenedWindowName = nil
    while self.sOpenedWindowName ~= 'ShopUI' do
        coroutine.yield()
    end
    g_GUI:GetActivePane().rShopCategoryPane:selectCategory("Heroes")
    g_GUI:HideTutorialArrow()
    
--    DFAnalytics.logEvent('prg_tut_item_openshop')

    g_Game:setActionEnabled('CloseWindow', true)

    self.sClosedWindowName = nil
    while self.sClosedWindowName ~= 'ShopUI' and self.sClosedWindowName ~= 'HeroCardSelector' and self.sClosedWindowName ~= 'HeroRoster' do
        coroutine.yield()
    end
    
--    DFAnalytics.logEvent('prg_tut_item_leftshop')

    g_City:enableEventGeneration(true)

    g_Game:setSaveEnabled(true)   
    g_Game:setActionEnabled('RoomSelection', true)
    g_Game:setActionEnabled('ShowRoster', true)
    g_Game:setActionEnabled('ShowOptions', true)
    g_Game:setActionEnabled('SelectHero', true)
    g_Game:setActionEnabled('CameraControl', true)
    g_Game:setActionEnabled('OpenMap', true)
    g_Game:setActionEnabled('CycleHeroScheduler', true)
    g_Game:setActionEnabled('OpenTodoList', true)
    g_Game:setActionEnabled('TouchProp', true)
    g_Game:setActionEnabled('AutoResolve', true)
    g_Game:setActionEnabled('RMTPurchase', true)
    g_Game:setActionEnabled('OpenAbilityPane', true)

    self.tSaved.bNewHeroTutorialCompleted = true
--    DFAnalytics.logEvent('prg_tut_item_end')
end

local function heroPackCategoryOpened(self)
    if not self.tSaved.bHeroesShopTutDone then
        g_GUI:ShowPostIt(g_DialogManager:getString("UIHT005TEXT"), 50, -200, nil, true)
        self.tSaved.bHeroesShopTutDone = true
    end
end
local function consumablesCategoryOpened(self)
    if not self.tSaved.bConsumablesTutDone then
        g_GUI:ShowPostIt(g_DialogManager:getString("UIHT003TEXT"), 50, -280, nil, true)
        self.tSaved.bConsumablesTutDone = true
    end
end
local function equipmentCategoryOpened(self)
    if not self.tSaved.bEquipmentTutDone then
        g_GUI:ShowPostIt(g_DialogManager:getString("UIHT004TEXT"), 50, -360, nil, true)
        self.tSaved.bEquipmentTutDone = true
    end
end
local function costumeCategoryOpened(self)
    if not self.tSaved.bCostumeCatTutDone then
        g_GUI:ShowPostIt(g_DialogManager:getString("UIHT006TEXT"), 50, -80, nil, true)
        self.tSaved.bCostumeCatTutDone = true
    end
end
local function eventInteractiveUIOpened(self)    
    if self.tSaved.bPatrolTutorialCompleted then
        if not self.tSaved.bMMAbilityTutorialCompleted then
            util.sleep(0.5)
            local nHalfWidth = Renderer.getUIHalfWidth()
            g_GUI:ShowPostIt(g_DialogManager:getString("ARWT015TEXT"), nHalfWidth + 150, -450, nil, true)
            g_GUI:ShowTutorialArrow(nHalfWidth - 50, -550, 0, nHalfWidth + 20, -550, { 1, .88, .1, 1  })
            self.tSaved.bMMAbilityTutorialCompleted = true
            while g_GUI:HasPostIts() and g_eventManager:getCurEvent() do
                coroutine.yield()
            end
            g_GUI:ClearPostIts()
            g_GUI:HideTutorialArrow()            
        elseif not self.tSaved.eventItemTutDone then
            local tConsumables = g_MiddleManager:getAllConsumableItemInfos()
            if tConsumables then
                local nNumItems = util.countitems(tConsumables)
                if not self.tSaved.eventItemTutDone and nNumItems > 0 then
                    g_GUI:ShowPostIt(g_DialogManager:getString("UIHT007TEXT"), 250, -40, nil, true)
                    g_GUI:ShowTutorialArrow(520, -100, 180, 640, -100, { 1, .88, .1, 1  })   
                    while not self.bItemUsed do
                        if not g_eventManager:getCurEvent() then
                            break
                        end
                        coroutine.yield()
                    end
                    self.tSaved.eventItemTutDone = true
                    g_GUI:ClearPostIts()
                    g_GUI:HideTutorialArrow()
                end
            end
        elseif not self.tSaved.meteoriteTapTutDone then
            local rEvent = g_eventManager:getCurEvent()
            if rEvent then
                local rInfo = rEvent:getMeteoriteInfo()
                if rInfo and rInfo.rMeteor then -- has a meteorite
                    self.tSaved.meteoriteTapTutDone = true
                    local meteorX, meteorY = rInfo.rMeteor:getLoc()
                    g_GUI:ShowTutorialArrow(0, -100, 180, -100, -100, { 1, .88, .1, 1  }, rInfo.rMeteor, Renderer.getRenderLayer('EventFX'))
                    while not rInfo.bTapped do
                        if not g_eventManager:getCurEvent() then
                            break
                        end                        
                        coroutine.yield()
                    end
                    g_GUI:HideTutorialArrow()        
                    self.tSaved.bQueueUpMeteoriteTutorial = true
                end
            end            
        end
    end
end

local function mapOpened(self)
    if not self.tSaved.bMapTutDone then
        g_Game:setActionEnabled('CloseWindow', false)
        g_Game:setActionEnabled('OpenMapEvent', false)
        local rMapPane = g_GUI:GetActivePane()
        g_GUI:ShowPostIt(g_DialogManager:getString("ARWT012TEXT"), 360, -150, nil, true, true)
        g_GUI:ShowTutorialArrow(585, -466, 0, 585, -466, { 1, .88, .1, 1 })
        while g_GUI:HasPostIts() do
            coroutine.yield()            
        end

        g_GUI:ShowPostIt(g_DialogManager:getString("ARWT011TEXT"), 360, -150, nil, true)
        g_GUI:ShowTutorialArrow(550, -420, 0, 500, -420, { 1, .88, .1, 1 })
        self.tSaved.bMapTutDone = true
        while g_GUI:HasPostIts() do
            coroutine.yield()            
        end
        g_Game:setActionEnabled('CloseWindow', true)
        g_Game:setActionEnabled('OpenMapEvent', true)
        g_GUI:ClearPostIts()
        g_GUI:HideTutorialArrow()
    end
end

local function eventDetailOpened(self)
    if self.tSaved.bNewHeroTutorialCompleted and not self.tSaved.bDelegateTutorialCompleted then
        local rEventDetailPane = g_GUI:GetActivePane()
        rEventDetailPane:enableAttemptButton(false)
        local rEvent = rEventDetailPane.rEvent
        while not rEvent:hasHeroesAssigned() do
            coroutine.yield()
        end
        if rEvent then
            local nHalfWidth = Renderer.getUIHalfWidth()
            g_GUI:ShowPostIt(g_DialogManager:getString("ARWT016TEXT"), nHalfWidth - 240, -10)
            g_GUI:ShowTutorialArrow(nHalfWidth + 304, -10, 0, nHalfWidth + 380, -10, { 1, .88, .1, 1 })
            while not rEvent:isAutoResolving() do
                coroutine.yield()
            end
            g_GUI:ClearPostIts()
            g_GUI:HideTutorialArrow()            
            self.tSaved.bDelegateTutorialCompleted = true
        end
    end
end

local function todoListTutorial(self)
    for k,v in pairs(g_Game.tEnabledActions) do
        g_Game.tEnabledActions[k] = false
    end
    g_Game:setActionEnabled('OpenTodoList', true)
    util.sleep(0.25)
    local nWidth = Renderer.getUIWidth()
    g_GUI:ShowPostIt(g_DialogManager:getString("ARWT018TEXT"),nWidth  - 460, -10, nil, true, true)
    g_GUI:ShowTutorialArrow(nWidth - 30, -160, -90, nWidth - 30, -110, { 1, .88, .1, 1 })
    util.sleep(1.5)
    for k,v in pairs(g_Game.tEnabledActions) do
        g_Game.tEnabledActions[k] = true
    end
    while g_GUI:HasPostIts() do
        coroutine.yield()
    end    
    g_GUI:ClearPostIts()
    g_GUI:HideTutorialArrow()
    self.tSaved.bTodoListTutorialCompleted = true
end

TutorialManager.tWindowOpenTutorials =
{
    ConsumablesShopCategory = consumablesCategoryOpened,
    EquipmentShopCategory = equipmentCategoryOpened,
    HeroPackShopCategory = heroPackCategoryOpened,
    HeroCostumeShopCategory = costumeCategoryOpened,
    EventInteractiveUI = eventInteractiveUIOpened,
    TerritoryMap = mapOpened,
    EventDetail = eventDetailOpened,
}

function TutorialManager:init(tSaved)
    local Ob = {}  
    Ob.tSaved = tSaved

    function Ob:startTutorial()
        if g_bDebugSkipTutorial then
            return false
        end
 
        g_GUI:addWindowOpenListener(self)
        g_GUI:addWindowCloseListener(self)                     

        if not self.tSaved.bPatrolTutorialCompleted then
            self.rThread = MOAIThread.new()
            self.rThread:run(patrolTutorial, self)
            return true
        end

        if not self.tSaved.bRoomTutorialCompleted then
            self.rThread = MOAIThread.new()
            self.rThread:run(roomTutorial, self)
            return true            
        end
        
        if self.tSaved.bItemTutorialStarted and not self.tSaved.bItemTutorialCompleted then
            self.rThread = MOAIThread.new()
            self.rThread:run(itemTutorial, self)
            return false -- game startup stuff can continue
        end
 
        return false
    end

    function Ob:shutdown()
        -- TODO: we need to break out of any thread that's currently running if we want to cleanly shut down the tutorial
        Ob.rThread = nil
    end

    function Ob:onTutorialCompleted()
        g_Game:saveGame()
        self:startTutorial()
    end

    function Ob:onSkullfaceDefeated()
        if not self.tSaved.bGetHeroTutorialCompleted then
            if self.rThread then
                self.rThread:stop()
            end
            self.rThread = MOAIThread.new()
            self.rThread:run(getHeroTutorial, self)
        end
    end

    function Ob:hasTutorialCompleted(sTutorialName)
        if sTutorialName == 'PatrolTutorial' then
            return (true == self.tSaved.bPatrolTutorialCompleted)
        end
    end

    function Ob:onWindowOpen(sWindowName)
        self.sOpenedWindowName = sWindowName
        if sWindowName and self.bEnableWindowTutorials then
            local tutFncn = TutorialManager.tWindowOpenTutorials[sWindowName]
            if tutFncn then
                if self.rWindowOpenThread then
                    g_GUI:ClearPostIts()
                    g_GUI:HideTutorialArrow()      
                    self.rWindowOpenThread:stop()
                end
                self.rWindowOpenThread = MOAIThread.new()
                self.rWindowOpenThread:run(tutFncn, self)
            end
        end
    end

    function Ob:onWindowClosed(sWindowName)
        self.sClosedWindowName = sWindowName
        -- we don't need to do this if we're at a much later point 
        if self.tSaved.bDelegateTutorialCompleted and not self.tSaved.bTodoListTutorialCompleted then
            self.rThread = MOAIThread.new()
            self.rThread:run(todoListTutorial, self)      
            return
        elseif sWindowName == 'EventEndScreen' then
            if not self.tSaved.bItemTutorialCompleted then
                local rTerritory = g_City:getTerritory('PummelPark')
                if rTerritory then                    
                    if rTerritory.tSaved.nCurrCrimeLevel then
                        if rTerritory.tSaved.nCurrCrimeLevel == 1 then
                            self.tSaved.bItemTutorialStarted = true
                            self.rThread = MOAIThread.new()
                            self.rThread:run(itemTutorial, self)  
                            return
                        elseif rTerritory.tSaved.nCurrCrimeLevel == 3 and not self.tSaved.bNewHeroTutorialCompleted then
                            self.tSaved.bNewHeroTutorialStarted = true
                            self.rThread = MOAIThread.new()
                            self.rThread:run(newHeroTutorial, self)
                            return
                        end
                    end
                end
            elseif self.tSaved.bQueueUpMeteoriteTutorial and not self.tSaved.bMeteoriteTutorialDone then
                g_GUI:ShowMeteoriteTutorialUI()
                self.tSaved.bMeteoriteTutorialDone = true
            end
            -- check event manager for threads to call
            g_eventManager:runEventEndScreenClosedThread()  
        end
    end

    function Ob:onItemUsed()
        self.bItemUsed = true
    end

    function Ob:getSaveVar(sVarName)
        return self.tSaved[sVarName]
    end

    Ob.sOpenedWindowName = ''
    Ob.sClosedWindowName = ''
    Ob.bFromPatrolTutorial = false
    Ob.bEnableWindowTutorials = true

    return Ob
end

return TutorialManager
