local util = require("DFUtil")
local Task = require("Task")
local WalkToTask = require("WalkToTask")
local WaitForPropTask = {}

kTIMESTEP = 0.03

function WaitForPropTask:new(rActivity, rRoom, sPropType, rUser, bTeleportOverride)
	local Ob = WalkToTask:new(rActivity, "WaitForPropTask")
    Ob.rRoom = rRoom
    Ob.sPropType = sPropType
    Ob.bIsDone = false
    Ob.rUser = rUser
    Ob.rActivity = rActivity
    if not Ob.rRoom or not Ob.sPropType then
        Ob.bIsDone = true
    end

	function Ob:Execute()
        local rAvailableProp = nil
        while true do
            rAvailableProp = rRoom:getNextAvailablePropOfType(self.sPropType)
            if not rAvailableProp then
                util.sleep(kTIMESTEP)
            else
                break
            end
        end
        self.rActivity.rAvailableProp = rAvailableProp        
        -- found one
        rAvailableProp:addUser(self.rUser)
        self.rActivity.nInteractPri = rAvailableProp:getInteractPri()
        self.rActivity.nInteractOffsetX, self.rActivity.nInteractOffsetY = rAvailableProp:getInteractOffset()
        local nRow, nCol = rAvailableProp:getInteractTileCoords()
        self:WalkToTile(nRow, nCol, bTeleportOverride or rAvailableProp:shouldTeleportToProp())
        
        self.bIsDone = true
	end
	
	function Ob:IsDone()
        return self.bIsDone
	end

	return Ob
end

return WaitForPropTask