local MMNothingActivity = {}

local util = require("DFUtil")
local Activity = require("activity/Activity")
local WalkToRoomTask = require("WalkToRoomTask")
local WaitForPropTask = require('WaitForPropTask')

local tIdleLoops = 
{
    'deskbreathe',
    'deskrelax',
--    'desktype',
    'deskfeetondesk',
}

local tIdleOneShot =
{
    deskbreathe = { 'deskdrinkcoffee', 'deskopendrawer', },
    deskrelax = { 'desksmellpits', },
    desktype = { 'desklookleft' },
}

local kIDLE_LOOP_MIN = 5
local kIDLE_LOOP_MAX = 10

local kNUM_LOOPS_MIN = 5
local kNUM_LOOPS_MAX = 15

function MMNothingActivity:new(rHero, rDef, nIndex, bRunUntilSuccess, tSaved)
	local Ob = Activity:new(rHero, rDef, nIndex, bRunUntilSuccess, tSaved)

	function Ob:Run()	
        self.rProp = self.rAvailableProp
        local nRow, nCol = self.rProp:getInteractTileCoords()
        local orgX, orgY = g_CurrentMap:getWorldCoords(nRow, nCol)
        self.rHero:setPriority(self.rProp:getInteractPri())
        local nInteractOffsetX, nInteractOffsetY = self.rProp:getInteractOffset()
		self.rHero:setLoc(orgX + nInteractOffsetX, orgY + nInteractOffsetY)
        
        self.bPlayOneShot = false
        local nMaxNumLoops = math.random(kNUM_LOOPS_MIN, kNUM_LOOPS_MAX)
        local nNumLoops = 0
        while true do
            nNumLoops = nNumLoops + 1
            if self.bPlayOneShot and self.sCurIdle then
                if tIdleOneShot[self.sCurIdle] then
                    local nMaxItems = table.getn(tIdleOneShot[self.sCurIdle])
                    self.rHero:playAnimation(tIdleOneShot[self.sCurIdle][math.random(nMaxItems)], true, false)
                end
                self.bPlayOneShot = false
            else
                self.sCurIdle = tIdleLoops[math.random(table.getn(tIdleLoops))]
                self.rHero:playAnimation(self.sCurIdle, false, false)
                util.sleep(math.random(kIDLE_LOOP_MIN, kIDLE_LOOP_MAX))
                if math.random(1, 2) == 1 then
                    self.bPlayOneShot = true
                end
            end
        end
        
		self:End()
	end

	function Ob:OnStart()
		local propName = 'mmcomp'
        local rRoom = g_CurrentMap:getRoom('mm')
        if not rRoom then
            -- exit
        end

        self.rAvailableProp = rRoom:getUnlockedPropOfType(propName)
        self.rAvailableProp:clearUsers()
        self.rAvailableProp:addUser(self.rHero)
	end

	function Ob:OnEnd()
        if self.rProp then
            self.rProp:removeUser(self.rHero)
        end
	end

	return Ob
end

return MMNothingActivity