local NothingActivity = {}

local util = require("DFUtil")
local Activity = require("activity/Activity")
local WalkToRoomTask = require("WalkToRoomTask")

local kPREIDLE_MIN = 3
local kPREIDLE_MAX = 5

function NothingActivity:new(rHero, rDef, nIndex, bRunUntilSuccess, tSaved, bDisallowWander)
	local Ob = Activity:new(rHero, rDef, nIndex, bRunUntilSuccess, tSaved, bDisallowWander)
    Ob.bDisallowWander = bDisallowWander 

	function Ob:Run()	
        if self.rHero:shouldPlayEnterAnimForNothingActivity() then
            self.rHero:setPlayEnterAnimForNothingActivity(false)            
            self.rHero:setVisible(false)
            util.sleep(1)
            self.rHero:setVisible(true)
            self.rHero:playAnimation('enter', true)
        else
            -- play an idle anim        
            local sIdleAnimName = self.rHero:getIdleAnim()
            if sIdleAnimName then
                util.sleep(math.random(kPREIDLE_MIN, kPREIDLE_MAX))
                self.rHero:playAnimation(sIdleAnimName, true)
            else
                util.sleep(Activity.kACTIVITY_DURATION)
            end
        end
	
		self:End()
	end

	function Ob:OnStart()
        if self.bDisallowWander then return end

        task = WalkToRoomTask:new(Ob, 'hub')
        Ob:AddTask(task)
        local rTile, nRow, nCol = g_CurrentMap:getRandomTile('hub')       
        if rTile then
            if self.rHero:shouldPlayEnterAnimForNothingActivity() then
                local rBaseTile = g_CurrentMap:getTile(nRow, nCol)
                local x, y = rBaseTile:getLoc()
                self.rHero:setPosition(x, y, true)
            else
                task = WalkToTileTask:new(Ob, nRow, nCol)
                Ob:AddTask(task)
            end
        end
	end

	function Ob:OnEnd()
	end

	return Ob
end

return NothingActivity
