local AlienEvent1 = {}
local AlienEvent2 = {}
local AlienEvent3 = {}
local AlienEvent4 = {}
local Event = require('event/Event')
local util = require("DFUtil")
local DFFile = require('DFCommon.File')
local Character = require("Character")
local Renderer = require('Renderer')
local DFAchievement = require('DFCommon.Achievement')

local function alienEvent1Thread(self)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    
    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('threathen_breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rHench1 = self:getActor('Enemy1')
    local rHench2 = self:getActor('Enemy2')
    local rHench3 = self:getActor('Enemy3')
    
    rHench2:setLoc(280, -100)
    rHench2:playAnimation('threathen_breathe', false, false)

    local rAlienHusk = self:getActor('AlienBodyHusk')
    rAlienHusk:insertIntoLayer(self.rLayer)
    rAlienHusk:playAnimation('lying_down', false, false)
    rAlienHusk:setLoc(150, -200)

    util.sleep(0.75)

    rHench1:sayLine("ALN1001ALIN", 'upper', true, true)
    rHench2:sayLine("ALN1002ALIN", 'upper', true, true)
    rHench3:sayLine("ALN1003ALIN", 'upper', true, true)
    rHench1:sayLine("ALN1004ALIN", 'upper', true, true)
    rHench2:sayLine("ALN1005ALIN", 'upper', true, true)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rHench1:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.2)
    rHench3:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.1)

    rHench1:playAnimation('threathen_breathe', false, false)
    rHench2:playAnimation('threathen_breathe', false, false)
    rHench3:playAnimation('threathen_breathe', false, false)

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("ALN1006HERO", 'upper', true, true)
    rHench1:sayLine("ALN1007ALIN", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { { rHench1, rHench2, rHench3 }  }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)      
        local rMM = g_MiddleManager:getAvatar()
        if rMM then
            rMM:sayLine("ALN1011MIDM", 'upper', true, true)
            rSpeakingActor = tAliveHeroes[1]
            rSpeakingActor:sayLine("ALN1008HERO", 'upper', true, true)
            rMM:sayLine("ALN1012MIDM", 'upper', true, true)
        end                
        local rHub = g_CurrentMap:getRoom('hub')
        if rHub then
            local rPizzaTable = rHub:getPropOfType('pizzatable')
            if rPizzaTable then
                rPizzaTable:unlockProp(true)
                g_Game:saveVar('PizzaTableOn', true)
            end
        end
    else
        for i, rEnemy in pairs(tAliveEnemies) do
            rEnemy:playAnimation('threathen_breathe', false, false)
        end
        rEnemy1 = tAliveEnemies[1]
        if rEnemy1 then
            rEnemy1:sayLine("ALN1010ALIN", 'upper', true, true)
        end
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self)    
end

local function alienEvent2Thread(self)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    
    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('threathen_breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rHench1 = self:getActor('Enemy1')
    local rHench2 = self:getActor('Enemy2')
    local rHench3 = self:getActor('Enemy3')
    
    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rHench1:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.2)
    rHench3:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.1)
    rHench2:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.1)

    rHench1:playAnimation('threathen_breathe', false, false)
    rHench2:playAnimation('threathen_breathe', false, false)
    rHench3:playAnimation('threathen_breathe', false, false)

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("ALN2001HERO", 'upper', true, true)
    rHench1:sayLine("ALN2002ALIN", 'upper', true, true)
    rSpeakingActor:sayLine("ALN2003HERO", 'upper', true, true)
    rHench1:sayLine("ALN2004ALIN", 'upper', true, true)
    rSpeakingActor:sayLine("ALN2005HERO", 'upper', true, true)
    rHench1:sayLine("ALN2006ALIN", 'upper', true, true)
    rSpeakingActor:sayLine("ALN2007HERO", 'upper', true, true)
    rHench1:sayLine("ALN2008ALIN", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { { rHench1, rHench2, rHench3 }  }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)      
        local rMM = g_MiddleManager:getAvatar()
        if rMM and tAliveHeroes[1] then
            rMM:sayLine("ALN2009MIDM", 'upper', true, true)
            rSpeakingActor = tAliveHeroes[1]
            rSpeakingActor:sayLine("ALN2010HERO", 'upper', true, true)
            rMM:sayLine("ALN2011MIDM", 'upper', true, true)
            rSpeakingActor:sayLine("ALN2013HERO", 'upper', true, true)
            rMM:sayLine("ALN2012MIDM", 'upper', true, true)
        end        
    else
        for i, rEnemy in pairs(tAliveEnemies) do
            rEnemy:playAnimation('threathen_breathe', false, false)
        end
        rEnemy1 = tAliveEnemies[1]
        if rEnemy1 then
            rEnemy1:sayLine("ALN2014ALIN", 'upper', true, true)
        end
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self)    
end

local function alienEvent3Thread(self)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    
    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('threathen_breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rHench1 = self:getActor('Enemy1')
    local rHench2 = self:getActor('Enemy2')
    local rHench3 = self:getActor('Enemy3')
    
    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rHench1:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.2)
    rHench3:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.1)
    rHench2:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.1)

    rHench1:playAnimation('threathen_breathe', false, false)
    rHench2:playAnimation('threathen_breathe', false, false)
    rHench3:playAnimation('threathen_breathe', false, false)

    local rSpeakingActor = tHeroActors[1]
    rHench1:sayLine("ALN3001ALIN", 'upper', true, true)
    rSpeakingActor:sayLine("ALN3002HERO", 'upper', true, true)
    rHench1:sayLine("ALN3003ALIN", 'upper', true, true)
    rSpeakingActor:sayLine("ALN3004HERO", 'upper', true, true)
    rHench1:sayLine("ALN3005ALIN", 'upper', true, true)
    rHench2:sayLine("ALN3006ALIN", 'upper', true, true)
    rSpeakingActor:sayLine("ALN3007HERO", 'upper', true, true)
    rHench1:sayLine("ALN3008ALIN", 'upper', true, true)
    rSpeakingActor:sayLine("ALN3009HERO", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { { rHench1, rHench2, rHench3 }  }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)      
        local rMM = g_MiddleManager:getAvatar()
        if rMM and tAliveHeroes[1] then
            rMM:sayLine("ALN3010MIDM", 'upper', true, true)
            rSpeakingActor = tAliveHeroes[1]
            rSpeakingActor:sayLine("ALN3011HERO", 'upper', true, true)
            rMM:sayLine("ALN3012MIDM", 'upper', true, true)
            rSpeakingActor:sayLine("ALN3013HERO", 'upper', true, true)
            rMM:sayLine("ALN3014MIDM", 'upper', true, true)
            rSpeakingActor:sayLine("ALN3015HERO", 'upper', true, true)
        end        
    else
        for i, rEnemy in pairs(tAliveEnemies) do
            rEnemy:playAnimation('threathen_breathe', false, false)
        end
        rEnemy1 = tAliveEnemies[1]
        if rEnemy1 then
            rEnemy1:sayLine("ALN3016ALIN", 'upper', true, true)
        end
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self)    
end

local function _checkHealth(rEvent)
    local rEnemy = rEvent:getActor('AlienBoss')
    if rEnemy then
        if rEnemy:getCurHP() <= 2 then
            return "Player"
        end
    end
    return nil
end

local function alienEvent4Thread(self)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    
    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('threathen_breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rBoss = self:getActor('AlienBoss')
    rBoss:setImmortal(true)
    rBoss:playAnimation('fight_breathe', false, false)
    rBoss:setLoc(340, -150)

    local rHench1 = self:getActor('Enemy1')
    local rHench2 = self:getActor('Enemy2')
    local rHench3 = self:getActor('Enemy3')
    local rHench4 = self:getActor('Enemy4')
    local rHench5 = self:getActor('Enemy5')
   
    util.sleep(0.75)

    rBoss:sayLine("ALN4001ABOS", 'upper', true, true)
    rBoss:sayLine("ALN4002ABOS", 'upper', true, true)
    rHench1:sayLine("ALN4003ALIN", 'upper', true, true)
    rHench2:sayLine("ALN4004ALIN", 'upper', true, true)
    rHench1:sayLine("ALN4005ALIN", 'upper', true, true)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("attack_breathe", true)
    end

    rHench1:playAnimation('threathen_breathe', false, false)
    util.sleep(0.1)
    rHench2:playAnimation('threathen_breathe', false, false)
    util.sleep(0.1)
    rHench3:playAnimation('threathen_breathe', false, false)
    util.sleep(0.1)
    rHench4:playAnimation('threathen_breathe', false, false)
    util.sleep(0.1)
    rHench5:playAnimation('threathen_breathe', false, false)
    util.sleep(0.1)

    local rSpeakingActor = tHeroActors[1]
    rBoss:sayLine("ALN4006ABOS", 'upper', true, true)
    rSpeakingActor:sayLine("ALN4007HERO", 'upper', true, true)
    rBoss:sayLine("ALN4008ABOS", 'upper', true, true)
    rSpeakingActor:sayLine("ALN4009HERO", 'upper', true, true)
    rBoss:sayLine("ALN4010ABOS", 'upper', true, true)
    rSpeakingActor:sayLine("ALN4011HERO", 'upper', true, true)
    rBoss:sayLine("ALN4012ABOS", 'upper', true, true)
    rSpeakingActor:sayLine("ALN4013HERO", 'upper', true, true)
    rBoss:sayLine("ALN4014ABOS", 'upper', true, true)
    rSpeakingActor:sayLine("ALN4015HERO", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens, _checkHealth)
    if bSuccessful then
        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)      
        rSpeakingActor = tAliveHeroes[1]
        if rSpeakingActor and rBoss then
            rSpeakingActor:playAnimation('breathe', true, false)
            rBoss:playAnimation('knock_out', false, false)

            rBoss:sayLine("ALN4016ABOS", 'upper', true, true)
            rSpeakingActor:sayLine("ALN4017HERO", 'upper', true, true)
            rBoss:sayLine("ALN4018ABOS", 'upper', true, true)
            rBoss:sayLine("ALN4019ABOS", 'upper', true, true)

            self.sWinnerPortraitPath, self.sWinnerPortraitIndex = rSpeakingActor:getCurPortraitPath()
            self.sLoserPortraitPath, self.sLoserPortraitIndex = rBoss:getCurPortraitPath()
        end

        local rHub = g_CurrentMap:getRoom('hub')
        if rHub then
            local rPizzaTable = rHub:getPropOfType('pizzatable')
            if rPizzaTable then
                rPizzaTable:lockProp()
                g_Game:saveVar('PizzaTableOn', false)
            end
        end

        DFAchievement.updateAchievement('BeatAlienBoss', 1) -- uncomment when I add the achievement
    else
        local tHeroActors = self:getAllHeroActors()

        if rBoss and tHeroActors then
            self.sLoserPortraitPath, self.sLoserPortraitIndex = tHeroActors[1]:getCurPortraitPath()
            self.sWinnerPortraitPath, self.sWinnerPortraitIndex = rBoss:getCurPortraitPath()

            rBoss:sayLine("ALN4020ABOS", 'upper', true, true)
        end
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self)
end


function AlienEvent1:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = alienEvent1Thread

    return Ob
end

function AlienEvent2:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = alienEvent2Thread

    return Ob
end

function AlienEvent3:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = alienEvent3Thread

    return Ob
end

function AlienEvent4:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = alienEvent4Thread

    return Ob
end

local tEvents =
{
    AlienEvent1, AlienEvent2, AlienEvent3, AlienEvent4
}

return tEvents