local CloneEvent1 = {}
local CloneEvent2 = {}
local CloneEvent3 = {}
local CloneEvent4 = {}
local Event = require('event/Event')
local util = require("DFUtil")
local DFFile = require('DFCommon.File')
local Character = require("Character")
local Renderer = require('Renderer')
local EffectInstance = require('EffectInstance')
local DFAchievement = require('DFCommon.Achievement')

local function cloneEvent1Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)

    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)

    local rCitizen = self:getActor("Citizen")   
    -- setup extra actors
    -- hack hack until we actually set these guys up as actors
    local bCitiFlipX = false
    if rCitizen.rDef == Character.getCharDef('CitiGirl') then
        bCitiFlipX = true
    end
    rCitizen:playAnimation("threathened_breathe", bCitiFlipX, false)
    self:snapActorToSlot("CitizenLocs", rCitizen)
    rCitizen:setLoc( 190, -60 )    
    rCitizen:insertIntoLayer(self.rLayer)

    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation("threathen_breathe", true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    -- hero says something
    local rSpeakingActor = tHeroActors[math.random(table.getn(tHeroActors))]
    rSpeakingActor:sayLineFromDialogset("HeroRobberyEntrance", 'upper', true, true)
    g_GUI:HideDialogText()
    
    for i, rEnemy in ipairs(tEnemies) do
        util.sleep(math.random(0.1, 0.5))
        local bBlock = false
        if i == table.getn(tEnemies) then
            bBlock = true
        end
        rEnemy:playAnimation("hero_entrance_react", true, false, bBlock)
    end
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation("hero_entrance_react_end", false, false)
    end
    g_GUI:HideDialogText()    
    local rSpeakingEnemy = tEnemies[math.random(table.getn(tEnemies))]
    rSpeakingEnemy:sayLineFromDialogset("HenchmanHeroReact", 'upper', true, true)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    rCitizen:playAnimation("watch_fight", bCitiFlipX, false)
    
    self.rEventUI:enableInteractiveUIElements(true)

    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { rCitizen }
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation("threathen_breathe", false, false)
    end
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        local rSkullface = self:getActor('Skullface')
        local rMM = g_MiddleManager:getAvatar()
        rSpeakingActor = tAliveHeroes[1]

        rSkullface:insertIntoLayer(self.rLayer)
        rSkullface:setLoc(500, -160)
        rSkullface:moveToLoc(280, -160, 2, 'run', true)
        rSkullface:playAnimation('fight_breathe', false, false)

        for i, rHero in ipairs(tAliveHeroes) do
            rHero:playAnimation('fight_breathe', true, false)
        end

        rSkullface:sayLine("CMIN001SKUL", 'upper', true, true)
        rSpeakingActor:sayLine("CMIN002HERO", 'upper', true, true)
        rSkullface:sayLine("CMIN003SKUL", 'upper', true, true)
        
        rSkullface:moveToLoc(180, -160, 1, 'run', true)
        rSkullface:playAnimation('fight_breathe', false, false)

        rSpeakingActor:sayLine("CMIN004HERO", 'upper', true, true)
        rSkullface:sayLine("CMIN005SKUL", 'upper', true, true)
        rSpeakingActor:sayLine("CMIN006HERO", 'upper', true, true)
        rSkullface:sayLine("CMIN007SKUL", 'upper', true, true)
        rSpeakingActor:sayLine("CMIN008HERO", 'upper', true, true)
        rSkullface:sayLine("CMIN009SKUL", 'upper', true, true)
        rSkullface:sayLine("CMIN010JAMS", 'upper', true, true)
        
        rSkullface:moveToLoc(60, -360, 2, 'run', true)

        rSpeakingActor:sayLine("CMIN011HERO", 'upper', true, true)
        rSpeakingActor:sayLine("CMIN012HERO", 'upper', true, true)
        rMM:sayLine("CMIN013MIDM", 'upper', true, true)
        rSpeakingActor:sayLine("CMIN014HERO", 'upper', true, true)

        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)
    else
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()

    g_eventManager:endEvent(self)
end

local function cloneEvent2Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)

    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)

    local rCitizen = self:getActor("Citizen")   
    -- setup extra actors
    -- hack hack until we actually set these guys up as actors
    local bCitiFlipX = false
    if rCitizen.rDef == Character.getCharDef('CitiGirl') then
        bCitiFlipX = true
    end
    rCitizen:playAnimation("threathened_breathe", bCitiFlipX, false)
    self:snapActorToSlot("CitizenLocs", rCitizen)
    rCitizen:insertIntoLayer(self.rLayer)

    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation("threathen_breathe", true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    -- hero says something
    local rSpeakingActor = tHeroActors[math.random(table.getn(tHeroActors))]
    rSpeakingActor:sayLineFromDialogset("HeroRobberyEntrance", 'upper', true, true)
    g_GUI:HideDialogText()
    
    for i, rEnemy in ipairs(tEnemies) do
        util.sleep(math.random(0.1, 0.5))
        local bBlock = false
        if i == table.getn(tEnemies) then
            bBlock = true
        end
        rEnemy:playAnimation("hero_entrance_react", true, false, bBlock)
    end
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation("hero_entrance_react_end", false, false)
    end
    g_GUI:HideDialogText()    
    local rSpeakingEnemy = tEnemies[math.random(table.getn(tEnemies))]
    rSpeakingEnemy:sayLineFromDialogset("HenchmanHeroReact", 'upper', true, true)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    rCitizen:playAnimation("watch_fight", bCitiFlipX, false)
    
    self.rEventUI:enableInteractiveUIElements(true)

    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { rCitizen }
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation("threathen_breathe", false, false)
    end
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        local rSkullface = self:getActor('Skullface')
        local rMM = g_MiddleManager:getAvatar()
        rSpeakingActor = tAliveHeroes[1]

        rSkullface:insertIntoLayer(self.rLayer)
        rSkullface:setLoc(500, -160)
        rSkullface:moveToLoc(280, -160, 2, 'run', true)
        rSkullface:playAnimation('fight_breathe', false, false)

        for i, rHero in ipairs(tAliveHeroes) do
            rHero:playAnimation('fight_breathe', true, false)
        end

        rSkullface:sayLine("CMP2001SKUL", 'upper', true, true)
        rSpeakingActor:sayLine("CMP2002HERO", 'upper', true, true)
        rSkullface:sayLine("CMP2003SKUL", 'upper', true, true)       
        rSpeakingActor:sayLine("CMP2004HERO", 'upper', true, true)
        rSkullface:sayLine("CMP2005SKUL", 'upper', true, true)
        rSpeakingActor:sayLine("CMP2006HERO", 'upper', true, true)
        rSkullface:sayLine("CMP2007BENY", 'upper', true, true)
        
        rSkullface:moveToLoc(600, -160, 2, "run", true)

        rSpeakingActor:sayLine("CMP2008HERO", 'upper', true, true)
        rSpeakingActor:sayLine("CMP2009HERO", 'upper', true, true)
        rMM:sayLine("CMP2010MIDM", 'upper', true, true)
        rSpeakingActor:sayLine("CMP2011HERO", 'upper', true, true)

        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)
    else
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()

    g_eventManager:endEvent(self)
end

local function cloneEvent3Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)

    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    local rSkullface1 = self:getActor('Enemy1')
    local rSkullface2 = self:getActor('Enemy2')
    local rSkullface3 = self:getActor('Enemy3')
    local rSkullface4 = self:getActor('Enemy4')

    rSkullface1:setLoc(150, -145)
    rSkullface1:insertIntoLayer(self.rLayer)
    rSkullface1:playAnimation('fight_breathe', true, false)

    rSkullface2:setLoc(200, -225)
    rSkullface2:insertIntoLayer(self.rLayer)
    rSkullface2:playAnimation('fight_breathe', false, false)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rSkullface1:playAnimation('fight_breathe', false, false)

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("CMP3001HERO", 'upper', true, true)
    rSpeakingActor:sayLine("CMP3002HERO", 'upper', true, true)
    rSkullface1:playAnimation('cheer', false, false)
    g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/SkullFaceKackle')
    util.sleep(0.2)
    rSkullface2:playAnimation('cheer', false, false)
    g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/SkullFaceKackle')
    rSkullface1:sayLine("CMP3003SKUL", 'upper', true, true)

    rSpeakingActor:sayLine("CMP3004HERO", 'upper', true, true)
    rSkullface1:playAnimation('fight_breathe', false, false)
    rSkullface2:playAnimation('fight_breathe', false, false)

    --skullface arrives!
    rSkullface3:insertIntoLayer(self.rLayer)
    rSkullface3:setLoc(600, -145)
    rSkullface3:moveToLoc(330, -145, 2, 'run', true)
    rSkullface3:playAnimation('fight_breathe', false, false)

    rSkullface3:sayLine("CMP3005BENY", 'upper', true, true)
    
    rSkullface3:moveToLoc(600, -145, 1, 'run', true)

    rSpeakingActor:sayLine("CMP3006HERO", 'upper', true, true)
    rSkullface1:sayLine("CMP3007SKUL", 'upper', true, true)
    rSpeakingActor:sayLine("CMP3008HERO", 'upper', true, true)
    rSkullface1:sayLine("CMP3009SKUL", 'upper', true, true)

    rSkullface3:setLoc(500, -145)
    rSkullface3:moveToLoc(330, -145, 2, 'run', true)
    rSkullface3:playAnimation('fight_breathe', false, false)

    rSkullface4:insertIntoLayer(self.rLayer)
    rSkullface4:setLoc(500, -225)
    rSkullface4:moveToLoc(370, -225, 2, 'run', true)
    rSkullface4:playAnimation('fight_breathe', false, false)
    
    util.sleep(2)
    rSkullface3:playAnimation('cheer', false, false)
    g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/SkullFaceKackle')
    rSkullface4:playAnimation('cheer', false, false)
    g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/SkullFaceKackle')
    
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    self.rEventUI:enableInteractiveUIElements(true)
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        rSkullface1:sayLine("CMP3011SKUL", 'upper', true, true)
        rSpeakingActor = tAliveHeroes[1]
        rSpeakingActor:sayLine("CMP3012HERO", 'upper', true, true)
        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)
    else
        rSkullface1:sayLine("CMP3013SKUL", 'upper', true, true)
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end

    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()

    g_eventManager:endEvent(self)
end

local function _checkCloneMachineHealth(rEvent)
    local rCloneMachineFoot = rEvent:getActor('CloningMachine')
    if rCloneMachineFoot then
        if rCloneMachineFoot:getCurHP() <= rCloneMachineFoot:getMaxHP() * 2/3 then
            return "Player"
        end
    end
    return nil
end

local function actorKOCB(self, rActor)
    local rCloningMachine = self:getActor('CloningMachine')
    if rActor == rCloningMachine then
        rCloningMachine:setLoc(240, -200)
        rCloningMachine:setScl(0.5)  
		
		local x,y = rCloningMachine:getLoc()
        local rEffectInstance = EffectInstance:new('Effects/Explosion.lua', Renderer.getLayer('UIOverlay').RenderLayer)
        rEffectInstance:setScl(6, 6)
        rEffectInstance:setLoc(x+530, y-350)
        rEffectInstance:start()
    end
end

local function cloneEvent4Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)
    self.actorKOCallback = actorKOCB

    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local rHench1 = self:getActor('Enemy1')
    rHench1:playAnimation('breathe', true, false)
    rHench1:insertIntoLayer(self.rLayer)
    rHench1:setLoc(60, -210)

    local rMadScientist = self:getActor('MadScientist')    
    rMadScientist:setLoc(340, -210)
    rMadScientist:insertIntoLayer(self.rLayer)

    local rCloningMachine = self:getActor('CloningMachine')
    rCloningMachine:setLoc(200, -150)
    rCloningMachine:playAnimation('breathe', false, false)
    rCloningMachine:insertIntoLayer(self.rLayer)

    local rSkullface = self:getActor('Skullface')
    rSkullface:insertIntoLayer(self.rLayer)
    rSkullface:setLoc(200, -210)
    rSkullface:playAnimation('fight_breathe', true, false)

    rSkullface:sayLine("CMBB001SKUL", 'upper', true, true)
    rMadScientist:sayLine("CMBB002MADS", 'upper', true, true)
    rSkullface:sayLine("CMBB003SKUL", 'upper', true, true)
    rSkullface:moveToLoc(600, -250, 2, 'run', true)

    rMadScientist:sayLine("CMBB004MADS", 'upper', true, true)
    rHench1:sayLine("CMBB005HMAN", 'upper', true, true)
    rMadScientist:sayLine("CMBB006MADS", 'upper', true, true)
    rMadScientist:sayLine("CMBB007MADS", 'upper', true, true)
    g_GUI:HideDialogText()
    
    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rHench1:playAnimation("hero_entrance_react", true, false, true)
    rHench1:playAnimation("hero_entrance_react_end", false, false)

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("CMBB008HERO", 'upper', true, true)
    rMadScientist:sayLine("CMBB009MADS", 'upper', true, true)
    rMadScientist:sayLine("CMBB010MADS", 'upper', true, true)
    rSpeakingActor:sayLine("CMBB011HERO", 'upper', true, true)
    rMadScientist:sayLine("CMBB012MADS", 'upper', true, true)
    rSpeakingActor:sayLine("CMBB013HERO", 'upper', true, true)
    rMadScientist:sayLine("CMBB014MADS", 'upper', true, true)
    rHench1:sayLine("CMBB015HMAN", 'upper', true, true)
    
    rHench1:moveToLoc(180, -150, 1, 'run', true)

    rHench1:setVisible(false)

    -- play effect
    local rFXLayer = Renderer.getRenderLayer('EventFX')
    local rCloningMachineEffect = EffectInstance:new('Effects/CloningMachine.lua', rFXLayer)
    local rImpactEffect = EffectInstance:new('Effects/Impact.lua', rFXLayer)
    rCloningMachineEffect:setLoc(196, -26)
    rCloningMachineEffect:setScl(1.5)
    rCloningMachineEffect:start()
    rImpactEffect:setLoc(160, -56)
    rImpactEffect:setScl(1.5)
    g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/CloneMachine')

    util.sleep(2)

    rImpactEffect:start()
    util.sleep(0.5)

    rHench1:setLoc(110, -150)
    rHench1:playAnimation('breathe', false, false)
    local rHench2 = self:getActor('Enemy2')
    rHench2:playAnimation('breathe', false, false)
    rHench2:insertIntoLayer(self.rLayer)  
    rHench2:setLoc(110, -150)
    local rHench3 = self:getActor('Enemy3')
    rHench3:playAnimation('breathe', false, false)
    rHench3:insertIntoLayer(self.rLayer)    
    rHench3:setLoc(110, -150)
    local rHench4 = self:getActor('Enemy4')
    rHench4:playAnimation('breathe', false, false)
    rHench4:insertIntoLayer(self.rLayer) 
    rHench4:setLoc(110, -150)

    local rHench5 = self:getActor('Enemy5')
    rHench5:playAnimation('breathe', false, false)
    rHench5:insertIntoLayer(self.rLayer)  
    rHench5:setLoc(110, -150)
    local rHench6 = self:getActor('Enemy6')
    rHench6:playAnimation('breathe', false, false)
    rHench6:insertIntoLayer(self.rLayer)    
    rHench6:setLoc(110, -150)
    local rHench7 = self:getActor('Enemy7')
    rHench7:playAnimation('breathe', false, false)
    rHench7:insertIntoLayer(self.rLayer) 
    rHench7:setLoc(110, -150)
    local rHench8 = self:getActor('Enemy8')
    rHench8:playAnimation('breathe', false, false)
    rHench8:insertIntoLayer(self.rLayer) 
    rHench8:setLoc(110, -150)


    rHench1:moveToLoc(60, -160, 1, 'run', false)
    rHench2:moveToLoc(80, -180, 1, 'run', false)
    rHench3:moveToLoc(60, -200, 1, 'run', false)
    rHench4:moveToLoc(80, -220, 1, 'run', false)
    rHench5:moveToLoc(120, -160, 1, 'run', false)
    rHench6:moveToLoc(140, -180, 1, 'run', false)
    rHench7:moveToLoc(120, -200, 1, 'run', false)
    rHench8:moveToLoc(140, -220, 1, 'run', false)

    util.sleep(1)

    local tEnemies = {}
    table.insert(tEnemies, rHench1)
    table.insert(tEnemies, rHench2)
    table.insert(tEnemies, rHench3)
    table.insert(tEnemies, rHench4)
    table.insert(tEnemies, rHench5)
    table.insert(tEnemies, rHench6)
    table.insert(tEnemies, rHench7)
    table.insert(tEnemies, rHench8)

    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('fight_breathe', false, false)
    end

    table.insert(tEnemies, rCloningMachine)
    rCloningMachine:setImmortal(true)

    g_GUI:HideDialogText()
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    self.rEventUI:enableInteractiveUIElements(true)
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens, _checkCloneMachineHealth)
    if bSuccessful then
        rMadScientist:sayLine("CMBB016MADS", 'upper', true, true)
        rMadScientist:sayLine("CMBB017MADS", 'upper', true, true)

        local rHench9 = self:getActor('Enemy9')
        rHench9:playAnimation('breathe', false, false)
        rHench9:insertIntoLayer(self.rLayer) 
        rHench9:setLoc(500, -100)
        rHench9:moveToLoc(380, -100, 1, 'run', true)
        rHench9:playAnimation('breathe', false, false)
        rHench9:sayLine("CMBB018HMAN", 'upper', true, true)
        rMadScientist:sayLine("CMBB019MADS", 'upper', true, true)
        rHench9:sayLine("CMBB020HMAN", 'upper', true, true)
        rMadScientist:sayLine("CMBB021MADS", 'upper', true, true)
        rHench9:moveToLoc(300, -100, 0.5, 'run', true)

        rHench9:setVisible(false)

        -- play effect
        local rFXLayer = Renderer.getRenderLayer('EventFX')
        local rCloningMachineEffect = EffectInstance:new('Effects/CloningMachine.lua', rFXLayer)
        local rImpactEffect = EffectInstance:new('Effects/Impact.lua', rFXLayer)
        rCloningMachineEffect:setLoc(196, -26)
        rCloningMachineEffect:setScl(1.5)
        rCloningMachineEffect:start()
        rImpactEffect:setLoc(160, -56)
        rImpactEffect:setScl(1.5)
        g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/CloneMachine')

        util.sleep(2)
        
        rImpactEffect:start()
        util.sleep(0.5)

        rHench9:playAnimation('breathe', false, false)
        -- play effect
        local rHench10 = self:getActor('Enemy10')
        rHench10:playAnimation('breathe', false, false)
        rHench10:insertIntoLayer(self.rLayer)  
        rHench10:setLoc(110, -150)
        local rHench11 = self:getActor('Enemy11')
        rHench11:playAnimation('breathe', false, false)
        rHench11:insertIntoLayer(self.rLayer)    
        rHench11:setLoc(110, -150)
        local rHench12 = self:getActor('Enemy12')
        rHench12:playAnimation('breathe', false, false)
        rHench12:insertIntoLayer(self.rLayer) 
        rHench12:setLoc(110, -150)
        local rHench13 = self:getActor('Enemy13')
        rHench13:playAnimation('breathe', false, false)
        rHench13:insertIntoLayer(self.rLayer) 
        rHench13:setLoc(110, -150)
        local rHench14 = self:getActor('Enemy14')
        rHench14:playAnimation('breathe', false, false)
        rHench14:insertIntoLayer(self.rLayer) 
        rHench14:setLoc(110, -150)        
        local rHench15 = self:getActor('Enemy15')
        rHench15:playAnimation('breathe', false, false)
        rHench15:insertIntoLayer(self.rLayer) 
        rHench15:setLoc(110, -150)
        local rHench16 = self:getActor('Enemy16')
        rHench16:playAnimation('breathe', false, false)
        rHench16:insertIntoLayer(self.rLayer) 
        rHench16:setLoc(110, -150)

        rHench9:moveToLoc(60, -160, 1, 'run', false)
        rHench10:moveToLoc(80, -180, 1, 'run', false)
        rHench11:moveToLoc(60, -200, 1, 'run', false)
        rHench12:moveToLoc(80, -220, 1, 'run', false)
        rHench13:moveToLoc(120, -160, 1, 'run', false)
        rHench14:moveToLoc(140, -180, 1, 'run', false)
        rHench15:moveToLoc(120, -200, 1, 'run', false)
        rHench16:moveToLoc(140, -220, 1, 'run', false)

        util.sleep(1)
        
        local tEnemies = {}
        table.insert(tEnemies, rHench9)
        table.insert(tEnemies, rHench10)
        table.insert(tEnemies, rHench11)
        table.insert(tEnemies, rHench12)
        table.insert(tEnemies, rHench13)
        table.insert(tEnemies, rHench14)
        table.insert(tEnemies, rHench15)
        table.insert(tEnemies, rHench16)
        
        for i, rEnemy in ipairs(tEnemies) do
            rEnemy:playAnimation('fight_breathe', false, false)
        end
        
        table.insert(tEnemies, rCloningMachine)
        rCloningMachine:setImmortal(false)

        g_GUI:HideDialogText()

        local tHeroes = tAliveHeroes
        local tEnemyWaves = { tEnemies }       
        local tCitizens = { }
        
        self.rEventUI:enableInteractiveUIElements(true)
        local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
        if bSuccessful then
            rMadScientist:sayLine("CMBB022MADS", 'upper', true, true)
            rMadScientist:moveToLoc(800, -210, 1, 'run', true)
            rSpeakingActor = tAliveHeroes[1]
            rSpeakingActor:sayLine("CMBB023HERO", 'upper', true, true)            
            DFAchievement.updateAchievement('BeatCloningMachine', 1)

            self.sWinnerPortraitPath, self.sWinnerPortraitIndex = tAliveHeroes[1]:getCurPortraitPath()
            self.sLoserPortraitPath, self.sLoserPortraitIndex = rMadScientist:getCurPortraitPath()

            self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)
        else        
            local tHeroActors = self:getAllHeroActors()           
            self.sLoserPortraitPath, self.sLoserPortraitIndex = tHeroActors[1]:getCurPortraitPath()
            self.sWinnerPortraitPath, self.sWinnerPortraitIndex = rMadScientist:getCurPortraitPath() 
            
            rMadScientist:playAnimation('cheer', false, false)
            rMadScientist:sayLine("CMBB024MADS", 'upper', true, true)

            self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
        end
    else
        local tHeroActors = self:getAllHeroActors()
        self.sLoserPortraitPath, self.sLoserPortraitIndex = tHeroActors[1]:getCurPortraitPath()
        self.sWinnerPortraitPath, self.sWinnerPortraitIndex = rMadScientist:getCurPortraitPath() 

        rMadScientist:playAnimation('cheer', false, false)
        rMadScientist:sayLine("CMBB024MADS", 'upper', true, true)

        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self)
end


function CloneEvent1:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = cloneEvent1Thread

    return Ob
end

function CloneEvent2:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = cloneEvent2Thread

    return Ob
end

function CloneEvent3:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = cloneEvent3Thread

    return Ob
end

function CloneEvent4:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = cloneEvent4Thread

    return Ob
end

local tEvents =
{
    CloneEvent1, CloneEvent2, CloneEvent3, CloneEvent4
}

return tEvents