local CrowbarEvent1 = {}
local CrowbarEvent2 = {}
local CrowbarEvent3 = {}
local Event = require('event/Event')
local util = require("DFUtil")
local DFFile = require('DFCommon.File')
local Character = require("Character")
local Renderer = require('Renderer')
local DFAchievement = require('DFCommon.Achievement')

local function crowbarEvent1Thread(self)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    
    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('threathen_breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rHench1 = self:getActor('Enemy1')
    local rHench2 = self:getActor('Enemy2')

    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rHench1:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.2)
    rHench2:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.1)

    rHench1:playAnimation('hero_entrance_react_end', false, false)
    rHench2:playAnimation('hero_entrance_react_end', false, false, true)

    rHench1:playAnimation('threathen_breathe', false, false)
    rHench2:playAnimation('threathen_breathe', false, false)

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("CCROW1001HERO", 'upper', true, true)
    rHench1:sayLine("CCROW1002CITZ", 'upper', true, true)
    rSpeakingActor:sayLine("CCROW1003HERO", 'upper', true, true)
    rHench1:sayLine("CCROW1004CITZ", 'upper', true, true)
    rSpeakingActor:sayLine("CCROW1005HERO", 'upper', true, true)
    rHench1:sayLine("CCROW1006CITZ", 'upper', true, true)
    rSpeakingActor:sayLine("CCROW1007HERO", 'upper', true, true)
    rHench2:sayLine("CCROW1008CITZ", 'upper', true, true)
    rSpeakingActor:sayLine("CCROW1009HERO", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        local rCitizen = self:getActor('HiddenCitizen')
        if rCitizen then
            rCitizen:sayLine("CCROW1010CITZ", 'upper', true, true)
        end
        rSpeakingActor = tAliveHeroes[1]
        rSpeakingActor:playAnimation('breathe', true, false)
        rSpeakingActor:sayLine("CCROW1011HERO", 'upper', true, true)

        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)      
    else
        for i, rEnemy in pairs(tAliveEnemies) do
            rEnemy:playAnimation('threathen_breathe', false, false)
        end
        rEnemy1 = tAliveEnemies[1]
        if rEnemy1 then
            rEnemy1:sayLine("CCROW1012CITZ", 'upper', true, true)
        end
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self)    
end

local function crowbarEvent2Thread(self)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    
    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('threathen_breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rHench1 = self:getActor('Enemy1')
    local rHench2 = self:getActor('Enemy2')
    local rHench3 = self:getActor('Enemy3')
    local rHench4 = self:getActor('Enemy4')

    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rHench1:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.2)
    rHench2:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.2)
    rHench4:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.2)
    rHench3:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.2)

    rHench1:playAnimation('hero_entrance_react_end', false, false)
    rHench2:playAnimation('hero_entrance_react_end', false, false)
    rHench3:playAnimation('hero_entrance_react_end', false, false)
    rHench4:playAnimation('hero_entrance_react_end', false, false, true)

    rHench1:playAnimation('threathen_breathe', false, false)
    rHench2:playAnimation('threathen_breathe', false, false)
    rHench3:playAnimation('threathen_breathe', false, false)
    rHench4:playAnimation('threathen_breathe', false, false)

    local rSpeakingActor = tHeroActors[1]
    rHench1:sayLine("CCROW2001CITZ", 'upper', true, true)
    rSpeakingActor:sayLine("CCROW2003HERO", 'upper', true, true)
    rSpeakingActor:sayLine("CCROW2011HERO", 'upper', true, true)
    rHench1:sayLine("CCROW2004CITZ", 'upper', true, true)
    rHench2:sayLine("CCROW2005CITZ", 'upper', true, true)
    rSpeakingActor:sayLine("CCROW2006HERO", 'upper', true, true)
    rHench2:sayLine("CCROW2007CITZ", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        local rCitizen = self:getActor('HiddenCitizen')
        if rCitizen then
            rCitizen:sayLine("CCROW2009CITZ", 'upper', true, true)
        end
        rSpeakingActor = tAliveHeroes[1]
        rSpeakingActor:playAnimation('breathe', true, false)
        rSpeakingActor:sayLine("CCROW2008HERO", 'upper', true, true)

        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)      
    else
        for i, rEnemy in pairs(tAliveEnemies) do
            rEnemy:playAnimation('threathen_breathe', false, false)
        end
        local rCitizen = self:getActor('HiddenAlienBody')
        if rCitizen then
            rCitizen:sayLine("CCROW2010CITZ", 'upper', true, true)
        end
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self)
end

local function _checkHealth(rEvent)
    local rEnemy = rEvent:getActor('Enemy1')
    if rEnemy then
        if rEnemy:getCurHP() <= 2 then
            return "Player"
        end
    end
    return nil
end

local function crowbarEvent3Thread(self)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    
    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('attack_breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rCrowbar = self:getActor('Enemy1')
    rCrowbar:setImmortal(true)

    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("attack_breathe", true)
    end

    rCrowbar:playAnimation('attack_breathe', false, false)

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("CCROW3001HERO", 'upper', true, true)
    rCrowbar:sayLine("CCROW3002CROW", 'upper', true, true)
    rSpeakingActor:sayLine("CCROW3003HERO", 'upper', true, true)
    rCrowbar:sayLine("CCROW3004CROW", 'upper', true, true)
    rCrowbar:sayLine("CCROW3005CROW", 'upper', true, true)
    rCrowbar:sayLine("CCROW3006CROW", 'upper', true, true)
    rSpeakingActor:sayLine("CCROW3007HERO", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens, _checkHealth)
    if bSuccessful then
        rSpeakingActor = tAliveHeroes[1]
        if rSpeakingActor and rCrowbar then
            rSpeakingActor:playAnimation('breathe', true, false)
            rCrowbar:playAnimation('breathe', false, false)

            rCrowbar:sayLine("CCROW3008CROW", 'upper', true, true)
            rCrowbar:sayLine("CCROW3009CROW", 'upper', true, true)
            rSpeakingActor:sayLine("CCROW3010HERO", 'upper', true, true)
            rCrowbar:sayLine("CCROW3011CROW", 'upper', true, true)
            rCrowbar:sayLine("CCROW3012CROW", 'upper', true, true)
            rSpeakingActor:sayLine("CCROW3013HERO", 'upper', true, true)
            rSpeakingActor:sayLine("CCROW3014HERO", 'upper', true, true)
            rCrowbar:sayLine("CCROW3015CROW", 'upper', true, true)

            self.sWinnerPortraitPath, self.sWinnerPortraitIndex = rSpeakingActor:getCurPortraitPath()
            self.sLoserPortraitPath, self.sLoserPortraitIndex = rCrowbar:getCurPortraitPath()
        end

        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)      
        g_Game:saveVar('CosmicCrowbarUnlocked', true)

        DFAchievement.updateAchievement('BeatCrowbar', 1) -- uncomment when I add the achievement
    else
        local tHeroActors = self:getAllHeroActors()

        if rCrowbar and tHeroActors then
            self.sLoserPortraitPath, self.sLoserPortraitIndex = tHeroActors[1]:getCurPortraitPath()
            self.sWinnerPortraitPath, self.sWinnerPortraitIndex = rCrowbar:getCurPortraitPath()

            rCrowbar:sayLine("CCROW3016CROW", 'upper', true, true)
        end
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self)
end


function CrowbarEvent1:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = crowbarEvent1Thread

    return Ob
end

function CrowbarEvent2:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = crowbarEvent2Thread

    return Ob
end

function CrowbarEvent3:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = crowbarEvent3Thread

    return Ob
end

local tEvents =
{
    CrowbarEvent1, CrowbarEvent2, CrowbarEvent3
}

return tEvents