local IntroEvent1 = {}
local IntroEvent1 = {}
local IntroEvent2 = {}
local IntroEvent3 = {}
local Event = require('event/Event')
local util = require("DFUtil")
local DFFile = require('DFCommon.File')
local Character = require("Character")
local Renderer = require('Renderer')
local DFAnalytics = require('DFCommon.Analytics')
local DFAchievement = require('DFCommon.Achievement')

local function onIntro1EventClosedCallback()
    g_Game:onTutorialCompleted('introfight_1')
    return false
end

local function introEvent1Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    local rFanboy = tHeroActors[1]

    local rCitizen = self:getActor('Citizen')   
    -- setup extra actors
    -- hack hack until we actually set these guys up as actors
    rCitizen:playAnimation('threathened_breathe', false, false)
    self:snapActorToSlot('CitizenLocs', rCitizen)
    rCitizen:insertIntoLayer(self.rLayer)
    
    local rThug = self:getActor('Enemy1')
    self:moveAllEnemiesToSlot({ rThug }, true)
    rThug:playAnimation('threathen_breathe', true, false)
    rThug:insertIntoLayer(self.rLayer)

    util.sleep(0.75)
    
    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)

        rHeroActor:enter(true)
        rHeroActor:playAnimation("attack_breathe", true)
    end
    local rVeteran = self:getActor('Veteran')
    rVeteran:setLoc(-360, -60)
    rVeteran:insertIntoLayer(self.rLayer)
    rVeteran:enter(true)
    rVeteran:playAnimation("breathe", true)

    tHeroActors[1]:setImmortal(true)

    rThug:playAnimation('hero_entrance_react', true, false)
        
    rThug:sayLine("ICBT001GTHG", 'upper', true, true)
    g_GUI:HideDialogText()
    rThug:playAnimation("breathe", false)
    
    rVeteran:sayLine("ICBT002VTRN", 'upper', true, true)
     
    rFanboy:sayLine("ICBT003FBOY", 'upper', true, true)
    
    rVeteran:sayLine("ICBT004VTRN", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rThug:playAnimation("fight_breathe", false)
    rThug:sayLine("ICBT005GTHG", 'upper', true, true)
    g_GUI:HideDialogText()
    rThug:playAnimation("breathe", false)
    
    rVeteran:sayLine("ICBT006VTRN", 'upper', true, true)
     
    --rFanboy:sayLine("ICBT007FBOY", 'upper', true, true)

    util.sleep(1)
    
    rThug:playAnimation('hero_entrance_react_end', false, false)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    rCitizen:playAnimation('watch_fight', false, false)
    
    -- fight!
    local tHeroes = { tHeroActors[1] }
    local tEnemyWaves = { { rThug } }
    local tCitizens = { rCitizen }

    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens, nil, true)
    
    DFAnalytics.logEvent('prg_tut_cmbt_basic')

    DFAnalytics.logEvent('prg_tut_cmbt_thug1')
        
    -- can't lose
    self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens, true)
    rFanboy:playAnimation('breathe', false, false, true)
    rFanboy:sayLine("ICBT008FBOY", 'upper', true, true)        
    rVeteran:sayLine("ICBT009VTRN", 'upper', true, true)        
    rFanboy:sayLine("ICBT010FBOY", 'upper', true, true)
    rVeteran:sayLine("ICBT011VTRN", 'upper', true, true)

    local rEnemy2 = self:getActor('Enemy2')
    local rEnemy3 = self:getActor('Enemy3')

    rEnemy2:setLoc(540, -125)
    rEnemy2:insertIntoLayer(self.rLayer)

    rEnemy3:setLoc(540, -200)
    rEnemy3:insertIntoLayer(self.rLayer)

    rEnemy2:moveToLoc(0, -125, 3, "run", false)
    rEnemy3:moveToLoc(20, -200, 3, "run", true)
    rCitizen:playAnimation('watch_fight', false, false)

    rEnemy2:playAnimation('threathen_breathe', false, false)
    rEnemy3:playAnimation('threathen_breathe', false, false)

    rFanboy:playAnimation('attack_breathe', true, false)
    rFanboy:sayLine("ICBT012FBOY", 'upper', true, true)
    
    rVeteran:sayLine("ICBT013VTRN", 'upper', true, true)

    --rFanboy:sayLine("ICBT014FBOY", 'upper', true, true)

    rVeteran:sayLine("ICBT015VTRN", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rEnemy2:playAnimation('fight_breathe', false)
    rEnemy2:sayLine("ICBT016GTHG", 'upper', true, true)
   
    g_GUI:HideDialogText()
    rEnemy2:playAnimation('breathe', false)    
    rVeteran:sayLine("ICBT018VTRN", 'upper', true, true)    
    --rFanboy:sayLine("ICBT019FBOY", 'upper', true, true)
    g_GUI:HideDialogText()

    g_GUI:ShowTutorialArrow(120, -10, 0, 170, -10, { 1, .88, .1, 1  })
    g_GUI:ShowPostIt(g_DialogManager:getString("UIHT002TEXT"), 300, -30)

    self.rEventUI:enableInteractiveUIElements(true)    
    self.rEventUI:enableMMAbilities(false)
    while rFanboy:getQueuedAbility() == nil do
        coroutine.yield()
    end
    
    DFAnalytics.logEvent('prg_tut_cmbt_ability')

    g_GUI:HideTutorialArrow()
    g_GUI:ClearPostIts()
        
    local tHeroes = { rFanboy }
    local tEnemyWaves = { { rEnemy2, rEnemy3 }, }
    local tCitizens = { rCitizen }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens, nil, true)
    self.rEventUI:enableInteractiveUIElements(false)    
    -- can't lose
    self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens, true)  
  
    DFAnalytics.logEvent('prg_tut_cmbt_thug2') 

    rFanboy:playAnimation('breathe', false, false, true)
    rFanboy:sayLine("ICBT023FBOY", 'upper', true, true)    
    rVeteran:sayLine("ICBT024VTRN", 'upper', true, true)        
    rFanboy:sayLine("ICBT025FBOY", 'upper', true, true)
    rVeteran:sayLine("ICBT026VTRN", 'upper', true, true)
    rFanboy:sayLine("ICBT027FBOY", 'upper', true, true)        
    rVeteran:sayLine("ICBT028VTRN", 'upper', true, true)
    g_GUI:HideDialogText()        
    
    --skullface arrives!
    local rSkullface = self:getActor('Skullface')
    rSkullface:insertIntoLayer(self.rLayer)
    rSkullface:setLoc(500, -160)
    rSkullface:moveToLoc(280, -160, 2, 'run', true)
    rCitizen:playAnimation('threathened_breathe', true, false)
    rSkullface:playAnimation('fight_breathe', false, false)
    
    rFanboy:playAnimation('attack_breathe', true, false)
    
    rSkullface:sayLine("ICBT029VIL1", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rVeteran:sayLine("ICBT051CPRM", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSkullface:sayLine("ICBT031VIL1", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rVeteran:sayLine("ICBT033VTRN", 'upper', true, true)
    
    rVeteran:sayLine("ICBT034VTRN", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSkullface:playAnimation("cheer", false, false)
    g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/SkullFaceKackle')
    rSkullface:sayLine("ICBT035VIL1", 'upper', true, true)
    g_GUI:HideDialogText()
    rSkullface:playAnimation("fight_breathe", false, false)
    
    rFanboy:sayLine("ICBT036FBOY", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSkullface:playAnimation("fight_breathe", false, false)
    rSkullface:sayLine("ICBT037VIL1", 'upper', true, true)
    g_GUI:HideDialogText()
    
    --skullface leaves
    rSkullface:moveToLoc(600, -160, 2, "run", true)
    
    rFanboy:playAnimation('breathe', false, false)
    
    rVeteran:sayLine("ICBT038VTRN", 'upper', true, true)
    
    rVeteran:sayLine("ICBT039VTRN", 'upper', true, true)
    g_GUI:HideDialogText()
    
    --veteran leaves
    rVeteran:moveToLoc(-600, -60, 2, "run", true)
    
    util.sleep(2)
    
    --skullface returns!
    rSkullface:moveToLoc(280, -160, 2, "run", true)
    
    rSkullface:playAnimation("cheer", false, false)
    g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/SkullFaceKackle')
    
    rFanboy:playAnimation("attack_breathe", true, false)
    
    rSkullface:sayLine("ICBT040VIL1", 'upper', true, true)
    g_GUI:HideDialogText()        
    
    rFanboy:sayLine("ICBT041FBOY", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSkullface:sayLine("ICBT044VIL1", 'upper', true, true)
    g_GUI:HideDialogText()
    
    --skullface leaves
    rSkullface:moveToLoc(600, -160, 2, "run", true)
    
    util.sleep(1)          

    self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)

    -- must be set to be successful
    self:setSuccessful(true)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    DFAnalytics.logEvent('prg_tut_cmbt_victory')  
    
    g_eventManager:endEvent(self)
end

local function introEvent3Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)  

    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    local rFanboy = tHeroActors[1]
    local rVeteran = self:getActor('Veteran')
    
    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end
    local rSkullface = self:getActor('Skullface')
    rSkullface:playAnimation('fight_breathe', false, false)
    rSkullface:setLoc(240, -104)
    local rThug = self:getActor('Enemy2')
    a = self:getActor('Enemy1')
    b = self:getActor('Skullface')

    rSkullface:sayLine("SFBB001VIL1", 'upper', true, true)
    g_GUI:HideDialogText()

    rThug:sayLine("SFBB002GTHG", 'upper', true, true)
    g_GUI:HideDialogText()

    rSkullface:sayLine("SFBB003VIL1", 'upper', true, true)
    g_GUI:HideDialogText()

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)	            
        rHeroActor:enter(true)
        rHeroActor:playAnimation('attack_breathe', true)
    end

    for i, rEnemy in ipairs(tEnemies) do
        if rEnemy ~= rSkullface then
            util.sleep(math.random(0.3, 0.7))
            rEnemy:playAnimation('hero_entrance_react', true, false)
        end
    end
    g_GUI:HideDialogText()
    
    rFanboy:sayLine("SFBB004FBOY", 'upper', true, true)
    g_GUI:HideDialogText()
    
    for i, rEnemy in ipairs(tEnemies) do
        if rEnemy ~= rSkullface then
            rEnemy:playAnimation('hero_entrance_react_end', false, false)
        end
    end

    rSkullface:playAnimation("fight_breathe", false, false)
    rSkullface:sayLine("SFBB005VIL1", 'upper', true, true)

    rFanboy:playAnimation('breathe', true, false)
    rFanboy:sayLine("SFBB006FBOY", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSkullface:sayLine("SFBB007VIL1", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rFanboy:sayLine("SFBB008FBOY", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSkullface:playAnimation("cheer", false, false)
    g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/SkullFaceKackle')

    rSkullface:sayLine("SFBB009VIL1", 'upper', true, true)
    rSkullface:playAnimation("fight_breathe", false, false)
    g_GUI:HideDialogText()
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    local tFirstWave = {}
    for i, rEnemy in ipairs(tEnemies) do
        if rEnemy ~= rSkullface then
            table.insert(tFirstWave, rEnemy)
        end
    end
    -- fight!
    local tHeroes = tHeroActors 
    local tEnemyWaves = { tFirstWave }
    local tCitizens = { }

    self.rEventUI:enableInteractiveUIElements(true)
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        rFanboy:playAnimation("fight_breathe", true, false)
        rFanboy:sayLine("SFBB011FBOY", 'upper', true, true)
        g_GUI:HideDialogText()
        rSkullface:sayLine("SFBB013VIL1", 'upper', true, true)
        g_GUI:HideDialogText()
        
        tHeroes = tHeroActors 
        tEnemyWaves = { { rSkullface } }
        bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    
        if bSuccessful then
            rSkullface:sayLine("SFBB014VIL1", 'upper', true, true)
            g_GUI:HideDialogText()
            self.sWinnerPortraitPath, self.sWinnerPortraitIndex =  tAliveHeroes[1]:getCurPortraitPath()
            self.sLoserPortraitPath, self.sLoserPortraitIndex = rSkullface:getCurPortraitPath() 
            rFanboy:sayLine("SFBB015FBOY", 'upper', true, true)
            self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)  

            DFAchievement.updateAchievement('BeatSkullface', 1)
            g_Game:getTutorialManager():onSkullfaceDefeated()
        else
            tHeroActors = self:getAllHeroActors()
            self.sLoserPortraitPath, self.sLoserPortraitIndex = tHeroActors[1]:getCurPortraitPath()
            self.sWinnerPortraitPath, self.sWinnerPortraitIndex = rSkullface:getCurPortraitPath() 
            rSkullface:sayLine("SFBB016VIL1", 'upper', true, true)            
            self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
        end
        
    else
        tHeroActors = self:getAllHeroActors()
        self.sLoserPortraitPath, self.sLoserPortraitIndex = tHeroActors[1]:getCurPortraitPath()
        self.sWinnerPortraitPath, self.sWinnerPortraitIndex = rSkullface:getCurPortraitPath() 
        rSkullface:sayLine("SFBB016VIL1", 'upper', true, true)
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    self:setSuccessful(bSuccessful)
    
    g_GUI:HideDialogText()
    g_eventManager:endEvent(self)

end

function IntroEvent1:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = introEvent1Thread

    return Ob
end

function IntroEvent2:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = introEvent2Thread

    return Ob
end

function IntroEvent3:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = introEvent3Thread

    return Ob
end

local tEvents =
{
    IntroEvent1, IntroEvent2, IntroEvent3
}

return tEvents
