local PortalEvent1 = {}
local PortalEvent2 = {}
local PortalEvent3 = {}
local Event = require('event/Event')
local util = require("DFUtil")
local DFFile = require('DFCommon.File')
local Character = require("Character")
local Renderer = require('Renderer')
local DFAchievement = require('DFCommon.Achievement')

local function portalEvent1Thread(self)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    
    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rHench1 = self:getActor('Enemy1')
    local rHench2 = self:getActor('Enemy2')
    local rHench3 = self:getActor('Enemy3')
    local rHench4 = self:getActor('Enemy4')
    local rHench5 = self:getActor('Enemy5')
    local rHench6 = self:getActor('Enemy6')

    rHench4:playAnimation('breathe', false, false)
    rHench5:playAnimation('breathe', false, false)
    rHench6:playAnimation('breathe', false, false)

    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rHench4:playAnimation('threathen_breathe', false, false)
    rHench5:playAnimation('threathen_breathe', false, false)
    rHench6:playAnimation('threathen_breathe', false, false)

    rHench2:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.2)
    rHench1:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.1)
    rHench3:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(1)

    rHench1:playAnimation('hero_entrance_react_end', false, false)
    rHench2:playAnimation('hero_entrance_react_end', false, false)
    rHench3:playAnimation('hero_entrance_react_end', false, false)

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("PINT001HERO", 'upper', true, true)

    rHench1:sayLine("PINT002HMAN", 'upper', true, true)
    rSpeakingActor:sayLine("PINT003HERO", 'upper', true, true)
    rHench1:sayLine("PINT004HMAN", 'upper', true, true)
    rHench2:sayLine("PINT005HMAN", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)
    else
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self, onIntro1EventClosedCallback)    
end

local function portalEvent2Thread(self)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)
    
    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rHench1 = self:getActor('Enemy1')
    local rHench2 = self:getActor('Enemy2')
    local rHench3 = self:getActor('Enemy3')
    local rHench4 = self:getActor('Enemy4')
    local rHench5 = self:getActor('Enemy5')
    local rHench6 = self:getActor('Enemy6')

    rHench4:playAnimation('breathe', false, false)
    rHench5:playAnimation('breathe', false, false)
    rHench6:playAnimation('breathe', false, false)

    local rMadScientist = self:getActor('MadScientist')    
    rMadScientist:setLoc(180, -230)
    rMadScientist:insertIntoLayer(self.rLayer)

    util.sleep(0.75)

    rMadScientist:sayLine("PTWO001MADS", 'upper', true, true)
    rHench1:sayLine("PTWO002HMAN", 'upper', true, true)
    rMadScientist:sayLine("PTWO003MADS", 'upper', true, true)
    rHench1:sayLine("PTWO004HMAN", 'upper', true, true)
    rMadScientist:sayLine("PTWO005MADS", 'upper', true, true)
    rHench1:sayLine("PTWO006HMAN", 'upper', true, true)
    rMadScientist:sayLine("PTWO007MADS", 'upper', true, true)
    g_GUI:HideDialogText() 
    
    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rHench4:playAnimation('threathen_breathe', false, false)
    rHench5:playAnimation('threathen_breathe', false, false)
    rHench6:playAnimation('threathen_breathe', false, false)

    rHench2:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.2)
    rHench1:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(0.1)
    rHench3:playAnimation('hero_entrance_react', true, false, false)
    util.sleep(1)

    rHench1:playAnimation('hero_entrance_react_end', false, false)
    rHench2:playAnimation('hero_entrance_react_end', false, false)
    rHench3:playAnimation('hero_entrance_react_end', false, false)

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("PTWO008HERO", 'upper', true, true)

    rHench1:sayLine("PTWO009HMAN", 'upper', true, true)
    rMadScientist:sayLine("PTWO010MADS", 'upper', true, true)
    g_GUI:HideDialogText()   
    util.sleep(1)    
    rMadScientist:moveToLoc(580, -230, 1, 'run', true)
    util.sleep(3)
    rSpeakingActor:sayLine("PTWO011HERO", 'upper', true, true)
    rHench1:sayLine("PTWO012HMAN", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)
    else
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self, onIntro1EventClosedCallback)    
end

local function portalEvent3Thread(self)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)

    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rMadScientist = self:getActor('MadScientist')    
    rMadScientist:setLoc(340, -210)
    rMadScientist:insertIntoLayer(self.rLayer)

    local rHench1 = self:getActor('Enemy1')

    util.sleep(0.75)

    rMadScientist:sayLine("PBAT001MADS", 'upper', true, true)

    rHench1:sayLine("PBAT002HMAN", 'upper', true, true)

    rMadScientist:sayLine("PBAT003MADS", 'upper', true, true)

    rHench1:sayLine("PBAT004HMAN", 'upper', true, true)

    rMadScientist:sayLine("PBAT005MADS", 'upper', true, true)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("PBAT006HERO", 'upper', true, true)

    for i, rEnemy in ipairs(tEnemies) do
        if rEnemy ~= rRocketLauncher then
            util.sleep(math.random(0.2, 0.4))
            rEnemy:playAnimation("hero_entrance_react", true, false)
        end
    end
    
    util.sleep(1)
    
    for i, rEnemy in ipairs(tEnemies) do
        if rEnemy ~= rRocketLauncher then
            rEnemy:playAnimation("hero_entrance_react_end", false, false)
        end
    end

    rMadScientist:sayLine("PBAT007MADS", 'upper', true, true)
    rMadScientist:sayLine("PBAT008MADS", 'upper', true, true)
    rMadScientist:sayLine("PBAT009MADS", 'upper', true, true)
    rMadScientist:sayLine("PBAT010MADS", 'upper', true, true)
    rSpeakingActor:sayLine("PBAT011HERO", 'upper', true, true)
    rMadScientist:sayLine("PBAT012MADS", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    -- fight!
    local tHeroes = tHeroActors
    table.insert(tEnemies, rMadScientist)
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        rSpeakingActor = tAliveHeroes[1]
        rSpeakingActor:playAnimation('breathe', true, false)
        rMadScientist:sayLine("PBAT013MADS", 'upper', true, true)
        rMadScientist:sayLine("PBAT014MADS", 'upper', true, true)
        rMadScientist:sayLine("PBAT015MADS", 'upper', true, true)

        local rBackground = MOAIProp2D.new()
        rBackground:setDeck(g_GUI:GetOnePixelDeck())
        rBackground:setLoc(0, 0)    
        rBackground:setScl(Renderer.getUIWidth(), Renderer.getUIHeight())
        local rLayer = Renderer.getRenderLayer("UI")
        rLayer:insertProp(rBackground)
        rBackground:setColor(1, 1, 1)
        util.sleep(1)
        rLayer:removeProp(rBackground)

        g_GUI:HideDialogText()
        local rMonsterFoot = self:getActor('MonsterFoot')
        rMonsterFoot:insertIntoLayer(self.rLayer)
        rMonsterFoot:setLoc(200, -200)
        g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/MonsterFootSlam')
        rMonsterFoot:playAnimation("smash", false, false, false)
        util.sleep(0.5)
        self:performScreenShake(50)
        util.sleep(1)

        rMadScientist:sayLine("PBAT017MADS", 'upper', true, true)
        rMadScientist:moveToLoc(800, -210, 1, 'run', true)

        self.sWinnerPortraitPath, self.sWinnerPortraitIndex =  tAliveHeroes[1]:getCurPortraitPath()
        self.sLoserPortraitPath, self.sLoserPortraitIndex = rMadScientist:getCurPortraitPath()

        DFAchievement.updateAchievement('BeatPortal', 1)
    else
        local tHeroActors = self:getAllHeroActors()
        self.sLoserPortraitPath, self.sLoserPortraitIndex = tHeroActors[1]:getCurPortraitPath()
        self.sWinnerPortraitPath, self.sWinnerPortraitIndex = rMadScientist:getCurPortraitPath() 

        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self, onIntro1EventClosedCallback)
end


function PortalEvent1:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = portalEvent1Thread

    return Ob
end

function PortalEvent2:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = portalEvent2Thread

    return Ob
end

function PortalEvent3:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = portalEvent3Thread

    return Ob
end

local tEvents =
{
    PortalEvent1, PortalEvent2, PortalEvent3
}

return tEvents