local RobotFootEvent1 = {}
local RobotFootEvent2 = {}
local RobotFootEvent3 = {}
local RobotFootEvent4 = {}
local RobotFootEvent5 = {}
local Event = require('event/Event')
local util = require("DFUtil")
local DFFile = require('DFCommon.File')
local Character = require("Character")
local DFAchievement = require('DFCommon.Achievement')

local function robotFootEvent1Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)

    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end
    
    local rHench1 = self:getActor('Enemy1')
    local rHench2 = self:getActor('Enemy2')
    local rHench3 = self:getActor('Enemy3')
    rHench2:playAnimation('breathe', false, false)
    rHench3:playAnimation('breathe', false, false)

    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rHench2:playAnimation('threathen_breathe', false, false)
    rHench1:playAnimation('hero_entrance_react', true, false, true)
    rHench1:playAnimation('hero_entrance_react_end', false, false)

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("FINT001HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rHench1:sayLine("FINT002THUG", 'upper', true, true)
    rHench2:sayLine("FINT003THUG", 'upper', true, true)
    rHench1:sayLine("FINT004THUG", 'upper', true, true)
    --g_GUI:HideDialogText()
    
    --rSpeakingActor:sayLine("FINT005HERO", 'upper', true, true)
    --g_GUI:HideDialogText()
    
    --rHench1:sayLine("FINT006THUG", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { rCitizen }
    
    self.rEventUI:enableInteractiveUIElements(true)
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens) 
    else
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self, onIntro1EventClosedCallback)

end

local function robotFootEvent2Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    
    self:moveAllEnemiesToSlot(tEnemies, true)

    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation('breathe', true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    local rHench1 = self:getActor('Enemy1')
    local rHench2 = self:getActor('Enemy2')
    local rHench3 = self:getActor('Enemy3')
    local rHench4 = self:getActor('Enemy4')

    rHench2:playAnimation('breathe', false, false)
    rHench3:playAnimation('breathe', false, false)
    rHench4:playAnimation('breathe', false, false)

    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    rHench2:playAnimation('threathen_breathe', false, false)
    rHench1:playAnimation('hero_entrance_react', true, false, true)
    rHench1:playAnimation('hero_entrance_react_end', false, false)
    rHench4:playAnimation('threathen_breathe', false, false)

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("FTWO001HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rHench1:sayLine("FTWO002HMAN", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSpeakingActor:sayLine("FTWO003HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rHench1:sayLine("FTWO004HMAN", 'upper', true, true)
    rHench1:sayLine("FTWO005HMAN", 'upper', true, true)
    --rHench1:sayLine("FTWO006HMAN", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSpeakingActor:sayLine("FTWO007HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rHench1:sayLine("FTWO008HMAN", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    self.rEventUI:enableInteractiveUIElements(true)
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        rSpeakingActor = tAliveHeroes[1]
        rSpeakingActor:playAnimation('breathe', true, false)
        local rMM = g_MiddleManager:getAvatar()
        
        rMM:sayLine("FTWO009MIDM", 'upper', true, true)
        g_GUI:HideDialogText()
        
        rSpeakingActor:sayLine("FTWO010HERO", 'upper', true, true)
        g_GUI:HideDialogText()
        
        rMM:sayLine("FTWO011MIDM", 'upper', true, true)
        g_GUI:HideDialogText()
        
        rSpeakingActor:sayLine("FTWO012HERO", 'upper', true, true)

        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)
    else
        if tAliveEnemies and tAliveEnemies[1] then
            tAliveEnemies[1]:sayLine("FTWO013HMAN", true, true)
        end
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self, onIntro1EventClosedCallback)
end

local function _checkRobotHealth(rEvent)
    local rRobotFoot = rEvent:getActor('RobotFoot')
    if rRobotFoot then
        if rRobotFoot:getCurHP() <= 2 then
            return "Player"
        end
    end
    return nil
end

local function robotFootEvent3Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    

    local rRobotFoot = self:getActor('RobotFoot')
    rRobotFoot:setImmortal(true)

    util.sleep(0.75)

    rRobotFoot:insertIntoLayer(self.rLayer)
    rRobotFoot:setLoc(200, -200)
    g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/RobotFootStomp')
    rRobotFoot:playAnimation("smash", false, false)
    util.sleep(0.5)
    self:performScreenShake(50)
    
    util.sleep(1)
        
    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end
    
    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("FBB1001HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rRobotFoot:sayLine("FBB1002FOOT", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSpeakingActor:sayLine("FBB1003HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rRobotFoot:sayLine("FBB1004FOOT", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSpeakingActor:sayLine("FBB1005HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rRobotFoot:sayLine("FBB1006FOOT", 'upper', true, true)
    g_GUI:HideDialogText()
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    self.rEventUI:enableInteractiveUIElements(true)
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens, _checkRobotHealth)
    if bSuccessful then
        util.sleep(2)
        for i, rHero in ipairs(tAliveHeroes) do
            rHero:playAnimation('breathe', true, false)
        end
        rRobotFoot:playAnimation('breathe', true, false)
        rRobotFoot:moveToLoc(270, 380, 0.5, nil, true)

        util.sleep(1)

        local rFallingHench = self:getActor('FallingHench')
        rFallingHench:insertIntoLayer(self.rLayer)
        rFallingHench:playAnimation('knock_out')
        rFallingHench:setLoc(250, 170)
        rFallingHench:setShadowVisible(false)
        g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/GiantRobot_HenchmenFall')
        rFallingHench:moveToLoc(250, -220, 0.5, nil, true)

        rFallingHench:sayLine("FBB1007THUG", 'upper', true, true)
        g_GUI:HideDialogText()
        
        tAliveHeroes[1]:sayLine("FBB1008HERO", 'upper', true, true)

        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)
    else
        if tAliveEnemies and tAliveEnemies[1] then
            tAliveEnemies[1]:sayLine("FBB1009FOOT", 'upper', true, true)
        end
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self, onIntro1EventClosedCallback)
end

local function robotFootEvent4Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    

    local rRobotFoot = self:getActor('RobotFoot')
    rRobotFoot:insertIntoLayer(self.rLayer)
    rRobotFoot:setLoc(200, -240)
    rRobotFoot:playAnimation("breathe", false, false)
    rRobotFoot:setImmortal(true)

    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    local rSpeakingActor = tHeroActors[1]
    rSpeakingActor:sayLine("FBB2001HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rRobotFoot:sayLine("FBB2002FOOT", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rSpeakingActor:sayLine("FBB2003HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    
    rRobotFoot:sayLine("FBB2004FOOT", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    self.rEventUI:enableInteractiveUIElements(true)
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens, _checkRobotHealth)
    if bSuccessful then
        util.sleep(2)
        for i, rHero in ipairs(tAliveHeroes) do
            rHero:playAnimation('breathe', true, false)
        end
        rRobotFoot:playAnimation('breathe', true, false)
        rRobotFoot:moveToLoc(270, 400, 0.5, nil, true)

        util.sleep(1)

        local rFallingHench = self:getActor('FallingHench')
        rFallingHench:insertIntoLayer(self.rLayer)
        rFallingHench:playAnimation('knock_out')
        rFallingHench:setLoc(250, 170)
        rFallingHench:setShadowVisible(false)
        g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/GiantRobot_HenchmenFall')
        rFallingHench:moveToLoc(250, -220, 0.5, nil, true)

        rFallingHench:sayLine("FBB2005THUG", 'upper', true, true)
        g_GUI:HideDialogText()
        
        tAliveHeroes[1]:sayLine("FBB2006HERO", 'upper', true, true)

        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)
    else
        if tAliveEnemies and tAliveEnemies[1] then
            tAliveEnemies[1]:sayLine("FBB2007FOOT", 'upper', true, true)
        end
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self, onIntro1EventClosedCallback)
end

local function robotFootEvent5Thread(self)
    self.rEventUI:enableInteractiveUIElements(false)
    -- setup hero
    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local tEnemies = self:getAllEventEnemies()    

    local rRobotFoot = self:getActor('RobotFoot')
    rRobotFoot:insertIntoLayer(self.rLayer)
    rRobotFoot:setLoc(200, -240)
    rRobotFoot:playAnimation("breathe", false, false)

    util.sleep(0.75)

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)
        rHeroActor:enter(true)
        rHeroActor:playAnimation("breathe", true)
    end

    local rSpeakingActor = tHeroActors[1]
    rRobotFoot:sayLine("FBB3001FOOT", 'upper', true, true)
    g_GUI:HideDialogText()
    rSpeakingActor:sayLine("FBB3002HERO", 'upper', true, true)
    rSpeakingActor:sayLine("FBB3003HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    rRobotFoot:sayLine("FBB3004FOOT", 'upper', true, true)
    rRobotFoot:sayLine("FBB3005FOOT", 'upper', true, true)
    g_GUI:HideDialogText()
    rSpeakingActor:sayLine("FBB3006HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    rRobotFoot:sayLine("FBB3007FOOT", 'upper', true, true)
    g_GUI:HideDialogText()
    rSpeakingActor:sayLine("FBB3008HERO", 'upper', true, true)
    g_GUI:HideDialogText()
    rRobotFoot:sayLine("FBB3009FOOT", 'upper', true, true)

    -- clear out the dialog
    g_GUI:HideDialogText()
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    self.rEventUI:enableInteractiveUIElements(true)
    local bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        for i, rHero in ipairs(tAliveHeroes) do
            rHero:playAnimation('breathe', true, false)
        end
        rRobotFoot:setLoc(200, -240)
        g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/GiantRobotExplode')
        rRobotFoot:moveAttr(MOAITransform2D.ATTR_Z_ROT, -80, 0.5, MOAIEaseType.LINEAR)
        util.sleep(0.5)
        self:performScreenShake(50)        
 
        util.sleep(0.5)

        local rFallingHench = self:getActor('FallingHench')
        rFallingHench:insertIntoLayer(self.rLayer)
        rFallingHench:playAnimation('knock_out')
        rFallingHench:setLoc(250, 170)
        rFallingHench:setShadowVisible(false)
        g_Audio:playCue('MMOJ_Audio/SFX/EnemySFX/GiantRobot_HenchmenFall')
        rFallingHench:moveToLoc(250, -220, 0.5, nil, true)

        rFallingHench:sayLine("FBB3010HMAN", 'upper', true, true)
        g_GUI:HideDialogText()
        tAliveHeroes[1]:sayLine("FBB3011HERO", 'upper', true, true)
        g_GUI:HideDialogText()
        rFallingHench:sayLine("FBB3012HMAN", 'upper', true, true)
        g_GUI:HideDialogText()
        tAliveHeroes[1]:sayLine("FBB3013HERO", 'upper', true, true)
        g_GUI:HideDialogText()
        rFallingHench:sayLine("FBB3014HMAN", 'upper', true, true)
        g_GUI:HideDialogText()
        tAliveHeroes[1]:sayLine("FBB3015HERO", 'upper', true, true)

        self.sWinnerPortraitPath, self.sWinnerPortraitIndex =  tAliveHeroes[1]:getCurPortraitPath()
        self.sLoserPortraitPath, self.sLoserPortraitIndex = rRobotFoot:getCurPortraitPath()

        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)

        DFAchievement.updateAchievement('BeatRobotFoot', 1)
    else
        local tHeroActors = self:getAllHeroActors()

        self.sLoserPortraitPath, self.sLoserPortraitIndex = tHeroActors[1]:getCurPortraitPath()
        self.sWinnerPortraitPath, self.sWinnerPortraitIndex = rRobotFoot:getCurPortraitPath() 

        if tAliveEnemies and tAliveEnemies[1] then
            tAliveEnemies[1]:sayLine("FBB3016FOOT", 'upper', true, true)
        end

        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens, true)
    end
    -- must be set to be successful
    self:setSuccessful(bSuccessful)
    
    -- clear out the dialog
    g_GUI:HideDialogText()
    
    g_eventManager:endEvent(self, onIntro1EventClosedCallback)
end

function RobotFootEvent1:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = robotFootEvent1Thread

    return Ob
end

function RobotFootEvent2:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = robotFootEvent2Thread

    return Ob
end

function RobotFootEvent3:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = robotFootEvent3Thread

    return Ob
end

function RobotFootEvent4:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = robotFootEvent4Thread

    return Ob
end

function RobotFootEvent5:new(rTerritory, rDef, tSaved)
    local Ob = Event:new(rTerritory, rDef, tSaved)
    Ob.sSpriteSheetKey = 'tFightEventSpriteSheetInfo'

    Ob.eventThread = robotFootEvent5Thread

    return Ob
end

local tEvents =
{
    RobotFootEvent1, RobotFootEvent2, RobotFootEvent3, RobotFootEvent4, RobotFootEvent5
}

return tEvents