local RobberyEvent = require('event/RobberyEvent')
local Character = require('Character')
local util = require('DFUtil')
--[[
local function villainFightEvent(self)
    local rEventBG = self:getEventBG()
    if rEventBG then
        rEventBG:addBGProp('CombatProps/Truck_Money', 'TruckLocs')
    end

    local tHeroActors = self:getAllHeroActors()
    self:moveAllHeroesToSlot(tHeroActors, true)

    -- setup enemy
    local tEnemies = self:getAllEventEnemies()
    -- snap the henchman to the slots
    self:moveAllEnemiesToSlot(tEnemies, true)

    local rVillain = self:getActor("Villain")
    -- setup extra actors
    rVillain:playAnimation("fight_breathe", false, false)
    self:snapActorToSlot("CitizenLocs", rVillain)
    rVillain:insertIntoLayer(self.rLayer)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation("breathe", true, false)
        rEnemy:insertIntoLayer(self.rLayer)
    end

    for i, rHeroActor in ipairs(tHeroActors) do
        util.sleep(math.random(0.1, 0.3))
        rHeroActor:insertIntoLayer(self.rLayer)	            
        rHeroActor:enter(true)
    end

    local x, y = rVillain:getLoc()
    rVillain:playAnimation("cheer", false, false, false)

    for i, rEnemy in ipairs(tEnemies) do
        util.sleep(math.random(0.3, 0.7))
        rEnemy:playAnimation("hero_entrance_react", true, false)
    end
    
    util.sleep(1)
    
    for i, rEnemy in ipairs(tEnemies) do
        rEnemy:playAnimation("hero_entrance_react_end", false, false)
    end
    
    -- fight!
    local tHeroes = tHeroActors
    local tEnemyWaves = { tEnemies }       
    local tCitizens = { }
    
    local bSuccessful, tAliveHeroes = self:fightThread(tHeroes, tEnemyWaves, tCitizens)
    if bSuccessful then
        rVillain:playAnimation("fight_breathe", false, false, false)
        g_GUI:HideDialogText()
        bSuccessful, tAliveHeroes, tAliveEnemies, tAliveCitizens = self:fightThread(tAliveHeroes, {  { rVillain } }, tCitizens)
    end
    if bSuccessful then
        self:playPlayerWonSequence(tAliveHeroes, tAliveCitizens)
    else
        self:playPlayerLostSequence(tAliveEnemies, tAliveCitizens)
    end

    self:setSuccessful(bSuccessful)
    
    g_eventManager:endEvent(self)
end

tMissionDefs =
{
    {
        tEvents =
        {
            {   
                nLevel = 1,
                bgDefFile = "Street.lua",
                tActors =
                {
                    Enemy1 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl2 },
                    Enemy2 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl2, },
                    Enemy3 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl2, },
                    Villain = { rCharDef = Character.tVillainDefinitions.MadScientistLvl1, },
                },
                constructorFncn = RobberyEvent.new,
                eventThreadFncn = villainFightEvent,
                Rewards =
                {
                    WinXP = 2,
                    MaxCash = 20,
                    MaxPP = 5,
                },
            },
        },  
    },      
    {
        tEvents =
        {
            {   
                nLevel = 1,
                bgDefFile = "Street.lua",
                tActors =
                {
                    Enemy1 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl3 },
                    Enemy2 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl3, },
                    Enemy3 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl3, },
                    Villain = { rCharDef = Character.tVillainDefinitions.SkullFaceLvl2, },
                },
                constructorFncn = RobberyEvent.new,
                eventThreadFncn = villainFightEvent,
                Rewards =
                {
                    WinXP = 2,
                    MaxCash = 20,
                    MaxPP = 5,
                },
            },
        },  
    },   
    {
        tEvents =
        {
            {   
                nLevel = 1,
                bgDefFile = "Street.lua",
                tActors =
                {
                    Enemy1 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl4 },
                    Enemy2 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl4, },
                    Enemy3 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl4, },
                    Villain = { rCharDef = Character.tVillainDefinitions.MadScientistLvl2, },
                },
                constructorFncn = RobberyEvent.new,
                eventThreadFncn = villainFightEvent,
                Rewards =
                {
                    WinXP = 2,
                    MaxCash = 20,
                    MaxPP = 5,
                },
            },
        },  
    },       
    {
        tEvents =
        {
            {   
                nLevel = 1,
                bgDefFile = "Street.lua",
                tActors =
                {
                    Enemy1 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl5 },
                    Enemy2 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl5, },
                    Enemy3 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl5, },
                    Villain = { rCharDef = Character.tVillainDefinitions.SkullFaceLvl3, },
                },
                constructorFncn = RobberyEvent.new,
                eventThreadFncn = villainFightEvent,
                Rewards =
                {
                    WinXP = 2,
                    MaxCash = 20,
                    MaxPP = 5,
                },
            },
        },  
    },        
    {
        tEvents =
        {
            {   
                nLevel = 1,
                bgDefFile = "Street.lua",
                tActors =
                {
                    Enemy1 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl6 },
                    Enemy2 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl6, },
                    Enemy3 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl6, },
                    Villain = { rCharDef = Character.tVillainDefinitions.MadScientistLvl3, },
                },
                constructorFncn = RobberyEvent.new,
                eventThreadFncn = villainFightEvent,
                Rewards =
                {
                    WinXP = 2,
                    MaxCash = 20,
                    MaxPP = 5,
                },
            },
        },  
    },       
    {
        tEvents =
        {
            {   
                nLevel = 1,
                bgDefFile = "Street.lua",
                tActors =
                {
                    Enemy1 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl7 },
                    Enemy2 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl7, },
                    Enemy3 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl7, },
                    Villain = { rCharDef = Character.tVillainDefinitions.SkullFaceLvl4, },
                },
                constructorFncn = RobberyEvent.new,
                eventThreadFncn = villainFightEvent,
                Rewards =
                {
                    WinXP = 2,
                    MaxCash = 20,
                    MaxPP = 5,
                },
            },
        },  
    },        
    {
        tEvents =
        {
            {   
                nLevel = 1,
                bgDefFile = "Street.lua",
                tActors =
                {
                    Enemy1 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl7 },
                    Enemy2 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl7, },
                    Enemy3 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl7, },
                    Villain = { rCharDef = Character.tVillainDefinitions.MadScientistLvl4, },
                },
                constructorFncn = RobberyEvent.new,
                eventThreadFncn = villainFightEvent,
                Rewards =
                {
                    WinXP = 2,
                    MaxCash = 20,
                    MaxPP = 5,
                },
            },
        },  
    },       
    {
        tEvents =
        {
            {   
                nLevel = 1,
                bgDefFile = "Street.lua",
                tActors =
                {
                    Enemy1 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl8 },
                    Enemy2 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl8, },
                    Enemy3 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl8, },
                    Villain = { rCharDef = Character.tVillainDefinitions.SkullFaceLvl5, },
                },
                constructorFncn = RobberyEvent.new,
                eventThreadFncn = villainFightEvent,
                Rewards =
                {
                    WinXP = 2,
                    MaxCash = 20,
                    MaxPP = 5,
                },
            },
        },  
    },        
    {
        tEvents =
        {
            {   
                nLevel = 1,
                bgDefFile = "Street.lua",
                tActors =
                {
                    Enemy1 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl9 },
                    Enemy2 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl9, },
                    Enemy3 = { rCharDef = Character.tHenchmanDefinitions.HenchmanRangedLvl9, },
                    Villain = { rCharDef = Character.tVillainDefinitions.MadScientistLvl5, },
                },
                constructorFncn = RobberyEvent.new,
                eventThreadFncn = villainFightEvent,
                Rewards =
                {
                    WinXP = 2,
                    MaxCash = 20,
                    MaxPP = 5,
                },
            },
        },  
    },       
}
]]--
local tMissionDefs = {}
return tMissionDefs