local UIElement = require('ui/UIElement')
local SpriteSheet = require('SpriteSheet')
local AbilityIcon = {}

local tUITextureSpriteSheetInfo =
{
}

function AbilityIcon:new(rRenderLayer, rAbility, rParentUI)
    local Ob = UIElement:new(rRenderLayer)
    
	function Ob:setVisible(bVisible)       
        self:setElementsVisible(bVisible)        
	end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()
    end

	function Ob:onFinger(eventType, sx, sy, tProps)
        if eventType == MOAITouchSensor.TOUCH_UP then
            if tProps then
                for i, rProp in ipairs(tProps) do
                    if rProp == self.rIcon and self.rParentUI then
                        self.rParentUI:handleIconPress(self)
                        return true
                    end
                end
            end
        end
    end

    Ob.rAbility = rAbility
    Ob.rParentUI = rParentUI

    local sIconName = rAbility:getDef().sIconName
    local sIconSheet = rAbility:getDef().sIconSheet
    if sIconName then
        tUITextureSpriteSheetInfo[sIconName] = sIconSheet
        Ob:loadUISpriteSheets(tUITextureSpriteSheetInfo)
        Ob.rIcon = Ob:getUITextureProp(sIconName)
        Ob.rIcon:setScl(0.7, 0.7)
        Ob:addElement(Ob.rIcon)
    end
    assert(not Ob.rButtonText)
    --Ob:addElement(Ob.rButtonText)

    return Ob
end

return AbilityIcon
