local util = require("DFUtil")
local ConsumableInventoryButton = require("ui/ConsumableInventoryButton")
local ListUI = require("ui/ListUI")
local UIElement = require('ui/UIElement')
local Item = require("Item")

local ConsumableInventoryUI = {}

function ConsumableInventoryUI:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

	function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
        self.rListUI:setVisible(bVisible)
    end

	function Ob:onFinger(eventType, sx, sy, tProps)
        self.rListUI:onFinger(eventType, sx, sy, tProps)
    end

    function Ob:getElementsMaxPriority()
        local nMaxPri = 0
        for i, rButton in ipairs(self.tConsumableButtons) do
            local nPri = rButton:getElementsMaxPriority()
            if nPri > nMaxPri then
                nMaxPri = nPri
            end
        end
        return nMaxPri
    end

    function Ob:setHeroSelectorUI(rHeroSelectorUI)
        self.rHeroSelectorUI = rHeroSelectorUI
    end

    function Ob:onEquipped(bEquipped)
        if self.rHeroSelectorUI then
            self.rHeroSelectorUI:onEquipped(bEquipped)
        end
    end

    -- create the equipment buttons
    Ob.tConsumableButtons = {}
    local tItems = g_MiddleManager:getActiveConsumables()
    if tItems then
        for i, rItem in ipairs(tItems) do
            if rItem ~= Item.kEMPTY_SLOT then
                local rNewButton = ConsumableInventoryButton:new(Ob.rRenderLayer, rItem, rItem:getItemDefKey(), Ob)
                table.insert(Ob.tConsumableButtons, rNewButton)
            end
        end
    end
    local tItems = g_MiddleManager:getConsumableItems()
    if tItems then
        for i, rItem in pairs(tItems) do
            local rNewButton = ConsumableInventoryButton:new(Ob.rRenderLayer, rItem, rItem:getItemDefKey(), Ob)
            table.insert(Ob.tConsumableButtons, rNewButton)
        end
    end
    -- add to the list UI
    Ob.rListUI = ListUI:new(Ob.rRenderLayer, Ob.tConsumableButtons, Ob)
    Ob.rListUI:setParent(Ob)
    Ob.rListUI:setAnchorLoc(0, 0)

    return Ob
end

return ConsumableInventoryUI