local util = require('DFUtil')
local ConsumablePurchaseButton = require('ui/ConsumablePurchaseButton')
local ListUI = require('ui/ListUI')
local UIElement = require('ui/UIElement')
local Item = require('Item')

local ConsumableSelectorUI = {}

function ConsumableSelectorUI:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

	function Ob:setVisible(bVisible)
        if bVisible then
            g_Game:getTutorialManager():onWindowOpen('ConsumablesShopCategory')
        end
        self:setElementsVisible(bVisible)
        self.rListUI:setVisible(bVisible)
    end

    function Ob:update()
        self.rListUI:update()
    end
    
	function Ob:onFinger(eventType, sx, sy, tProps)
        self.rListUI:onFinger(eventType, sx, sy, tProps)
    end

    function Ob:onPaneClosed()
        self.rListUI:onPaneClosed()
    end

    function Ob:setLoc(x, y)
        self.rListUI:setAnchorLoc(x, y)
    end

    -- create the equipment buttons
    Ob.tConsumableButtons = {}
    local tDefKeys = Item.getAllConsumableDefKeys()
    local tOrderedList = {}    
    for i, sDefKey in ipairs(tDefKeys) do
        local rDef = Item.getConsumableDef(sDefKey)

        if g_MiddleManager:isResearched('consumable', sDefKey) then
            if not (rDef.bPermanent and rDef.sPropName and g_Game:isPropEnabled(rDef.sPropName)) then       
                table.insert(tOrderedList, sDefKey)
            end
        end
    end
    for i, sDefKey in ipairs(tDefKeys) do
        if not g_MiddleManager:isResearched('consumable', sDefKey) then
            table.insert(tOrderedList, sDefKey)
        end
    end
    for i, sDefKey in ipairs(tOrderedList) do
        local rNewButton = ConsumablePurchaseButton:new(Ob.rRenderLayer, sDefKey)
        table.insert(Ob.tConsumableButtons, rNewButton)
    end
    -- add to the list UI
    Ob.rListUI = ListUI:new(Ob.rRenderLayer, Ob.tConsumableButtons, Ob)
    Ob.rListUI:setParent(Ob)
    Ob.rListUI:setAnchorLoc(0, 0)

    return Ob
end

return ConsumableSelectorUI