local UIElement = require('ui/UIElement')
local CountdownUI = {}

local tUITextureSpriteSheetInfo =
{
time_0 = 'UI/hud2',
time_1 = 'UI/hud2',
time_2 = 'UI/hud2',
time_3 = 'UI/hud2',
time_4 = 'UI/hud2',
time_5 = 'UI/hud2',
time_6 = 'UI/hud2',
}

function CountdownUI:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

	function Ob:setVisible(bVisible)
        self.bVisible = bVisible
        self:setElementsVisible(bVisible)
	end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()
    end
    
    function Ob:setColor(r,g,b,a)
        self.rTime0Icon:setColor(r, g, b, a)
        self.rTime1Icon:setColor(r, g, b, a)
        self.rTime2Icon:setColor(r, g, b, a)
        self.rTime3Icon:setColor(r, g, b, a)
        self.rTime4Icon:setColor(r, g, b, a)
        self.rTime5Icon:setColor(r, g, b, a)
        self.rTime6Icon:setColor(r, g, b, a)
    end

    function Ob:updateProgress(nProgress)
        if nProgress < 0 then
            nProgress = 0
        end
        if nProgress >= 0 and nProgress <= 16.66 then
            self.rTime0Icon:setVisible(false)
            self.rTime1Icon:setVisible(false)
            self.rTime2Icon:setVisible(false)
            self.rTime3Icon:setVisible(false)
            self.rTime4Icon:setVisible(false)
            self.rTime5Icon:setVisible(false)
            self.rTime6Icon:setVisible(true)
        elseif nProgress > 16.66 and nProgress <= 33.32 then
            self.rTime0Icon:setVisible(false)
            self.rTime1Icon:setVisible(false)
            self.rTime2Icon:setVisible(false)
            self.rTime3Icon:setVisible(false)
            self.rTime4Icon:setVisible(false)
            self.rTime5Icon:setVisible(true)
            self.rTime6Icon:setVisible(false)
        elseif nProgress > 33.32 and nProgress <= 49.98 then
            self.rTime0Icon:setVisible(false)
            self.rTime1Icon:setVisible(false)
            self.rTime2Icon:setVisible(false)
            self.rTime3Icon:setVisible(false)
            self.rTime4Icon:setVisible(true)
            self.rTime5Icon:setVisible(false)
            self.rTime6Icon:setVisible(false)       
        elseif nProgress > 49.98 and nProgress <= 66.64 then
            self.rTime0Icon:setVisible(false)
            self.rTime1Icon:setVisible(false)
            self.rTime2Icon:setVisible(false)
            self.rTime3Icon:setVisible(true)
            self.rTime4Icon:setVisible(false)
            self.rTime5Icon:setVisible(false)
            self.rTime6Icon:setVisible(false)     
        elseif nProgress > 66.64 and nProgress <= 83.3 then
            self.rTime0Icon:setVisible(false)
            self.rTime1Icon:setVisible(false)
            self.rTime2Icon:setVisible(true)
            self.rTime3Icon:setVisible(false)
            self.rTime4Icon:setVisible(false)
            self.rTime5Icon:setVisible(false)
            self.rTime6Icon:setVisible(false)
        elseif nProgress > 83.3 and nProgress < 100 then
            self.rTime0Icon:setVisible(false)
            self.rTime1Icon:setVisible(true)
            self.rTime2Icon:setVisible(false)
            self.rTime3Icon:setVisible(false)
            self.rTime4Icon:setVisible(false)
            self.rTime5Icon:setVisible(false)
            self.rTime6Icon:setVisible(false)
        else 
            self.rTime0Icon:setVisible(true)
            self.rTime1Icon:setVisible(false)
            self.rTime2Icon:setVisible(false)
            self.rTime3Icon:setVisible(false)
            self.rTime4Icon:setVisible(false)
            self.rTime5Icon:setVisible(false)
            self.rTime6Icon:setVisible(false)
        end
    end

    Ob:loadUISpriteSheets(tUITextureSpriteSheetInfo)

    Ob.rTime0Icon = Ob:getUITextureProp('time_0')
    Ob.rTime0Icon:setLoc(0, 0)    
    Ob:addElement(Ob.rTime0Icon)
    Ob.rTime1Icon = Ob:getUITextureProp('time_1')
    Ob.rTime1Icon:setLoc(0, 0)
    Ob:addElement(Ob.rTime1Icon)
    Ob.rTime2Icon = Ob:getUITextureProp('time_2')
    Ob.rTime2Icon:setLoc(0, 0)
    Ob:addElement(Ob.rTime2Icon)
    Ob.rTime3Icon = Ob:getUITextureProp('time_3')
    Ob.rTime3Icon:setLoc(0, 0)
    Ob:addElement(Ob.rTime3Icon)
    Ob.rTime4Icon = Ob:getUITextureProp('time_4')
    Ob.rTime4Icon:setLoc(0, 0)
    Ob:addElement(Ob.rTime4Icon)
    Ob.rTime5Icon = Ob:getUITextureProp('time_5')
    Ob.rTime5Icon:setLoc(0, 0)
    Ob:addElement(Ob.rTime5Icon)
    Ob.rTime6Icon = Ob:getUITextureProp('time_6')
    Ob.rTime6Icon:setLoc(0, 0)
    Ob:addElement(Ob.rTime6Icon)

    Ob.rTime0Icon:setVisible(false)
    Ob.rTime1Icon:setVisible(false)
    Ob.rTime2Icon:setVisible(false)
    Ob.rTime3Icon:setVisible(false)
    Ob.rTime4Icon:setVisible(false)
    Ob.rTime5Icon:setVisible(false)
    Ob.rTime6Icon:setVisible(false)

    return Ob
end

return CountdownUI
