local util = require('DFUtil')
local CurrencyPurchaseButton = require('ui/CurrencyPurchaseButton')
local ListUI = require('ui/ListUI')
local UIElement = require('ui/UIElement')
local DFIAP = require('DFCommon.IAP')
local CurrencySelectorUI = {}

function CurrencySelectorUI:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

	function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
        self.rListUI:setVisible(bVisible)
        if bVisible then
            g_Game:getTutorialManager():onWindowOpen('CurrencyShopCategory')
        end
    end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()
        self.rListUI:onPaneClosed()
    end

	function Ob:onFinger(eventType, sx, sy, tProps)
        self.rListUI:onFinger(eventType, sx, sy, tProps)
    end

    function Ob:setLoc(x, y)
        self.rListUI:setAnchorLoc(x, y)
    end

    function Ob:update()
        self.rListUI:update()
    end
        
    Ob.tCurrencyButtons = {}
    for i, sCurrencyDefKey in ipairs(g_Game:getAllExchangeDefKeys()) do
        local rDef = g_Game:getExchangeDef(sCurrencyDefKey)
        if rDef then
            local rNewButton = CurrencyPurchaseButton:new(Ob.rRenderLayer, rDef, sCurrencyDefKey)
            table.insert(Ob.tCurrencyButtons, rNewButton)                
        end
    end

    -- add to the list UI
    Ob.rListUI = ListUI:new(Ob.rRenderLayer, Ob.tCurrencyButtons, Ob)
    Ob.rListUI:setParent(Ob)
    Ob.rListUI:setAnchorLoc(0, 0)

    return Ob
end

return CurrencySelectorUI