local util = require('DFUtil')
local EquipmentPurchaseButton = require('ui/EquipmentPurchaseButton')
local ListUI = require('ui/ListUI')
local UIElement = require('ui/UIElement')
local Item = require('Item')

local EquipmentSelectorUI = {}

function EquipmentSelectorUI:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

	function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
        self.rListUI:setVisible(bVisible)
        if bVisible then
            g_Game:getTutorialManager():onWindowOpen('EquipmentShopCategory')
        end
    end

	function Ob:onFinger(eventType, sx, sy, tProps)
        self.rListUI:onFinger(eventType, sx, sy, tProps)
    end

    function Ob:onPaneClosed()
        self.rListUI:onPaneClosed()
    end

    function Ob:setLoc(x, y)
        self.rListUI:setAnchorLoc(x, y)
    end

    function Ob:update()
        self.rListUI:update()
    end
        
    -- create the equipment buttons
    Ob.tEquipmentButtons = {}
    local tDefKeys = Item.getAllEquipmentDefKeys()
    local tOrderedList = {}    
    for i, sDefKey in ipairs(tDefKeys) do
        if g_MiddleManager:isResearched('equipment', sDefKey) then
            local rDef = Item.getEquipmentDef(sDefKey)
            if rDef and not rDef.bHideInShop then
                table.insert(tOrderedList, sDefKey)  
            end
        end
    end
    for i, sDefKey in ipairs(tDefKeys) do
        if not g_MiddleManager:isResearched('equipment', sDefKey) then
            table.insert(tOrderedList, sDefKey)
        end
    end
    for i, sDefKey in ipairs(tOrderedList) do
        local rNewButton = EquipmentPurchaseButton:new(Ob.rRenderLayer, sDefKey)
        table.insert(Ob.tEquipmentButtons, rNewButton)
    end
    -- add to the list UI
    Ob.rListUI = ListUI:new(Ob.rRenderLayer, Ob.tEquipmentButtons, Ob)
    Ob.rListUI:setParent(Ob)
    Ob.rListUI:setAnchorLoc(0, 0)

    return Ob
end

return EquipmentSelectorUI