local util = require('DFUtil')
local HeroCostumePurchaseButton = require('ui/HeroCostumePurchaseButton')
local ListUI = require('ui/ListUI')
local UIElement = require('ui/UIElement')
local Character = require('Character')

local HeroCostumeSelectorUI = {}

function HeroCostumeSelectorUI:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

	function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
        self.rListUI:setVisible(bVisible)
        if bVisible then
            g_Game:getTutorialManager():onWindowOpen('HeroCostumeShopCategory')
        end
    end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()
        self.rListUI:onPaneClosed()
    end

	function Ob:onFinger(eventType, sx, sy, tProps)
        self.rListUI:onFinger(eventType, sx, sy, tProps)
    end

    function Ob:setLoc(x, y)
        self.rListUI:setAnchorLoc(x, y)
    end

    function Ob:update()
        self.rListUI:update()
    end
        
    -- create the equipment buttons
    Ob.tCostumeButtons = {}
    for i, rHero in ipairs(g_Game:getActiveHeroes()) do
        local tCostumeKeys = rHero:getCostumeKeyList()
        for c, sCostumeKey in ipairs(tCostumeKeys) do
            if not rHero:isCostumeUnlocked(sCostumeKey) then
                local rNewButton = HeroCostumePurchaseButton:new(Ob.rRenderLayer, rHero, sCostumeKey)
                table.insert(Ob.tCostumeButtons, rNewButton)
            end
        end
    end
    -- add to the list UI
    Ob.rListUI = ListUI:new(Ob.rRenderLayer, Ob.tCostumeButtons, Ob)
    Ob.rListUI:setParent(Ob)
    Ob.rListUI:setAnchorLoc(0, 0)

    return Ob
end

return HeroCostumeSelectorUI