local util = require('DFUtil')
local PackPurchaseButton = require('ui/PackPurchaseButton')
local ListUI = require('ui/ListUI')
local UIElement = require('ui/UIElement')
local Character = require('Character')

local HeroPackSelectorUI = {}

function HeroPackSelectorUI:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

    function Ob:update()
        self.rListUI:update()
    end
    
	function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
        self.rListUI:setVisible(bVisible)
        if bVisible then
            g_Game:getTutorialManager():onWindowOpen('HeroPackShopCategory')
        end
    end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()
        self.rListUI:onPaneClosed()
    end

	function Ob:onFinger(eventType, sx, sy, tProps)
        self.rListUI:onFinger(eventType, sx, sy, tProps)
    end

    function Ob:setLoc(x, y)
        self.rListUI:setAnchorLoc(x, y)
    end

    -- create the equipment buttons
    Ob.tPackSelectorButtons = {}
    local tDefList = Character.getPackList()
    for i, sPackDefKey in ipairs(tDefList) do
        local rNewButton = PackPurchaseButton:new(Ob.rRenderLayer, sPackDefKey)
        table.insert(Ob.tPackSelectorButtons, rNewButton)
    end
    -- add to the list UI
    Ob.rListUI = ListUI:new(Ob.rRenderLayer, Ob.tPackSelectorButtons, Ob)
    Ob.rListUI:setAnchorLoc(0, 0)

    return Ob
end

return HeroPackSelectorUI