local UIElement = require('ui/UIElement')
local Item = require('Item')
local MeteoriteIcon = {}

local tUITextureSpriteSheetInfo =
{
    Crystal_Lvl1 = 'UI/hud',
    Crystal_Lvl2 = 'UI/hud',
    Crystal_Lvl3 = 'UI/hud',
    Crystal_Lvl4 = 'UI/hud',
    Crystal_Lvl5 = 'UI/hud',
    Crystal_Lvl6 = 'UI/hud',
    Crystal_Lvl1_W = 'UI/hud',
    Crystal_Lvl2_W = 'UI/hud',
    Crystal_Lvl3_W = 'UI/hud',
    Crystal_Lvl4_W = 'UI/hud',
    Crystal_Lvl5_W = 'UI/hud',
    Crystal_Lvl6_W = 'UI/hud',
}

local tBGTextures =
{
    "Crystal_Lvl1",
    "Crystal_Lvl2",
    "Crystal_Lvl3",
    "Crystal_Lvl4",
    "Crystal_Lvl5",
    "Crystal_Lvl6",
}

local tFGTextures =
{
    "Crystal_Lvl1_W",
    "Crystal_Lvl2_W",
    "Crystal_Lvl3_W",
    "Crystal_Lvl4_W",
    "Crystal_Lvl5_W",
    "Crystal_Lvl6_W",
}

function MeteoriteIcon:new(rRenderLayer, sItemKey, nLevel)
    local Ob = UIElement:new(rRenderLayer)
    local rDef = Item.getMeteoriteDef(sItemKey)

	function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
    end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()
    end

    function Ob:setColorOverride(r, g, b)
        if r and g and b then            
            self.tColorOverride = { r, g, b }
            self.rBGRockTexture:setColor(r, g, b)
            self.rFGRockTexture:setColor(r, g, b)
        end
    end

    function Ob:setAlphaOverride(a)
        if a then
            if self.tColorOverride then
                self.rBGRockTexture:setColor(self.tColorOverride[1], self.tColorOverride[2], self.tColorOverride[3], a/2)
                self.rFGRockTexture:setColor(self.tColorOverride[1], self.tColorOverride[2], self.tColorOverride[3], a)
            else
                if self.rDef and self.rDef.tColor then
                    self.rBGRockTexture:setColor(self.rDef.tColor[1], self.rDef.tColor[2], self.rDef.tColor[3], a)
                    self.rFGRockTexture:setColor(1, 1, 1, a)
                end                
            end
        end
    end

    function Ob:clearColorOverride()
        if self.rDef and self.rDef.tColor then
            self.rBGRockTexture:setColor(self.rDef.tColor[1], self.rDef.tColor[2], self.rDef.tColor[3])
            self.rFGRockTexture:setColor(1, 1, 1)
            self.tColorOverride = nil
        end
    end

    function Ob:setMeteorite(sItemKey, nLevel)
        if sItemKey and nLevel then
            if nLevel <= Item.kMETEORITE_MAX_LEVEL then        
                self.sItemKey = sItemKey
                self.nLevel = nLevel
                self.rDef = Item.getMeteoriteDef(sItemKey)
                if self.rDef then
                    self.rBGRockTexture = self:getUITextureProp(tBGTextures[nLevel], self.rBGRockTexture)
                    self.rFGRockTexture = self:getUITextureProp(tFGTextures[nLevel], self.rFGRockTexture)
                    if self.rDef.tColor then
                        self.rBGRockTexture:setColor(self.rDef.tColor[1], self.rDef.tColor[2], self.rDef.tColor[3])
                    end
                end
            end
        end
    end

    Ob:loadUISpriteSheets(tUITextureSpriteSheetInfo)

    Ob.rBGRockTexture = Ob:getUITextureProp(tBGTextures[1])
    Ob.rBGRockTexture:setLoc(0, 0)
    Ob:addElement(Ob.rBGRockTexture)
    
    Ob.rFGRockTexture = Ob:getUITextureProp(tFGTextures[1])
    Ob.rFGRockTexture:setLoc(0, 0)
    Ob:addElement(Ob.rFGRockTexture)  

    Ob:setMeteorite(sItemKey, nLevel)

    return Ob
end

return MeteoriteIcon