local util = require('DFUtil')
local MeteoriteInventoryButton = require('ui/MeteoriteInventoryButton')
local ListUI = require('ui/ListUI')
local UIElement = require('ui/UIElement')
local Item = require('Item')

local MeteoriteInventoryUI = {}

function MeteoriteInventoryUI:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

	function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
        self.rListUI:setVisible(bVisible)
    end

	function Ob:onFinger(eventType, sx, sy, tProps)
        self.rListUI:onFinger(eventType, sx, sy, tProps)
    end

    function Ob:getElementsMaxPriority()
        local nMaxPri = 0
        for i, rButton in ipairs(self.tMeteoriteButtons) do
            local nPri = rButton:getElementsMaxPriority()
            if nPri > nMaxPri then
                nMaxPri = nPri
            end
        end
        return nMaxPri
    end

    function Ob:setHeroSelectorUI(rHeroSelectorUI)
        self.rHeroSelectorUI = rHeroSelectorUI
    end

    function Ob:getHeroSelectorUI()
        return self.rHeroSelectorUI
    end

    function Ob:onEquipped(bEquipped)
        if self.rHeroSelectorUI then
            self.rHeroSelectorUI:onEquipped(bEquipped)
        end
    end

    function Ob:onPaneClosed()
        self.rListUI:onPaneClosed()
    end

    function Ob:setLoc(x, y)
        self.rListUI:setAnchorLoc(x, y)
    end

    function Ob:update()
        self.rListUI:recalcListPos()
        self.rListUI:update()
    end

    -- create the equipment buttons
    Ob.tMeteoriteButtons = {}
    local tInfos = g_MiddleManager:getAllMeteoritesInInventory()
    for i, rInfo in ipairs(tInfos) do
        if rInfo.sDefKey and rInfo.nLevel then
            local rNewButton = MeteoriteInventoryButton:new(Ob.rRenderLayer, rInfo.sDefKey, rInfo.nLevel, Ob)
            if rNewButton then
                table.insert(Ob.tMeteoriteButtons, rNewButton)
            end
        end
    end

    -- add to the list UI
    Ob.rListUI = ListUI:new(Ob.rRenderLayer, Ob.tMeteoriteButtons, Ob)
    Ob.rListUI:setParent(Ob)
    Ob.rListUI:setAnchorLoc(0, 0)

    return Ob
end

return MeteoriteInventoryUI