local util = require('DFUtil')
local MeteoritePurchaseButton = require('ui/MeteoritePurchaseButton')
local ListUI = require('ui/ListUI')
local UIElement = require('ui/UIElement')
local Item = require('Item')
local MeteoriteSelectorUI = {}

function MeteoriteSelectorUI:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

	function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
        self.rListUI:setVisible(bVisible)
        if bVisible then
            g_Game:getTutorialManager():onWindowOpen('MeteoriteShopCategory')
        end
    end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()
        self.rListUI:onPaneClosed()
    end

	function Ob:onFinger(eventType, sx, sy, tProps)
        self.rListUI:onFinger(eventType, sx, sy, tProps)
    end

    function Ob:setLoc(x, y)
        self.rListUI:setAnchorLoc(x, y)
    end

    function Ob:update()
        self.rListUI:update()
    end
        
    Ob.tMeteoriteButtons = {}
    for i, sMeteoriteDefKey in ipairs(Item.getAllMeteoriteDefKeys()) do
        local rDef = Item.getMeteoriteDef(sMeteoriteDefKey)
        if rDef then
            if rDef.tPurchasePrice then
                for nLevel, nPrice in ipairs(rDef.tPurchasePrice) do
                    local rNewButton = MeteoritePurchaseButton:new(Ob.rRenderLayer, sMeteoriteDefKey, nLevel)
                    table.insert(Ob.tMeteoriteButtons, rNewButton)
                end
            end
        end
    end

    -- add to the list UI
    Ob.rListUI = ListUI:new(Ob.rRenderLayer, Ob.tMeteoriteButtons, Ob)
    Ob.rListUI:setParent(Ob)
    Ob.rListUI:setAnchorLoc(0, 0)

    return Ob
end

return MeteoriteSelectorUI