local MeteoriteTutorialUI = {}
local Renderer = require('Renderer')
local UIElement = require('ui/UIElement')
local SpriteSheet = require('SpriteSheet')
local util = require('DFUtil')
local ResumeUI = require('ui/ResumeUI')

local tUITextureSpriteSheetInfo =
{
    Meteorite_Screen = 'UI/meteorite',
}

function MeteoriteTutorialUI:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

    function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
    end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()        
    end

    function Ob:onFinger(eventType, sx, sy, tProps)
        if eventType == MOAITouchSensor.TOUCH_UP then
            g_GUI:HideMeteoriteTutorialUI()
        end
    end

    Ob:loadUISpriteSheets(tUITextureSpriteSheetInfo, 'center', 'center')

    local screenX = (Renderer.getUIWidth() - 1024) / 2
    local screenY = (Renderer.getUIHeight() - 768) / 2
    
    Ob.rBackground = MOAIProp2D.new()
	Ob.rBackground:setDeck(g_GUI:GetOnePixelDeck())
	Ob.rBackground:setLoc(0, 0)
	Ob.rBackground:setScl(Renderer.getUIWidth(), Renderer.getUIHeight())
	Ob.rBackground:setColor(0, 0, 0)
	Ob:addElement(Ob.rBackground)

    Ob.rTutorialTexture = SpriteSheet:new('UI/meteorite', nil, 0, 0, 'left', 'top')
    Ob.rTutorialTexture:setLoc(screenX, -screenY)
    Ob:addElement(Ob.rTutorialTexture) 

    return Ob
end

return MeteoriteTutorialUI