local MiddleManagerUI = {}
local DFSaveLoad = require('DFCommon.SaveLoad')
local DFAnalytics = require('DFCommon.Analytics')
local Character = require('Character')
local Renderer = require('Renderer')
local DFAnalytics = require('DFCommon.Analytics')                           
local Ability = require('Ability/Ability')

local kDEFAULT_MMOPTION_COLORS = { r = 0.23, g = 0.54, b = 0.76 }
local kDISABLED_MMOPTION_COLORS = { r = 0.2, g = 0.2, b = 0.2 }

function MiddleManagerUI:new(rRenderLayer)
    local Ob = MOAITransform.new()

	Ob.rRenderLayer = rRenderLayer
	Ob.tElements = {}

	function Ob:addElement(rElement)
		rElement:setParent(self)
		table.insert(self.tElements, rElement)
	end

	Ob.rBackground = MOAIProp2D.new()
	Ob.rBackground:setDeck(g_GUI:GetOnePixelDeck())
	Ob.rBackground:setScl(120, 100)
	Ob.rBackground:setLoc(0, 0)
	Ob.rBackground:setColor(0, 0, 0)
	Ob:addElement(Ob.rBackground)

	-- the new pack button
	Ob.rResetSaveButton = MOAIProp2D.new()
	Ob.rResetSaveButton:setDeck(g_GUI:GetGreenButtonDeck())
    Ob.rResetSaveButton:setScl(0.4, 0.9)
	Ob.rResetSaveButton:setLoc(0, 0)
	Ob.rResetSaveButton:setColor(kDEFAULT_MMOPTION_COLORS.r, kDEFAULT_MMOPTION_COLORS.g, kDEFAULT_MMOPTION_COLORS.b)   
    Ob:addElement(Ob.rResetSaveButton)

    Ob.rResetSaveButtonText = g_GUI:CreateTextBox(20, MOAITextBox.CENTER_JUSTIFY)
    Ob.rResetSaveButtonText:setString("Reset Save")
    Ob.rResetSaveButtonText:setRect(-100, -30, 100, 30)
	Ob.rResetSaveButtonText:setColor(255, 255, 255)    
    Ob.rResetSaveButtonText:setLoc(0, -10)
    Ob:addElement(Ob.rResetSaveButtonText)

    -- the shop button
	Ob.rAddCashButton = MOAIProp2D.new()
	Ob.rAddCashButton:setDeck(g_GUI:GetGreenButtonDeck())
    Ob.rAddCashButton:setScl(0.4, 0.9)
	Ob.rAddCashButton:setLoc(0, -80)
	Ob.rAddCashButton:setColor(kDEFAULT_MMOPTION_COLORS.r, kDEFAULT_MMOPTION_COLORS.g, kDEFAULT_MMOPTION_COLORS.b)
    Ob:addElement(Ob.rAddCashButton)

    Ob.rAddCashButtonText = g_GUI:CreateTextBox(20, MOAITextBox.CENTER_JUSTIFY)
    Ob.rAddCashButtonText:setString("Debug Add Cash")
    Ob.rAddCashButtonText:setRect(-100, -30, 100, 30)
	Ob.rAddCashButtonText:setColor(255, 255, 255)    
    Ob.rAddCashButtonText:setLoc(0, -90)
    Ob:addElement(Ob.rAddCashButtonText)

    -- the shop button
	Ob.rAddPPButton = MOAIProp2D.new()
	Ob.rAddPPButton:setDeck(g_GUI:GetGreenButtonDeck())
    Ob.rAddPPButton:setScl(0.4, 0.9)
	Ob.rAddPPButton:setLoc(0, -160)
	Ob.rAddPPButton:setColor(kDEFAULT_MMOPTION_COLORS.r, kDEFAULT_MMOPTION_COLORS.g, kDEFAULT_MMOPTION_COLORS.b)
    Ob:addElement(Ob.rAddPPButton)

    Ob.rAddPPButtonText = g_GUI:CreateTextBox(20, MOAITextBox.CENTER_JUSTIFY)
    Ob.rAddPPButtonText:setString("Debug Add PP")
    Ob.rAddPPButtonText:setRect(-100, -30, 100, 30)
	Ob.rAddPPButtonText:setColor(255, 255, 255)    
    Ob.rAddPPButtonText:setLoc(0, -170)
    Ob:addElement(Ob.rAddPPButtonText)

	Ob.rDebugDisplayButton = MOAIProp2D.new()
	Ob.rDebugDisplayButton:setDeck(g_GUI:GetGreenButtonDeck())
    Ob.rDebugDisplayButton:setScl(0.4, 0.9)
	Ob.rDebugDisplayButton:setLoc(0, -240)
	Ob.rDebugDisplayButton:setColor(kDEFAULT_MMOPTION_COLORS.r, kDEFAULT_MMOPTION_COLORS.g, kDEFAULT_MMOPTION_COLORS.b)
    Ob:addElement(Ob.rDebugDisplayButton)

    Ob.rDebugDisplayButtonText = g_GUI:CreateTextBox(20, MOAITextBox.CENTER_JUSTIFY)
    Ob.rDebugDisplayButtonText:setString("DebugDisplay")
    Ob.rDebugDisplayButtonText:setRect(-100, -30, 100, 30)
	Ob.rDebugDisplayButtonText:setColor(255, 255, 255)    
    Ob.rDebugDisplayButtonText:setLoc(0, -250)
    Ob:addElement(Ob.rDebugDisplayButtonText)

	Ob.rDebugAbilityButton = MOAIProp2D.new()
	Ob.rDebugAbilityButton:setDeck(g_GUI:GetGreenButtonDeck())
    Ob.rDebugAbilityButton:setScl(0.4, 0.9)
	Ob.rDebugAbilityButton:setLoc(0, -320)
	Ob.rDebugAbilityButton:setColor(kDEFAULT_MMOPTION_COLORS.r, kDEFAULT_MMOPTION_COLORS.g, kDEFAULT_MMOPTION_COLORS.b)
    Ob:addElement(Ob.rDebugAbilityButton)

    Ob.rDebugAbilityButtonText = g_GUI:CreateTextBox(20, MOAITextBox.CENTER_JUSTIFY)
    Ob.rDebugAbilityButtonText:setString("Unlock Abilities")
    Ob.rDebugAbilityButtonText:setRect(-100, -30, 100, 30)
	Ob.rDebugAbilityButtonText:setColor(255, 255, 255)    
    Ob.rDebugAbilityButtonText:setLoc(0, -330)
    Ob:addElement(Ob.rDebugAbilityButtonText)

	Ob.rAnalyticsButton = MOAIProp2D.new()
	Ob.rAnalyticsButton:setDeck(g_GUI:GetGreenButtonDeck())
    Ob.rAnalyticsButton:setScl(0.4, 0.9)
	Ob.rAnalyticsButton:setLoc(0, -400)
	Ob.rAnalyticsButton:setColor(kDEFAULT_MMOPTION_COLORS.r, kDEFAULT_MMOPTION_COLORS.g, kDEFAULT_MMOPTION_COLORS.b)
    Ob:addElement(Ob.rAnalyticsButton)

    Ob.rAnalyticsButtonText = g_GUI:CreateTextBox(20, MOAITextBox.CENTER_JUSTIFY)
    if DFAnalytics.initialized then
        Ob.rAnalyticsButtonText:setString("Toggle Analytics: CURRENTLY ON")
    else
        Ob.rAnalyticsButtonText:setString("Toggle Analytics: CURRENTLY OFF")        
    end
    Ob.rAnalyticsButtonText:setRect(-300, -30, 300, 30)
	Ob.rAnalyticsButtonText:setColor(255, 255, 255)    
    Ob.rAnalyticsButtonText:setLoc(0, -410)
    Ob:addElement(Ob.rAnalyticsButtonText)

    -- the shop button
	Ob.rCloseButton = MOAIProp2D.new()
	Ob.rCloseButton:setDeck(g_GUI:GetGreenButtonDeck())
    Ob.rCloseButton:setScl(0.4, 0.9)
	Ob.rCloseButton:setLoc(0, -490)
	Ob.rCloseButton:setColor(kDEFAULT_MMOPTION_COLORS.r, kDEFAULT_MMOPTION_COLORS.g, kDEFAULT_MMOPTION_COLORS.b)
    Ob:addElement(Ob.rCloseButton)

    Ob.rCloseButtonText = g_GUI:CreateTextBox(20, MOAITextBox.CENTER_JUSTIFY)
    Ob.rCloseButtonText:setString("Close")
    Ob.rCloseButtonText:setRect(-100, -30, 100, 30)
	Ob.rCloseButtonText:setColor(255, 255, 255)    
    Ob.rCloseButtonText:setLoc(0, -500)
    Ob:addElement(Ob.rCloseButtonText)

	function Ob:setVisible(bVisible)
		if not self.rRenderLayer then
			return
		end
		if bVisible then
			for i, rElement in ipairs(self.tElements) do
				self.rRenderLayer:insertProp(rElement)
			end
		else
			for i, rElement in ipairs(self.tElements) do
				self.rRenderLayer:removeProp(rElement)
			end
		end
	end

	function Ob:onFinger(eventType, sx, sy)
		local tLayer = Renderer.getLayer("UI")
		local x, y = tLayer.RenderLayer:wndToWorld(sx, sy)			
        local tProps = { tLayer.Partition:propListForPoint(x, y) }
		if #tProps then
            if eventType == MOAITouchSensor.TOUCH_UP then
                for i, rProp in ipairs(tProps) do
                    if rProp == self.rResetSaveButtonText then
                        g_Game:clearSaveGame()
                        g_bDisableAutoSave = true                        
                    elseif rProp == self.rCloseButton then
                        g_GUI:SetActivePane(nil)
                    elseif rProp == self.rAddCashButtonText then 
                        local cheatAmount = 200
                        g_Game:addCash(cheatAmount)
                        DFAnalytics.incrStat('csh_ernd_chet', cheatAmount)
                    elseif rProp == self.rAddPPButton then
                        local cheatAmount = 5
                        g_Game:addPP(cheatAmount)
                        DFAnalytics.logEvent("ppp_ernd", { type = "chet", amount = cheatAmount }) 
                        DFAnalytics.incrStat('ppp_ernd_chet', cheatAmount)
                    elseif rProp == self.rDebugDisplayButton then
                        g_Game:toggleDebug()
                        g_GUI:HideMMMenu()
                    elseif rProp == self.rDebugAbilityButton then
                        Ability.bDebugUnlockAbilities = true
                    elseif rProp == self.rAnalyticsButton then
                        if DFAnalytics.initialized then
                            DFAnalytics.shutdown()
                            self.rAnalyticsButtonText:setString("Toggle Analytics: CURRENTLY OFF")
                        else
                            DFAnalytics.init("nathandf", "26bb8c442c2148e2067bf861a1f38535", "7Gj3q02g38FAsEB7KtTViAjxKDoMh8uU") -- won't even init the non test analytics
                            self.rAnalyticsButtonText:setString("Toggle Analytics: CURRENTLY ON")
                        end
                    end
                end
            end
        else
            g_GUI:HideMMMenu()
            return true           
		end
		return true
	end
    
    return Ob
end

return MiddleManagerUI