local NoCurrencyConfirmUI = {}
local SimpleConfirmScreenUI = require('ui/SimpleConfirmScreenUI')
local UIElement = require('ui/UIElement')
local DFAnalytics = require('DFCommon.Analytics')

local tUITextureSpriteSheetInfo =
{
    popup_mm = 'UI/shopheropack'
}

function NoCurrencyConfirmUI:new(rRenderLayer, sMessageText, rParentUI, sYesText, sNoText)
    local Ob = SimpleConfirmScreenUI:new(rRenderLayer, nil, rParentUI, sYesText, sNoText)

    function Ob:onYesPressed()
        if self.rParentUI then
            self.rParentUI:onYesPressed()
        end
        DFAnalytics.logEvent("beg_yes")
    end

    function Ob:onNoPressed()
        if self.rParentUI then
            self.rParentUI:onNoPressed()
        end
        DFAnalytics.logEvent("beg_no")
    end

    Ob:loadUISpriteSheets(tUITextureSpriteSheetInfo)

    Ob.rInsuffTextBox = g_GUI:CreateTextBox(60, MOAITextBox.CENTER_JUSTIFY, 'boogaloo')
	Ob.rInsuffTextBox:setRect(-130, 300, 130, 0)
    Ob.rInsuffTextBox:setString(sMessageText)
	Ob.rInsuffTextBox:setLoc(200, -30)
	Ob:addElement(Ob.rInsuffTextBox)

    Ob.rMM = Ob:getUITextureProp('popup_mm')
    Ob.rMM:setLoc(324, -10)
    Ob:addElement(Ob.rMM)
    
    DFAnalytics.logEvent("beg_appr")

    return Ob
end

return NoCurrencyConfirmUI