local PostIt = {}
local UIElement = require('ui/UIElement')

local tUITextureSpriteSheetInfo =
{
    popup = 'UI/shopheropack',
}

local kPOSTIT_X_SIZE = 512
local kPOSTIT_Y_SIZE = 410

function PostIt:new(rRenderLayer, sMessageText)
    local Ob = UIElement:new(rRenderLayer)

    function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
    end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()
    end

    function Ob:setHideWhenTapped(bSet)
        self.bHideWhenTapped = bSet
    end

    function Ob:shouldHideWhenTapped()
        return self.bHideWhenTapped
    end

    function Ob:setBlockInputUntilTapped(bBlockInputUntilTapped)
        self.bBlockInputUntilTapped = bBlockInputUntilTapped
    end

    function Ob:shouldBlockInputUntilTapped()
        return self.bBlockInputUntilTapped
    end

    function Ob:onFinger()
        return true
    end

    Ob:loadUISpriteSheets(tUITextureSpriteSheetInfo)

    Ob.rBackground = Ob:getUITextureProp('popup')
    Ob.rBackground:setScl(1.1)
	Ob:addElement(Ob.rBackground)

    Ob.rTextBox = g_GUI:CreateTextBox(20, MOAITextBox.LEFT_JUSTIFY)
    Ob.rTextBox:setRect(0, 300, 260, 0)
    Ob.rTextBox:setString(sMessageText)
    Ob.rTextBox:setLoc(50, -10)
    Ob:addElement(Ob.rTextBox)

    Ob.bHideWhenTapped = false
    Ob.bBlockInputUntilTapped = false

    return Ob
end

return PostIt