local Renderer = require('Renderer')
local UIElement = require('ui/UIElement')
local util = require('DFUtil')
local ResumeUI = {}

function ResumeUI:new(rRenderLayer, rHero)
    local Ob = UIElement:new(rRenderLayer)

	function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
    end

    if not rHero then
        return Ob
    end

    local rDef = rHero:getDef()
    
    if not rDef then
        return Ob
    end

    local tResumeInfo = rDef.tResumeInfo

    if not rDef then
        return Ob
    end

    Ob.rBackground = MOAIProp2D.new()
	Ob.rBackground:setDeck(g_GUI:GetOnePixelDeck())
	Ob.rBackground:setLoc(0, 0)    
    Ob.rBackground:setScl(550, Renderer.getUIHeight() - 22)
	Ob.rBackground:setColor(1, 1, 1)
    Ob:addElement(Ob.rBackground)   

    Ob.rNameText = g_GUI:CreateTextBox(30, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rNameText:setString("Resume: " .. g_DialogManager:getString(rHero:getName())) 
    Ob.rNameText:setRect(0, 80, 400, 0)
    Ob.rNameText:setLoc(48, -20)
    Ob:addElement(Ob.rNameText)

    Ob.rLine1 = MOAIProp2D.new()
    Ob.rLine1:setDeck(g_GUI:GetOnePixelDeck())
    Ob.rLine1:setLoc(48, -60)
    Ob.rLine1:setScl(450, 3)
    Ob.rLine1:setColor(0, 0, 0)
    Ob:addElement(Ob.rLine1)

    Ob.rObjectiveLabelText = g_GUI:CreateTextBox(18, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rObjectiveLabelText:setString(g_DialogManager:getString("STXT111TEXT"))
    Ob.rObjectiveLabelText:setRect(0, 80, 300, 0)
    Ob.rObjectiveLabelText:setLoc(48, -64)
    Ob:addElement(Ob.rObjectiveLabelText)

    Ob.rObjectiveText = g_GUI:CreateTextBox(20, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rObjectiveText:setString(g_DialogManager:getString(tResumeInfo.sObjective))
    Ob.rObjectiveText:setRect(0, 300, 350, 0)
    Ob.rObjectiveText:setLoc(150, -64)
    Ob:addElement(Ob.rObjectiveText)

    Ob.rLine2 = MOAIProp2D.new()
    Ob.rLine2:setDeck(g_GUI:GetOnePixelDeck())
    Ob.rLine2:setLoc(48, -150)
    Ob.rLine2:setScl(450, 3)
    Ob.rLine2:setColor(0, 0, 0)
    Ob:addElement(Ob.rLine2)

    Ob.rObjectiveLabelText = g_GUI:CreateTextBox(18, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rObjectiveLabelText:setString(g_DialogManager:getString("STXT112TEXT"))
    Ob.rObjectiveLabelText:setRect(0, 80, 300, 0)
    Ob.rObjectiveLabelText:setLoc(48, -154)
    Ob:addElement(Ob.rObjectiveLabelText)

    Ob.rObjectiveText = g_GUI:CreateTextBox(20, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rObjectiveText:setString(g_DialogManager:getString(tResumeInfo.sBackground))
    Ob.rObjectiveText:setRect(0, 300, 350, 0)
    Ob.rObjectiveText:setLoc(150, -154)
    Ob:addElement(Ob.rObjectiveText)

    Ob.rLine3 = MOAIProp2D.new()
    Ob.rLine3:setDeck(g_GUI:GetOnePixelDeck())
    Ob.rLine3:setLoc(48, -320)
    Ob.rLine3:setScl(450, 3)
    Ob.rLine3:setColor(0, 0, 0)
    Ob:addElement(Ob.rLine3)

    Ob.rWorkExpLabelText = g_GUI:CreateTextBox(18, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rWorkExpLabelText:setString(g_DialogManager:getString("STXT113TEXT"))
    Ob.rWorkExpLabelText:setRect(0, 80, 300, 0)
    Ob.rWorkExpLabelText:setLoc(48, -324)
    Ob:addElement(Ob.rWorkExpLabelText)

    Ob.rWorkExp1Text = g_GUI:CreateTextBox(20, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rWorkExp1Text:setString(g_DialogManager:getString(tResumeInfo.sWorkExpText1))
    Ob.rWorkExp1Text:setRect(0, 300, 350, 0)
    Ob.rWorkExp1Text:setLoc(60, -349)
    Ob:addElement(Ob.rWorkExp1Text)

    Ob.rWorkDate1Text = g_GUI:CreateTextBox(20, MOAITextBox.RIGHT_JUSTIFY, 'ptsans')
    Ob.rWorkDate1Text:setString(g_DialogManager:getString(tResumeInfo.sWorkExpDate1))
    Ob.rWorkDate1Text:setRect(0, 300, 436, 0)
    Ob.rWorkDate1Text:setLoc(60, -349)
    Ob:addElement(Ob.rWorkDate1Text)

    Ob.rWorkExp2Text = g_GUI:CreateTextBox(20, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rWorkExp2Text:setString(g_DialogManager:getString(tResumeInfo.sWorkExpText2))
    Ob.rWorkExp2Text:setRect(0, 300, 350, 0)
    Ob.rWorkExp2Text:setLoc(60, -375)
    Ob:addElement(Ob.rWorkExp2Text)

    Ob.rWorkDate2Text = g_GUI:CreateTextBox(20, MOAITextBox.RIGHT_JUSTIFY, 'ptsans')
    Ob.rWorkDate2Text:setString(g_DialogManager:getString(tResumeInfo.sWorkExpDate2))
    Ob.rWorkDate2Text:setRect(0, 300, 436, 0)
    Ob.rWorkDate2Text:setLoc(60, -375)
    Ob:addElement(Ob.rWorkDate2Text)

    Ob.rLine4 = MOAIProp2D.new()
    Ob.rLine4:setDeck(g_GUI:GetOnePixelDeck())
    Ob.rLine4:setLoc(48, -424)
    Ob.rLine4:setScl(450, 3)
    Ob.rLine4:setColor(0, 0, 0)
    Ob:addElement(Ob.rLine4)

    Ob.rSkillsLabelText = g_GUI:CreateTextBox(18, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rSkillsLabelText:setString(g_DialogManager:getString("STXT114TEXT"))
    Ob.rSkillsLabelText:setRect(0, 80, 300, 0)
    Ob.rSkillsLabelText:setLoc(48, -428)
    Ob:addElement(Ob.rSkillsLabelText)

    local sSkillsText = ""
    local nItems = util.countitems(rHero:getAbilities())
    local nNum = 0
    for i, rAbility in pairs(rHero:getAbilities()) do
        nNum = nNum + 1
        if rAbility:showInUI() then
            sSkillsText = sSkillsText..rAbility:getName().." (Level "..rAbility:getCurLevel()..")"
            if nNum < nItems then
                sSkillsText = sSkillsText..", "
            end
        end
    end

    Ob.rSkillsText = g_GUI:CreateTextBox(20, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rSkillsText:setString(sSkillsText)
    Ob.rSkillsText:setRect(0, 300, 440, 0)
    Ob.rSkillsText:setLoc(60, -455)
    Ob:addElement(Ob.rSkillsText)

    Ob.rLine4 = MOAIProp2D.new()
    Ob.rLine4:setDeck(g_GUI:GetOnePixelDeck())
    Ob.rLine4:setLoc(48, -524)
    Ob.rLine4:setScl(450, 3)
    Ob.rLine4:setColor(0, 0, 0)
    Ob:addElement(Ob.rLine4)

    Ob.rReferencesLabelText = g_GUI:CreateTextBox(18, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rReferencesLabelText:setString(g_DialogManager:getString("STXT115TEXT"))
    Ob.rReferencesLabelText:setRect(0, 80, 300, 0)
    Ob.rReferencesLabelText:setLoc(48, -528)
    Ob:addElement(Ob.rReferencesLabelText)

    Ob.rReferencesText = g_GUI:CreateTextBox(20, MOAITextBox.LEFT_JUSTIFY, 'ptsans')
    Ob.rReferencesText:setString(g_DialogManager:getString(tResumeInfo.sReferences))
    Ob.rReferencesText:setRect(0, 300, 440, 0)
    Ob.rReferencesText:setLoc(60, -555)
    Ob:addElement(Ob.rReferencesText)

    return Ob
end

return ResumeUI