local Button = require('ui/Button')
local NoCurrencyConfirmUI = require('ui/NoCurrencyConfirmUI')
local Renderer = require('Renderer')
local ShopButton = {}

function ShopButton:new(rRenderLayer, rParentUI, tSpriteSheetInfo, sButtonTexture, sButtonPressedTexture, tButtonColor, tPressedButtonColor, bYFlip, tPressedOffsetLoc, sButtonText, sButtonTextFont, nTextSize, tButtonTextOffset, tButtonTextColor, tPressedButtonTextColor, nCashCost, nPPCost, tNoAffordColor, tNoAffordTextColor, nMMReqLevel, tMMReqColor, tMMReqTextColor)
    local Ob = Button:new(rRenderLayer, rParentUI, tSpriteSheetInfo, sButtonTexture, sButtonPressedTexture, tButtonColor, tPressedButtonColor, bYFlip, tPressedOffsetLoc, sButtonText, sButtonTextFont, nTextSize, tButtonTextOffset, tButtonTextColor, tPressedButtonTextColor, nCashCost, nPPCost, tNoAffordColor)

    function Ob:pressedCallback(bPressed)
        -- check
        if not bPressed then
            if self.nPPCost then
                if not self.bCanAfford then
                    local rCurrencyHelpPane = NoCurrencyConfirmUI:new(Renderer.getRenderLayer('UIOverlay'), g_DialogManager:getString("STXT107TEXT"), self, "STXT108TEXT", "STXT109TEXT")
                    rCurrencyHelpPane:setLoc(240, -160)
                    g_GUI:SetPopupPane(rCurrencyHelpPane)
                end
            elseif self.nCashCost then
                if not self.bCanAfford then
                    local rCurrencyHelpPane = NoCurrencyConfirmUI:new(Renderer.getRenderLayer('UIOverlay'), g_DialogManager:getString("STXT110TEXT"), self, "STXT108TEXT", "STXT109TEXT")
                    rCurrencyHelpPane:setLoc(240, -160)
                    g_GUI:SetPopupPane(rCurrencyHelpPane)
                end
            end
        end
    end

    function Ob:onYesPressed()
        g_GUI:SetPopupPane(nil)
        if self.nCashCost then
            g_GUI:ShowCurrencyUI()
        else
            g_GUI:ShowRMTUI()
        end
    end

    function Ob:onNoPressed()
        g_GUI:SetPopupPane(nil)
    end

    function Ob:update()
        -- check price      
        self.bCanAfford = true
        self.bMMLvlMet = true
        
        if self.nMMReqLevel then
            if g_MiddleManager:getStarRatingLevel() >= self.nMMReqLevel then
                self.bMMLvlMet = true
            else
                self.bMMLvlMet = false
            end
        end

        if self.bMMLvlMet then
            self.rButtonText:revealAll()
            if self.nCashCost or self.nPPCost then
                if self.nCashCost then
                    if g_Game:getCurCash() >= self.nCashCost then
                        self.bCanAfford = true
                    else
                        self.bCanAfford = false
                    end
                elseif self.nPPCost then
                    if g_Game:getCurPP() >= self.nPPCost then
                        self.bCanAfford = true
                    else
                        self.bCanAfford = false
                    end
                end
                if self.bCanAfford then
                    if self.tButtonColor then
                        self.rButton:setColor(self.tButtonColor[1], self.tButtonColor[2], self.tButtonColor[3])
                    else
                        self.rButton:setColor(1, 1, 1)
                    end
                    if self.tNoAffordTextColor then
                        if self.tButtonTextColor then
                            self.rButtonText:setColor(self.tButtonTextColor[1], self.tButtonTextColor[2], self.tButtonTextColor[3])
                        else
                            self.rButtonText:setColor(1, 1, 1)
                        end
                    end
                else
                    if self.tNoAffordColor then
                        self.rButton:setColor(self.tNoAffordColor[1], self.tNoAffordColor[2], self.tNoAffordColor[3], self.tNoAffordColor[4])
                    end
                    if self.tNoAffordTextColor then
                        self.rButtonText:setColor(self.tNoAffordTextColor[1], self.tNoAffordTextColor[2], self.tNoAffordTextColor[3])
                    end
                end
            end
        else
            if self.nMMReqLevel then
                self.rMMReqText:setString(g_DialogManager:getString("STXT082TEXT"))
                if self.tMMReqTextColor then
                    self.rMMReqText:setColor(self.tMMReqTextColor[1], self.tMMReqTextColor[2], self.tMMReqTextColor[3])
                end
            end

            if self.tMMReqColor then
                self.rButton:setColor(self.tMMReqColor[1], self.tMMReqColor[2], self.tMMReqColor[3])
            end
            if self.rMMReqText then
                self.rMMReqText:revealAll()             
            end
            self.rButtonText:setReveal(0)
        end
    end

    Ob.nCashCost = nCashCost
    Ob.nPPCost = nPPCost
    Ob.tNoAffordColor = tNoAffordColor
    Ob.tNoAffordTextColor = tNoAffordTextColor
    Ob.nMMReqLevel = nMMReqLevel
    Ob.tMMReqColor = tMMReqColor
    Ob.tMMReqTextColor = tMMReqTextColor

    Ob.bCanAfford = true
    Ob.bMMLvlMet = true

    return Ob
end

return ShopButton