local SimpleConfirmScreenUI = {}
local UIElement = require('ui/UIElement')
local Button = require('ui/Button')

local tUITextureSpriteSheetInfo =
{
    popup_button = 'UI/shopheropack',
    popup = 'UI/shopheropack',
}

function SimpleConfirmScreenUI:new(rRenderLayer, sMessageText, rParentUI, sYesText, sNoText)
    local Ob = UIElement:new(rRenderLayer)

    function Ob:setVisible(bVisible)
        self:setElementsVisible(bVisible)
        self.rYesButton:setVisible(bVisible)
        if self.rNoButton then
            self.rNoButton:setVisible(bVisible)
        end
        if bVisible then
            g_Audio:playCue('MMOJ_Audio/UI/PostIt')
        end
    end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()
        self.rYesButton:onPaneClosed()
        if self.rNoButton then
            self.rNoButton:onPaneClosed()
        end
    end

    function Ob:onButtonJustPressed(rButton)
        if rButton == self.rYesButton then
            if rParentUI.onYesPressed then
                g_Audio:playCue('MMOJ_Audio/UI/CategorySelect')
                rParentUI:onYesPressed(self) 
            end
        elseif rButton == self.rNoButton then
            if rParentUI.onNoPressed then
                g_Audio:playCue('MMOJ_Audio/UI/BackButton')
                rParentUI:onNoPressed(self) 
            end
        end
    end

	function Ob:onFinger(eventType, sx, sy, tProps)
        if self.rYesButton then
            self.rYesButton:onFinger(eventType, sx, sy, tProps)
        end
        if self.rNoButton then
            self.rNoButton:onFinger(eventType, sx, sy, tProps)
        end
		return true
	end    

    Ob:loadUISpriteSheets(tUITextureSpriteSheetInfo)

    Ob.rBackground = Ob:getUITextureProp('popup')
    Ob.rBackground:setScl(1.61)
	Ob:addElement(Ob.rBackground)

    if sMessageText then
        Ob.rTextBox = g_GUI:CreateTextBox(24, MOAITextBox.LEFT_JUSTIFY)
        Ob.rTextBox:setRect(0, 300, 400, 0)
        Ob.rTextBox:setString(sMessageText)
        Ob.rTextBox:setLoc(60, -40)
        Ob:addElement(Ob.rTextBox)
    end

    Ob.rYesButton = Button:new(rRenderLayer, Ob, tUITextureSpriteSheetInfo, 'popup_button', nil, { 1, 1, 1 }, { 0.5, 0.5, 0.5 }, false, nil, sYesText, 'default', 22, { 50, -5 }, { 0, 0, 0 })    
    Ob.rYesButton:setLoc(180, -260)
    Ob.rYesButton:setScl(1.6)
    Ob.rYesButton:setParent(Ob)

    if sNoText then
        Ob.rYesButton:setLoc(70, -260)

        Ob.rNoButton = Button:new(rRenderLayer, Ob, tUITextureSpriteSheetInfo, 'popup_button', nil, { 1, 1, 1 }, { 0.5, 0.5, 0.5 }, false, nil, sNoText, 'default', 22, { 50, -5 }, { 0, 0, 0 })    
        Ob.rNoButton:setLoc(284, -260)
        Ob.rNoButton:setScl(1.6)
        Ob.rNoButton:setParent(Ob)
    end

    return Ob
end

return SimpleConfirmScreenUI