local UIElement = require('ui/UIElement')

local StatHelpScreen = {}

local tUITextureSpriteSheetInfo =
{
    popup_help = 'UI/hud3',
}

function StatHelpScreen:new(rRenderLayer)
	local Ob = UIElement:new(rRenderLayer)

	function Ob:setVisible(bVisible)
        self.bVisible = bVisible
        self:setElementsVisible(bVisible)
    end

    function Ob:isVisible()
        return self.bVisible
    end

    function Ob:onPaneClosed()
        self:unloadUISpriteSheets()
    end

    Ob:loadUISpriteSheets(tUITextureSpriteSheetInfo)
    
    Ob.rBackground = Ob:getUITextureProp('popup_help')
    Ob.rBackground:setLoc(0, 0)
    Ob:addElement(Ob.rBackground)    

	Ob.rStatPowerText = g_GUI:CreateTextBox(30, MOAITextBox.LEFT_JUSTIFY, 'type')
	Ob.rStatPowerText:setString(g_DialogManager:getString("STXT036TEXT"))
	Ob.rStatPowerText:setLoc(400, -16)
    Ob:addElement(Ob.rStatPowerText)

	Ob.rStatPowerDescription = g_GUI:CreateTextBox(18, MOAITextBox.LEFT_JUSTIFY, 'type')
	Ob.rStatPowerDescription:setString(g_DialogManager:getString("STXT040TEXT"))
    Ob.rStatPowerDescription:setRect(0, 100, 280, 0)
	Ob.rStatPowerDescription:setLoc(100, -50)
    Ob:addElement(Ob.rStatPowerDescription)

	Ob.rStatHealthText = g_GUI:CreateTextBox(30, MOAITextBox.LEFT_JUSTIFY, 'type')
	Ob.rStatHealthText:setString(g_DialogManager:getString("STXT037TEXT"))
	Ob.rStatHealthText:setLoc(400, -110)
    Ob:addElement(Ob.rStatHealthText)

	Ob.rStatHealthDescription = g_GUI:CreateTextBox(18, MOAITextBox.LEFT_JUSTIFY, 'type')
	Ob.rStatHealthDescription:setString(g_DialogManager:getString("STXT041TEXT"))
    Ob.rStatHealthDescription:setRect(0, 100, 280, 0)
	Ob.rStatHealthDescription:setLoc(100, -144)
    Ob:addElement(Ob.rStatHealthDescription)

	Ob.rStatShieldText = g_GUI:CreateTextBox(30, MOAITextBox.LEFT_JUSTIFY, 'type')
	Ob.rStatShieldText:setString(g_DialogManager:getString("STXT038TEXT"))
	Ob.rStatShieldText:setLoc(400, -206)
    Ob:addElement(Ob.rStatShieldText)

	Ob.rStatShieldDescription = g_GUI:CreateTextBox(18, MOAITextBox.LEFT_JUSTIFY, 'type')
	Ob.rStatShieldDescription:setString(g_DialogManager:getString("STXT042TEXT"))
    Ob.rStatShieldDescription:setRect(0, 100, 280, 0)
	Ob.rStatShieldDescription:setLoc(100, -240)
    Ob:addElement(Ob.rStatShieldDescription)

	Ob.rStatAwarenessText = g_GUI:CreateTextBox(30, MOAITextBox.LEFT_JUSTIFY, 'type')
	Ob.rStatAwarenessText:setString(g_DialogManager:getString("STXT039TEXT"))
	Ob.rStatAwarenessText:setLoc(400, -300)
    Ob:addElement(Ob.rStatAwarenessText)

	Ob.rStatAwarenessDescription = g_GUI:CreateTextBox(18, MOAITextBox.LEFT_JUSTIFY, 'type')
	Ob.rStatAwarenessDescription:setString(g_DialogManager:getString("STXT043TEXT"))
    Ob.rStatAwarenessDescription:setRect(0, 100, 280, 0)
	Ob.rStatAwarenessDescription:setLoc(100, -336)
    Ob:addElement(Ob.rStatAwarenessDescription)
    
    Ob.rStatMoraleText = g_GUI:CreateTextBox(30, MOAITextBox.LEFT_JUSTIFY, 'type')
	Ob.rStatMoraleText:setString(g_DialogManager:getString("STXT134TEXT"))
	Ob.rStatMoraleText:setLoc(400, -396)
    Ob:addElement(Ob.rStatMoraleText)

	Ob.rStatMoraleDescription = g_GUI:CreateTextBox(18, MOAITextBox.LEFT_JUSTIFY, 'type')
	Ob.rStatMoraleDescription:setString(g_DialogManager:getString("STXT135TEXT"))
    Ob.rStatMoraleDescription:setRect(0, 100, 280, 0)
	Ob.rStatMoraleDescription:setLoc(100, -430)
    Ob:addElement(Ob.rStatMoraleDescription)

    return Ob
end

return StatHelpScreen