local tDefaultRewards =
        {
            {
                nPossibility = 10,
                rDef =
                {
                    type = 'pp',
                    amountRange = { 1, 1 },
                },
            },        
            {
                nPossibility = 20,
                rDef =
                {
                    type = 'consumable',
                    sItemDefKey = 'strengthpotion3',
                },
            },
            {
                nPossibility = 30,
                rDef =
                {
                    type = 'consumable',
                    sItemDefKey = 'strengthpotion2',
                },
            },
            {
                nPossibility = 40,
                rDef =
                {
                    type = 'consumable',
                    sItemDefKey = 'manalvl1',
                },
            },
            {
                nPossibility = 50,
                rDef =
                {
                    type = 'consumable',
                    sItemDefKey = 'healthlvl1',
                },
            },
            {
                nPossibility = 60,
                rDef =
                {
                    type = 'consumable',
                    sItemDefKey = 'healthlvl2',
                },
            },
            {
                nPossibility = 80,
                rDef =
                {
                    type = 'cash',
                    amountRange = { 200, 200 },
                },
            },             
            {
                nPossibility = 100,
                rDef =
                {
                    type = 'cash',
                    amountRange = { 100, 100 },
                },
            },
        }

local tDefs = 
{
    -- Crime Reduction Todo Items
    BranchRating =
    {
        type = 'RatingTodoItem',
        bCanRepeat = true,
        nRatingAmount = 500,   
        uiLineCode = 'STXT150TEXT',
        tPossibleRewards = tDefaultRewards,
    },
    CompleteCrimeEvents =
    {
        type = 'CompleteEventTodoItem',
        sEventType = 'crime',
        nNumToComplete = 5,
        uiLineCode = 'STXT150TEXT',
        tPossibleRewards = tDefaultRewards,
    },    
    CompleteFireEvents =
    {
        type = 'CompleteEventTodoItem',
        sEventType = 'fire',
        nNumToComplete = 3,
        tPossibleRewards = tDefaultRewards,
        nReqTerritoryUnlockLevel = 4,
    },
    CompleteBusEvents =
    {
        type = 'CompleteEventTodoItem',
        sEventType = 'busrescue',
        nNumToComplete = 3,
        tPossibleRewards = tDefaultRewards,
        nReqTerritoryUnlockLevel = 3,
    }, 
    CollectCoinsFromNeighborhoods =
    {
        type = 'CollectCoinsTodoItem',
        sEventType = 'crime',
        nNumToComplete = 100,
        uiLineCode1 = 'TODO010TEXT',
        uiLineCode2 = 'TODO011TEXT',
        tPossibleRewards = tDefaultRewards,
    },
    MakeOneHoodHappy =
    {
        type = 'HoodMoraleTodoItem',
        nNumToComplete = 1,
        uiLineCode1 = 'TODO014TEXT',
        uiLineCode2 = 'TODO015TEXT',
        uiLineCode3 = 'TODO028TEXT',
        tPossibleRewards = tDefaultRewards,
    },    
    MakeTwoHoodsHappy =
    {
        type = 'HoodMorale',
        sEventType = 'happyhood',
        nNumToComplete = 2,
        uiLineCode1 = 'TODO014TEXT',
        uiLineCode2 = 'TODO015TEXT',
        uiLineCode3 = 'TODO028TEXT',
        tPossibleRewards = tDefaultRewards,
    },  
    
    -- Upgrade Office/Manager Todo Items
    UpgradeHub = 
    {
        type = 'HubUpgradeTodoItem',
        bCanRepeat = true,
        uiLineCode = "TODO009TEXT",
        tPossibleRewards = tDefaultRewards,
    },    
    AddRoom =
    {
        type = 'AddRoomTodoItem',
        bCanRepeat = true,
        uiLineCode = "TODO008TEXT",
        tPossibleRewards = tDefaultRewards,
    },
    UpgradeRoom =
    {
        type = 'UpgradeRoomTodoItem',
        bCanRepeat = true,
        uiLineCode = "TODO007TEXT",
        tPossibleRewards = tDefaultRewards,
    },
    UpgradeProp =
    {
        type = 'UpgradePropTodoItem',
        bCanRepeat = true,
        uiLineCode = "TODO035TEXT",
        tPossibleRewards = tDefaultRewards,
    },
    AddProp =
    {
        type = 'AddPropTodoItem',
        bCanRepeat = true,
        uiLineCode = "TODO006TEXT",
        tPossibleRewards = tDefaultRewards,
    },
    DelegateEvent =
    {
        type = 'DelegateEventTodoItem',
        bCanRepeat = true,
        nNumToComplete = 3,
        uiLineCode1 = "TODO023TEXT",
        uiLineCode2 = "TODO030TEXT",
        uiLineCode3 = "TODO029TEXT",
        tPossibleRewards = tDefaultRewards,
    },  
    
    -- Upgrade Hero/Combat Todo Items
    BuyFiveSnacks =
    {
        type = 'BuyItemTodoItem',
        sItemType = 'Snack',
        bCanRepeat = true,
        nNumToComplete = 3,
        uiLineCode1 = "TODO016TEXT",
        uiLineCode2 = "TODO017TEXT",
        tPossibleRewards = tDefaultRewards,
    },   
    BuyThreeEquipments =
    {
        type = 'BuyItemTodoItem',
        sItemType = 'Equipment',
        bCanRepeat = true,
        nNumToComplete = 3,
        uiLineCode1 = "TODO016TEXT",
        uiLineCode2 = "TODO034TEXT",
        tPossibleRewards = tDefaultRewards,
    },  
    BuyOneCostume =
    {
        type = 'BuyItemTodoItem',
        sItemType = 'Costume',
        bCanRepeat = true,
        nNumToComplete = 1,
        uiLineCode1 = "TODO016TEXT",
        uiLineCode2 = "TODO019TEXT",
        nMinHeroLevel = 5,
        tPossibleRewards = tDefaultRewards,
    },  
    TrainHeroThreeTimes =
    {
        type = 'TrainHeroTodoItem',
        bCanRepeat = true,
        nNumToComplete = 3,
        uiLineCode1 = "TODO020TEXT",
        uiLineCode2 = "TODO032TEXT",
        tPossibleRewards = tDefaultRewards,
    }, 
    LevelHeroFive =
    {
        type = 'LevelHeroTodoItem',
        bCanRepeat = true,
        nNumToComplete = 5,
        uiLineCode = "TODO022TEXT",
        tPossibleRewards = tDefaultRewards,
        nMinHeroLevel = 4,
    }, 
    LevelHeroTen =
    {
        type = 'LevelHeroTodoItem',
        bCanRepeat = true,
        nNumToComplete = 10,
        uiLineCode = "TODO022TEXT",
        tPossibleRewards = tDefaultRewards,
        nMinHeroLevel = 8,
    }, 
    ResearchTenEquipment =
    {
        type = 'ResearchTodoItem',
        sItemType = 'Equipment',
        bCanRepeat = false,
        nNumToComplete = 1,
        uiLineCode1 = 'TODO033TEXT',
        uiLineCode2 = 'TODO031TEXT',
        tPossibleRewards = tDefaultRewards,
    }, 
    ResearchTenSnack =
    {
        type = 'ResearchTodoItem',
        sItemType = 'Snack',
        bCanRepeat = false,
        nNumToComplete = 1,
        uiLineCode1 = 'TODO033TEXT',
        uiLineCode2 = 'TODO036TEXT',
        tPossibleRewards = tDefaultRewards,
    },
}

local tList =
{
    'BranchRating',
    'CompleteCrimeEvents',
    'CompleteFireEvents',
    'CompleteBusEvents',
    'UpgradeHub',
    'AddRoom',
    'UpgradeRoom',
    'UpgradeProp',
    'AddProp',
    'CollectCoinsFromNeighborhoods',
    'MakeOneHoodHappy',
    'MakeTwoHoodsHappy',
    'DelegateEvent',
    'BuyFiveSnacks',
    'BuyThreeEquipments',
    'BuyOneCostume',
    'TrainHeroThreeTimes',
    'LevelHeroFive',
    'LevelHeroTen',   
    'ResearchTenEquipment',
    'ResearchTenSnack',
}

return
{
    tList = tList,
    tDefs = tDefs,
}